Option Explicit
Option Compare Text
DefInt A-Z

Sub ascii_export ()
    
    timerform.CMDialog1.DialogTitle = "ASCII File Export For " + CNCFrmDat(CnCFrmNo).name
    timerform.CMDialog1.DefaultExt = "TXT"
    timerform.CMDialog1.Filter = "ASCII|*.txt"
    timerform.CMDialog1.Filename = ""
    timerform.CMDialog1.Flags = &H4& Or &H2& Or &H800&
    On Local Error GoTo cancel_export
    timerform.CMDialog1.Action = 2
    On Local Error GoTo 0
    
    screen.MousePointer = 11    'busy
    outhandle = FreeFile
    Open timerform.CMDialog1.Filename For Output As outhandle
    CNCfrm(CnCFrmNo).EditFunc.Caption = "Export"
    Close outhandle
    screen.MousePointer = 0

cancel_export:
    Exit Sub

End Sub

Function Calsum (EditFrm As Integer) As Long

Dim Lcalib As LatheCalibType
Dim tmp As Long
Dim i As Integer

tmp = 0

            ReadLatheCalib EditFrm, Lcalib
            For i = 1 To 3
                tmp = tmp + Lcalib.Tool_x(i)
                tmp = tmp + Lcalib.Tool_z(i)
            Next
Calsum = tmp

End Function

Sub exe_CNC (UseZ As Integer)

Dim robotcntrl  As robotCNTRLtype
Dim i As Integer
    
    If CNCFrmDat(CnCFrmNo).Filename = "" Then CNCfrm(CnCFrmNo).Tag = byhand
    
    
    If EditFrmdat(CNCFrmDat(CnCFrmNo).DevNo).Exe_Handle <> 0 Then
        Close EditFrmdat(CNCFrmDat(CnCFrmNo).DevNo).Exe_Handle
        EditFrmdat(CNCFrmDat(CnCFrmNo).DevNo).Exe_Handle = 0
    End If
    
    'EditFrmdat(EditFrm).Exe_Handle = 0
    
    
    
    Select Case CNCfrm(CnCFrmNo).Tag
    Case virgin
       'If Not loadcnc() Then Exit Sub
    Case byhand
        i = savegrid(True)
    End Select
    
    If CNCFrmDat(CnCFrmNo).Filename = "" Then Exit Sub
    
    READDATA CNCFrmDat(CnCFrmNo).DevNo, robotcntrl
    
    'robotcntrl.online = 1
    Select Case robotcntrl.online
    Case 0, 2     'not connected/offline
        Select Case CNCFrmDat(CnCFrmNo).DevType
        Case CNCMill
            MillGraph.WindowState = 0
            MillGraph.SetFocus
            MillGraph.EditFunc.Caption = "Exe"
        Case CNCLathe
            LatheGraph.WindowState = 0
            LatheGraph.SetFocus
            LatheGraph.EditFunc.Caption = "Exe"
        End Select
    
    Case 1      'currently online
        If (robotcntrl.Inpos And 1) = 1 Then
            MsgBox CNCFrmDat(CnCFrmNo).name + " is already Executing"
        Else
            Select Case CNCFrmDat(CnCFrmNo).DevType
            Case CNCMill
                If SendMillCmp(CNCFrmDat(CnCFrmNo).DevNo, UseZ) Then                   'Start execution
                    Millmanual.Show 1
                End If
            Case CNCLathe
                If SendLatheCmp(CNCFrmDat(CnCFrmNo).DevNo) Then                   'Start execution
                    Lathemanual.Show 1
                End If
            End Select

        End If
        CNCfrm(CnCFrmNo).SetFocus
    End Select
    

End Sub

Function SendLatheCmp (EditFrm) As Integer

Dim file$
Dim header As String * 3
Dim version As Integer
Dim page As String * 256

Dim offset As Long
Dim magic As Long
Dim OffsetPtr As Long






file$ = CNCFrmDat(EditFrmdat(EditFrm).Frmno).Filename

SendLatheCmp = False
If Dir$(file$) <> "" Then
    outhandle = FreeFile
    Open file$ For Binary Access Read Write As outhandle
        Get #outhandle, 1, header            'GET version
        Get #outhandle, , version
        If (header = "NCL") And ((version = fILEVERSION) Or (version = fILEVERSION1)) Then
            OffsetPtr = Loc(outhandle)
            Get #outhandle, OffsetPtr + 1, offset
            Get #outhandle, , magic                     ' Magic is sum of calibration

            'MsgBox "Magic number in file " + Format$(magic) + Chr$(13) + "Magic number in ini " + Format$(Calsum(EditFrm))

            
            If magic <> Calsum(EditFrm) Then                          ' Force recompilation if calibration changed
                offset = 0
            End If

            If offset = 0 Then
                offset = LOF(outhandle)
                If Lathe_compile(EditFrm) Then      'Compile will put data at end of file
                    Put #outhandle, OffsetPtr + 1, offset
                    magic = Calsum(EditFrm)
                    Put #outhandle, , magic
                End If
            End If
            
            Get #outhandle, OffsetPtr + 1, offset       ' Read pointer to start of program
            If offset <> 0 Then
                Get #outhandle, offset + 1, page
                setbuffer EditFrm, page, True         'Send the first page
                
                EditFrmdat(EditFrm).Exe_Handle = outhandle
                SendLatheCmp = True
            Else
                On Local Error Resume Next
                Close outhandle             'Closing write protected file gives error
                
            End If
        Else
            MsgBox "File " + file$ + " not valid", , "Sendcmp"
            On Local Error Resume Next
            Close outhandle
        End If
    
End If

On Local Error GoTo 0

End Function

Function SendMillCmp (EditFrm, UseZ As Integer) As Integer

Dim file$
Dim header As String * 3
Dim version As Integer
Dim page As String * 256

Dim offset As Long
Dim Dummy As Long
Dim OffsetPtr As Long

'CNCfrmNo



file$ = CNCFrmDat(EditFrmdat(EditFrm).Frmno).Filename

SendMillCmp = False
On Error GoTo diskerr

If Dir$(file$) <> "" Then
    outhandle = FreeFile
    Open file$ For Binary Access Read Write As outhandle
        Get #outhandle, 1, header            'GET version
        Get #outhandle, , version
        If (header = "NCM") And ((version = fILEVERSION) Or (version = fILEVERSION1)) Then
            Select Case UseZ
            Case True
                OffsetPtr = Loc(outhandle)
                Get #outhandle, OffsetPtr + 1, offset
                Get #outhandle, , Dummy
            Case False
                Get #outhandle, , Dummy
                OffsetPtr = Loc(outhandle)
                Get #outhandle, , offset
            End Select
            
            
            If offset = 0 Then
                offset = LOF(outhandle)
                If mill_compile(EditFrm, UseZ) Then      'Compile will put data at end of file
                    If PromptEngrave Then
                    
                    Else
                        Put #outhandle, OffsetPtr + 1, offset       'Save pointer to prog if no engraving
                    End If
                End If
            End If
            
            'Get #outhandle, OffsetPtr + 1, offset
            
            If offset <> 0 Then
                Get #outhandle, offset + 1, page
                setbuffer EditFrm, page, True         'Send the first page
                
                'Walli3.Picture1.Cls
                'MILLPAGe = 1
                'Walli3.Picture1.Print MILLPAGe;

                EditFrmdat(EditFrm).Exe_Handle = outhandle
                SendMillCmp = True
            Else
                On Local Error Resume Next
                Close outhandle             'Closing write protected file gives error
            End If
        Else
            MsgBox "File " + file$ + " not valid", , "Sendcmp"
            On Local Error Resume Next
            Close outhandle
        End If
    
End If
On Local Error GoTo 0
Exit Function

diskerr:
    MsgBox "Error accessing " & file$
    On Local Error GoTo 0
    Exit Function



End Function

