Option Explicit
Option Compare Text
DefInt A-Z


'Dim curt As Integer             'Current Tool

Dim Curf As Integer
Dim Curs As Integer             'Current spindle speed
Dim spin As Integer

Dim LocalDesX As Integer
Dim LocalDesZ As Integer
Dim Locali As Integer
Dim Localk As Integer


Dim buffer As String

Dim linenum As Long


Dim quit
Dim dirbyte

Dim tmpptr As Integer
Dim tmpfile() As Integer

Dim er

Dim xs
Dim xm As Long
Dim xdir

Dim zs
Dim ZM As Long
Dim Zdir


'Dim cz

Dim radius As Single
Dim radsqr As Single
Dim sector
Dim arcdir

Dim progend

Dim rev

'Dim absolute
Dim firstcut

Dim Lcalib As LatheCalibType

Private Function arctest ()
	 
	 Dim DX
	 Dim dif As Integer
	 
	 arctest = True
	 Exit Function
	 
	 
	 
	 
	 If xs < xm And LocalDesX > xm Then
		dif = Abs(LocalDesX - xm)        'Correct for any rounding errors
		If dif > 10 Then arctest = False
	 End If
	 If xs > xm And LocalDesX < xm Then
		dif = Abs(LocalDesX - xm)        'Correct for any rounding errors
		If dif > 10 Then arctest = False
	 End If
	 If zs < ZM And LocalDesZ > ZM Then
		dif = Abs(LocalDesZ - ZM)        'Correct for any rounding errors
		If dif > 10 Then arctest = False
	 End If
	 
	 If zs > ZM And LocalDesZ < ZM Then
		dif = Abs(LocalDesZ - ZM)       'Correct for any rounding errors
		If dif > 10 Then arctest = False
	 End If
	 
	 DX = Abs(xs - xm) - Abs(LocalDesX - xm)
	 If DX * sector * arcdir < 0 Then
		arctest = False
	 End If
End Function

Sub ChangeTool ()

SaveByte 128 + 64 + 32
SaveByte 11
SaveByte curt       'Mcopy(low(LineNum), high(LineNum)).t       'Lathe will move to 0,0
LastDesX = 0: LastDesZ = 0                          'So do same


'curt = Mcopy(low(LineNum), high(LineNum)).t

dirbyte = 0            'Played with direction tell setdirection
ToolChange = False


End Sub

Private Sub CNC_gcodes ()
    
	
LocalDesX = DesX
LocalDesZ = DesZ


Locali = CNC_gcode.i
Localk = CNC_gcode.k


'Printer.Print LineNum; CNC_gcode.g; LocalDesX; LocalDesZ
	
	Select Case CNC_gcode.G
	Case 0, 92                   'Fast position
		g0
	
	Case 1                    'Linear Interpolation
		g1
	
	Case 2                    'CW Interpolation
		g3
	
	Case 3                    'CCW Interpolation
		g2
	
	Case 4                    'Dwell
		g4
	
	Case 33
		G33
	
	Case 38
		g38
	
	Case 39
		g39
	Case 83
		g83

	End Select
End Sub

Private Sub compileline ()
   
	SaveByte (&HE0): SaveByte (16): saveword (linenum)  '(CNC_gcode.n)
	
	If Mcopy(low(linenum), high(linenum)).S <> NotSet Then
	    Curs = Mcopy(low(linenum), high(linenum)).S
	    If Curs > UBound(lathe_spindle_spd) Then Curs = UBound(lathe_spindle_spd)
	    If spin Then m3     'If Spindle on use spindle speed now
	End If
	
	'If Mcopy(low(LineNum), high(LineNum)).t <> notset Then
	'    If Mcopy(low(LineNum), high(LineNum)).t <> curt Then        'Change of tool
	If ToolChange Then ChangeTool
	
	
	
	Select Case Mcopy(low(linenum), high(linenum)).F
	    Case Curf, NotSet
	    Case Else
		Curf = Mcopy(low(linenum), high(linenum)).F
		If Curf > UBound(lathe_feedrates) Then Curf = UBound(lathe_feedrates)
		setfeedrate
	End Select

	mcodes
	If Not progend Then CNC_gcodes
	
	PurgeBuffer

End Sub

Private Sub do_arc ()

Dim incx As Integer
Dim incz As Integer
Dim b As Integer

Dim deltax As Integer
Dim deltaZ As Integer

Dim DX As Integer
Dim dz As Integer
Dim a$
	 
	 If Abs(radius - Sqr((xm - LocalDesX) ^ 2 + (ZM - LocalDesZ) ^ 2)) > 16 Then
		MsgBox "Arc not possible"
		quit = True
		Exit Sub
	 End If
	 
	 If Not arctest() Then
		MsgBox "Arc not possible "
		quit = True
		Exit Sub
	 End If


	 b = 128
	 If xdir = 1 Then b = b Or 2
	 If Zdir = 1 Then b = b Or 1
	 SaveByte (b)
	 dirbyte = 0            'Played with direction tell setdirection
	 
	 deltaZ = Abs(LocalDesZ - LastDesZ)          'total change for LocalDesY
	 deltax = Abs(LocalDesX - LastDesX)          'total change for LocalDesX

	 Do
	  dz = Abs(zs - LastDesZ)   'change from start pos to current
	  DX = Abs(xs - LastDesX)
	  If Abs(LastDesX - xm) > Abs(LastDesZ - ZM) Then
		   'set LocalDesY increment, calculate LocalDesX
		   If deltaZ - dz < 8 Then incz = deltaZ - dz Else incz = 8
		   LastDesZ = LastDesZ + incz * Zdir

		   'guiding equat  SQR((XM - LocalDesX) ^ 2 + (ZM - LocalDesY) ^ 2) =radsqr
		   incx = Fix(Abs((Sqr(radsqr - (ZM - LastDesZ) ^ 2) + (LastDesX - xm) * xdir)))
		   If incx > 8 Then incx = 8
		   If incx > Fix(Abs(deltax - DX)) Then incx = Fix(Abs(deltax - DX))
		   LastDesX = LastDesX + incx * xdir
	  Else
		   'set LocalDesX increment, calculate LocalDesY
		   If deltax - DX < 8 Then incx = deltax - DX Else incx = 8
		   LastDesX = LastDesX + incx * xdir
		   
		   incz = Fix(Abs((Sqr(radsqr - (xm - LastDesX) ^ 2) - (LastDesZ - ZM) * Zdir)))
		   If incz > 8 Then incz = 8
		   If incz > Fix(Abs(deltaZ - dz)) Then incz = Fix(Abs(deltaZ - dz))
		   LastDesZ = LastDesZ + incz * Zdir
	  End If
	 
	  If incx <> 0 Or incz <> 0 Then
		SaveByte (0)
		front (incx)
		front (incz)
	  End If
	 
	 Loop Until (incx = 0) And (incz = 0)
	 'LastDesX = LocalDesX
	 'LastDesY = LocalDesY
End Sub

Private Sub front (k)
	 'save number with k 1's in front justified
	 Select Case k
	  Case 0
		   SaveByte (0)
	  Case 1
		   SaveByte (&H80)
	  Case 2
		   SaveByte (&H88)
	  Case 3
		   SaveByte (&HA4)
	  Case 4
		   SaveByte (&HAA)
	  Case 5
		   SaveByte (&HEA)
	  Case 6
		   SaveByte (&HEE)
	  Case 7
		   SaveByte (&HFE)
	  Case 8
		   SaveByte (&HFF)
	 End Select
End Sub

Private Sub g0 ()
	 
Dim DX As Integer
Dim dz As Integer

	 
	 DX = LocalDesX - LastDesX
	 dz = LocalDesZ - LastDesZ
	 If (DX = 0) And (dz = 0) Then Exit Sub
	 
	 SetDirection DX, dz
	 DX = Abs(DX):  dz = Abs(dz)
	 SaveByte (16)
	 saveword (DX)
	 saveword (dz)
	 
	 
End Sub

Private Sub g1 ()
	 
'Dim b
Dim KX  As Integer
Dim KZ  As Integer

Dim DX As Integer
Dim dz As Integer

Dim deltax As Integer
Dim deltaZ As Integer

Dim slopexZ As Single
Dim slopeZx As Single


	
	 
	deltax = LocalDesX - LastDesX
	deltaZ = LocalDesZ - LastDesZ
	SetDirection deltax, deltaZ
	
	
	If deltax = 0 And deltaZ = 0 Then Exit Sub
	
	deltax = Abs(deltax): deltaZ = Abs(deltaZ): DX = 0: dz = 0


'    GoTo skip
	
	If deltaZ = 0 Then
	    SaveByte 65
	    saveword deltax
	    Exit Sub
	End If

	If deltax = 0 Then
	    SaveByte 64
	    saveword deltaZ
	    Exit Sub
	End If

skip:

	If deltax <> 0 Then slopeZx = deltaZ / deltax
	If deltaZ <> 0 Then slopexZ = deltax / deltaZ
	
	Do
	If (deltaZ - dz) < (deltax - DX) Then
		SaveByte (0)                         'XY data
		If deltax - DX < 8 Then KX = deltax - DX Else KX = 8
		DX = DX + KX
		KZ = Int(DX * slopeZx - dz)
		If KZ > 8 Then KZ = 8
		If KZ < 0 Then KZ = 0
		dz = dz + KZ
		front (KX): front (KZ)
	Else
		SaveByte (0)                         'XY data
		If deltaZ - dz < 8 Then KZ = deltaZ - dz Else KZ = 8
		dz = dz + KZ
		KX = Int(dz * slopexZ - DX)
		If KX > 8 Then KX = 8
		If KX < 0 Then KX = 0
		DX = DX + KX
		front (KX): front (KZ)
	End If
	Loop Until (DX = deltax) And (dz = deltaZ)
		'
End Sub

Private Sub g2 ()

Dim x1
Dim Z1

	 
	 
	 arcdir = -1
	 radsqr = CSng(Locali) * CSng(Locali) + CSng(Localk) * CSng(Localk)
	 radius = Sqr(radsqr)
	 
	 xs = LastDesX: zs = LastDesZ              'start posns
	 If LocalDesX > xs And LocalDesZ > zs Then
	  xm = CLng(xs) - CLng(Locali)              'LocalDesX Middle
	  xdir = 1
	  ZM = CLng(zs) + CLng(Localk)              'LocalDesY middle
	  Zdir = 1
	  sector = 1
	 ElseIf LocalDesX > xs And LocalDesZ <= zs Then
	  xm = CLng(xs) + CLng(Locali)         '1 does do_arc, 6
	  xdir = 1
	  ZM = CLng(zs) + CLng(Localk)
	  Zdir = -1
	  sector = -1
	 ElseIf LocalDesX <= xs And LocalDesZ > zs Then
	  xm = CLng(xs) - CLng(Locali)         ' 3 now uses
	  xdir = -1
	  ZM = CLng(zs) - CLng(Localk)
	  Zdir = 1
	  sector = -1
	 ElseIf LocalDesX <= xs And LocalDesZ <= zs Then
	  xm = CLng(xs) + CLng(Locali)         '5 does reverse
	  xdir = -1
	  ZM = CLng(zs) - CLng(Localk)
	  Zdir = -1
	  sector = 1
	 End If
	 If xdir * Zdir = 1 Then
	  
	  opentmpfile

	  x1 = LocalDesX
	  Z1 = LocalDesZ
	  LastDesX = LocalDesX: LocalDesX = xs
	  LastDesZ = LocalDesZ: LocalDesZ = zs
	  Locali = Abs(xm - LastDesX)
	  Localk = Abs(ZM - LastDesZ)
	  g3
	  'LastDesX = x1
	  'LastDesY = y1
	  savebuffer
	 Else
	  do_arc
	 End If
End Sub

Private Sub g3 ()

Dim x1
Dim Z1


	 arcdir = 1
	 radsqr = CSng(Locali) * CSng(Locali) + CSng(Localk) * CSng(Localk)
	 'radsqr = LocalI * LocalI + CNC_gcode.j * CNC_gcode.j
	 radius = Sqr(radsqr)
	 
	 xs = LastDesX: zs = LastDesZ
	 If LocalDesX >= xs And LocalDesZ >= zs Then
	  xm = CLng(xs) + CLng(Locali)     '5 from reverse
	  xdir = 1
	  ZM = CLng(zs) - CLng(Localk)
	  Zdir = 1
	  sector = 1
	 ElseIf LocalDesX >= xs And LocalDesZ < zs Then
	  xm = CLng(xs) - CLng(Locali)     '3 does do_arc      - gets X dirn wrong
	  xdir = 1                  'changed now does reverse
	  ZM = CLng(zs) - CLng(Localk)
	  Zdir = -1
	  sector = -1
	 
	 ElseIf LocalDesX < xs And LocalDesZ >= zs Then
	  xm = CLng(xs) + CLng(Locali)
	  xdir = -1
	  ZM = CLng(zs) + CLng(Localk)
	  Zdir = 1
	  sector = -1
	 
	 ElseIf LocalDesX < xs And LocalDesZ < zs Then
	  xm = CLng(xs) - CLng(Locali)         '2 does do_arc, 4
	  xdir = -1
	  ZM = CLng(zs) + CLng(Localk)
	  Zdir = -1
	  sector = 1
	 End If
	 If xdir * Zdir = -1 Then
	  'PRINT "Before bodgery "; LocalI; CNC_gcode.j; XM; LastDesX; LocalDesX; ZM; LastDesY; LocalDesY
	  opentmpfile
	  x1 = LocalDesX
	  Z1 = LocalDesZ
	  LastDesX = LocalDesX: LocalDesX = xs
	  LastDesZ = LocalDesZ: LocalDesZ = zs
	  Locali = Abs(xm - LastDesX): Localk = Abs(ZM - LastDesZ): g2
	  'LastDesX = x1: LastDesY = y1
	  savebuffer
	 Else
	  do_arc
	 End If
End Sub

Private Sub G33 ()

'CNC_gcode.z, LocalI, LocalK used raw

Dim pass  As Integer
Dim stepin As Single
Dim DX As Integer


Dim counts As Single

Dim a As Integer
Dim aa As Integer

Dim b As Integer
Dim c As Integer

Dim cnt As Single
Dim errs As Single

'Make pitch table
'Calculate counts per step
counts = 3000 / Localk

'Solve    ab+c(b-1) = 8counts   where a+c=16

errs = 100
For a = 0 To 16
    c = 16 - a
    b = Fix((8 * counts + c) / 16)
    If Abs((a * b + c * (b - 1)) / 8 - counts) < errs Then
	errs = Abs((a * b + c * (b - 1)) / 8 - counts)
	aa = a
    End If
Next

Dim m$

c = 16 - aa
b = Fix((8 * counts + c) / 16)

errs = Abs((a * b + c * (b - 1)) / 8 - counts)

m$ = "Counts = " + Format$(counts) + Chr$(13)
m$ = m$ + Format$(aa) + "*" + Format$(b) + " " + Format$(c) + "*" + Format$(b - 1)

'MsgBox m$
c = b - 1


SaveByte 66     'Thread table
c = 256 - c
b = 256 - b
Select Case aa
Case 0
    SaveByte c: SaveByte c: SaveByte c: SaveByte c: SaveByte c: SaveByte c: SaveByte c: SaveByte c
    SaveByte c: SaveByte c: SaveByte c: SaveByte c: SaveByte c: SaveByte c: SaveByte c: SaveByte c
Case 1
    SaveByte c: SaveByte c: SaveByte c: SaveByte c: SaveByte c: SaveByte c: SaveByte c: SaveByte c
    SaveByte c: SaveByte c: SaveByte c: SaveByte c: SaveByte c: SaveByte c: SaveByte c: SaveByte b
Case 2
    SaveByte c: SaveByte c: SaveByte c: SaveByte c: SaveByte c: SaveByte c: SaveByte c: SaveByte b
    SaveByte c: SaveByte c: SaveByte c: SaveByte c: SaveByte c: SaveByte c: SaveByte c: SaveByte b
Case 3
    SaveByte c: SaveByte c: SaveByte c: SaveByte c: SaveByte c: SaveByte b: SaveByte c: SaveByte c
    SaveByte c: SaveByte c: SaveByte b: SaveByte c: SaveByte c: SaveByte c: SaveByte c: SaveByte b
Case 4
    SaveByte c: SaveByte c: SaveByte c: SaveByte b: SaveByte c: SaveByte c: SaveByte c: SaveByte b
    SaveByte c: SaveByte c: SaveByte c: SaveByte b: SaveByte c: SaveByte c: SaveByte c: SaveByte b
Case 5
    SaveByte c: SaveByte c: SaveByte c: SaveByte b: SaveByte c: SaveByte c: SaveByte b: SaveByte c
    SaveByte c: SaveByte b: SaveByte c: SaveByte c: SaveByte b: SaveByte c: SaveByte c: SaveByte b
Case 6
    SaveByte c: SaveByte b: SaveByte c: SaveByte c: SaveByte b: SaveByte c: SaveByte c: SaveByte b
    SaveByte c: SaveByte b: SaveByte c: SaveByte c: SaveByte b: SaveByte c: SaveByte c: SaveByte b
Case 7
    SaveByte c: SaveByte b: SaveByte c: SaveByte b: SaveByte c: SaveByte b: SaveByte c: SaveByte b
    SaveByte c: SaveByte b: SaveByte c: SaveByte c: SaveByte b: SaveByte c: SaveByte c: SaveByte b
Case 8
    SaveByte c: SaveByte b: SaveByte c: SaveByte b: SaveByte c: SaveByte b: SaveByte c: SaveByte b
    SaveByte c: SaveByte b: SaveByte c: SaveByte b: SaveByte c: SaveByte b: SaveByte c: SaveByte b
Case 9
    SaveByte b: SaveByte c: SaveByte b: SaveByte c: SaveByte b: SaveByte c: SaveByte b: SaveByte c
    SaveByte b: SaveByte c: SaveByte b: SaveByte b: SaveByte c: SaveByte b: SaveByte b: SaveByte c
Case 10
    SaveByte b: SaveByte c: SaveByte b: SaveByte b: SaveByte c: SaveByte b: SaveByte b: SaveByte c
    SaveByte b: SaveByte c: SaveByte b: SaveByte b: SaveByte c: SaveByte b: SaveByte b: SaveByte c
Case 11
    SaveByte b: SaveByte b: SaveByte b: SaveByte c: SaveByte b: SaveByte b: SaveByte c: SaveByte b
    SaveByte b: SaveByte c: SaveByte b: SaveByte b: SaveByte c: SaveByte b: SaveByte b: SaveByte c
Case 12
    SaveByte b: SaveByte b: SaveByte b: SaveByte c: SaveByte b: SaveByte b: SaveByte b: SaveByte c
    SaveByte b: SaveByte b: SaveByte b: SaveByte c: SaveByte b: SaveByte b: SaveByte b: SaveByte c
Case 13
    SaveByte b: SaveByte b: SaveByte b: SaveByte b: SaveByte b: SaveByte c: SaveByte b: SaveByte b
    SaveByte b: SaveByte b: SaveByte c: SaveByte b: SaveByte b: SaveByte b: SaveByte b: SaveByte c
Case 14
    SaveByte b: SaveByte b: SaveByte b: SaveByte b: SaveByte b: SaveByte b: SaveByte b: SaveByte c
    SaveByte b: SaveByte b: SaveByte b: SaveByte b: SaveByte b: SaveByte b: SaveByte b: SaveByte c
Case 15
    SaveByte b: SaveByte b: SaveByte b: SaveByte b: SaveByte b: SaveByte b: SaveByte b: SaveByte b
    SaveByte b: SaveByte b: SaveByte b: SaveByte b: SaveByte b: SaveByte b: SaveByte b: SaveByte c
Case 16
    SaveByte b: SaveByte b: SaveByte b: SaveByte b: SaveByte b: SaveByte b: SaveByte b: SaveByte b
    SaveByte b: SaveByte b: SaveByte b: SaveByte b: SaveByte b: SaveByte b: SaveByte b: SaveByte b
End Select

SaveByte 0  'End of thread table

'Thread cutting
'in by   .1mm
'thread  CNC_gcode.z
'fast trav -1mm, CNC_gcode.z
    
    
    

    stepin = 10
    pass = 0
    DX = 0
    
    Do
	SetDirection 1, 1   'both will be traveling towards "0,0"
    
	DX = DX + stepin
	If DX > Locali Then DX = Locali   'i = height of thread
	
	If pass = 0 Then
	    SaveByte 65: saveword DX                ' on first pass go in just by thread depth
	Else
	    SaveByte 65: saveword DX + MMTOSTEPS    ' other passes go in by clearance as well
	End If

	SaveByte 67: saveword CNC_gcode.z       'Thread

	SetDirection -1, -1   'both will be traveling away from  "0,0"
    
	SaveByte 16
	saveword DX + MMTOSTEPS     'come out to give 1 mm clearance
	saveword CNC_gcode.z        ' back to start Z
	
	pass = pass + 1
	stepin = stepin * 11 / 12: If stepin < 1 Then stepin = 1

    Loop Until DX = Locali

	
    SetDirection 1, 1                   'Move X back in by the 1mm of clear
    SaveByte 65: saveword MMTOSTEPS     'Z is already back at start point


    If spin Then m3

End Sub

Private Sub g38 ()
'Wait for input in x field low, input in z field high
Dim i As Integer

Select Case Mcopy(low(linenum), high(linenum)).X
    Case NotSet, Home
    Case Else
	i = Mcopy(low(linenum), high(linenum)).X * Mcopy(low(linenum), high(linenum)).steps_to_units
	SaveByte (128 + 64 + 32)
	SaveByte (15)
	SaveByte (2 ^ (i - 1))
End Select

Select Case Mcopy(low(linenum), high(linenum)).z
    Case NotSet, Home
    Case Else
	i = Mcopy(low(linenum), high(linenum)).z * Mcopy(low(linenum), high(linenum)).steps_to_units
	SaveByte (128 + 64 + 32)
	SaveByte (14)
	SaveByte (2 ^ (i - 1))
End Select



End Sub

Private Sub g39 ()
'set output in x field low, input in z field high
Dim i As Integer



Select Case Mcopy(low(linenum), high(linenum)).X
    Case NotSet, Home
    Case Else
	i = Mcopy(low(linenum), high(linenum)).X * Mcopy(low(linenum), high(linenum)).steps_to_units
	SaveByte (128 + 64 + 32)
	SaveByte (13)
	SaveByte (2 ^ (i - 1))
End Select

Select Case Mcopy(low(linenum), high(linenum)).z
    Case NotSet, Home
    Case Else
	i = Mcopy(low(linenum), high(linenum)).z * Mcopy(low(linenum), high(linenum)).steps_to_units
	SaveByte (128 + 64 + 32)
	SaveByte (12)
	SaveByte (2 ^ (i - 1))
End Select


End Sub

Private Sub g4 ()

If CNC_gcode.d > 0 Then
	SaveByte (128 + 8)
	SaveByte (CNC_gcode.d * 2)
End If

End Sub

Private Sub g83 ()
	 
Dim zstep As Integer
Dim dz  As Integer
	 
	dz = 0
	zstep = MMTOSTEPS * .5

	
	    Do
		SetDirection 0, 1         'In
		SaveByte (16)
		saveword (0)
		saveword (dz)
		
		dz = dz + zstep
		If dz > LocalDesZ Then
		    dz = dz - zstep
		    zstep = LocalDesZ - dz
		    dz = LocalDesZ
		End If
	    
		SaveByte (64)
		saveword (zstep)
		
		If dz = LocalDesZ Then g4
	    
		SetDirection 0, -1         'Out
		SaveByte (16)
		saveword (0)
		saveword (dz)
	    Loop Until dz = LocalDesZ

End Sub

Private Sub Keyin (pause As Integer)
    SaveByte (128 + 64 + 32)
    SaveByte (8)                    'Added 21/10/95
    If pause Then m0
End Sub

Function Lathe_compile (Editfrm) As Integer

Dim b As Integer
Dim k As Integer
Dim mult As Single
	
	
'Outhandle is already valid

	Lathe_compile = False
	
	spin = False: Curs = 7: Curf = 6
	
	screen.MousePointer = 11    'busy
	SetUpStatus "Cyber Lathe Compiler"
	quit = False
	buffer = ""
	
	
	
	cncfrm(Editfrmdat(Editfrm).Frmno).EditFunc.Caption = "Copy"       'Get copy of program


	dirbyte = 0
	progend = False
	rev = False:  firstcut = True
	SendHome

	
	linenum = Get_LatheGcode(1, False)
	If CNC_gcode.G = 25 Then
	    MakeProfile                     'Returns Array Pass1 and Pass2
	    ReadLatheCalib CNCFrmDat(CNCFrmNo).DevNo, Lcalib
	    LastDesX = 0
	    LastDesZ = 0
	    
	    m68             'Chuck closed
	    Curs = 8: m3    'Spindle on
	    setfeedrate
	    Tool1Pass 1     '-1 for away from chuck
	    Erase Pass1

	    Tool2Pass -1
	    Erase Pass2
	    
	    Tool3Pass
	    Tool4Pass
	    
	    
	    curt = 1: ChangeTool
	    
	    m5              'Spindle Off
	    m69             'Chuck Open
	Else
	    setfeedrate
	    mult = 100 / cncfrm(Editfrmdat(Editfrm).Frmno).Table1.Rows
	    For linenum = 1 To cncfrm(Editfrmdat(Editfrm).Frmno).Table1.Rows
		showprogress (linenum * 100) / cncfrm(Editfrmdat(Editfrm).Frmno).Table1.Rows
		
		linenum = Get_LatheGcode(linenum, True)               'Modify x z for tooloffset
		If linenum <= 0 Then
		    If linenum = 0 Then quit = True Else progend = True
		Else
		    compileline         'May mod linenum
		End If
		If progend Then Exit For
		If quit Then
		    cncfrm(Editfrmdat(Editfrm).Frmno).Table1.RowIndex = linenum
		    Unload StatusDlg
		    screen.MousePointer = 0
		    Exit Function
		End If
	    Next
	End If
	SaveByte (255)              'End of file marker
	PurgeBuffer
	
	Unload StatusDlg
	screen.MousePointer = 0
	
	Lathe_compile = True
End Function

Private Sub m0 ()
	 
	 SaveByte (128 + 64 + 32)
	 SaveByte (10)
End Sub

Private Sub m2 ()
	 progend = True
End Sub

Private Sub m3 ()       'CW
	
	spin = True
	SaveByte (128 + 64 + 32)
	SaveByte (1)
	SaveByte (lathe_spindle_spd(Curs))
End Sub

Private Sub m5 ()           'Spindle off
    spin = False
    SaveByte (128 + 64 + 32)
    SaveByte (3)
	  
End Sub

Sub m58 ()
	'Clamp no pause
	Keyin (False)
	SaveByte (128 + 64 + 32)
	SaveByte (4)

End Sub

Sub m59 ()
	 Keyin (False)
	 SaveByte (128 + 64 + 32)
	 SaveByte (5)

End Sub

Private Sub m68 ()
	'Clamp with pause
	Keyin (False)
	'Keyin (False)
	SaveByte (128 + 64 + 32)
	SaveByte (4)
	'm0

End Sub

Private Sub m69 ()
	 'unclamp   with pause
	 Keyin (False)
	 SaveByte (128 + 64 + 32)
	 SaveByte (5)
	 'm0

End Sub

Private Sub mcodes ()
	   
    Select Case CNC_gcode.m
	Case 0
	    m0
	Case 2
	    m2
	Case 3
	    m3
	Case 5
	    m5
	Case 58
	    m58
	Case 59
	    m59
	Case 68
	    m68
	Case 69
	    m69
	Case NotSet
	
	Case Else
	    quit = True
	    MsgBox "M-Code" + Str$(CNC_gcode.m) + " is not supported"
	End Select
	CNC_gcode.m = NotSet

End Sub

Private Sub opentmpfile ()

rev = True

tmpptr = 0
ReDim tmpfile(1024)

'tmpfile = FreeFile
'Open "wal.tmp" For Binary Access Read Write As tmpfile



End Sub

Private Sub PurgeBuffer ()

On Local Error GoTo PurgeBuffer_Error


If buffer <> "" Then
	Put #outhandle, LOF(outhandle) + 1, buffer
	buffer = ""
End If


On Local Error GoTo 0
Exit Sub


PurgeBuffer_Error:
    MsgBox "Error Writing to file"
    quit = True
    Resume Next


End Sub

Private Sub savebuffer ()
	 
	 Dim b As Integer
	 Dim k As Long
	 'Transfer temp to main file

	 rev = False
	 
	 'Get #tmpfile, 1, b
	 'If (b And 4) = 4 Then b = b - 4 Else b = b + 4
	 'If (b And 2) = 2 Then b = b - 2 Else b = b + 2
	 'savebyte (b)
	 
	 b = tmpfile(0)
	 If (b And 4) = 4 Then
	    b = b - 4
	 Else
	    b = b + 4
	 End If
	 
	 If (b And 2) = 2 Then
	    b = b - 2
	 Else
	    b = b + 2
	 End If

	 If (b And 1) = 1 Then
	    b = b - 1
	 Else
	    b = b + 1
	 End If
	 SaveByte (b)

	 'For k = LOF(tmpfile) - 5 To 1 Step -6
	 ' Get #tmpfile, k, b: savebyte b
	 ' Get #tmpfile, , b: savebyte b
	 ' Get #tmpfile, , b: savebyte b
	 'Next

	 For k = tmpptr - 3 To 1 Step -3
		b = tmpfile(k): SaveByte b
		b = tmpfile(k + 1): SaveByte b
		b = tmpfile(k + 2): SaveByte b
	 Next
	 Erase tmpfile
	 
	' CNC_gcode.x = LastDesX: CNC_gcode.y = LastDesY
	 
	 'Close tmpfile
	 'Kill "wal.tmp"
	 
End Sub

Private Sub SaveByte (dat As Integer)

Dim byte As String * 1

	If rev Then            'save to buffer for reverse later
		'Put #tmpfile, , dat
		If tmpptr > UBound(tmpfile) Then
		ReDim Preserve tmpfile(tmpptr + 1024)
		End If
		tmpfile(tmpptr) = dat: tmpptr = tmpptr + 1
	Else                    'save direct in compiled data table
		'byte = Chr$(dat)
		'Put #outhandle, , byte
		
		buffer = buffer + Chr$(dat)
		'If Len(buffer$) = 1024 Then Put #outhandle, , buffer$: buffer$ = ""
	End If
	 
End Sub

Private Sub saveword (dat)
	 
'6502 vesion save MSB first - CHECK WHY

	 SaveByte (dat Mod 256)
	 SaveByte (Fix(dat / 256))

'    If rev Then            'save to buffer for reverse later
'        Put #tmpfile, , dat
'    Else                    'save direct in compiled data table
'        Put #outhandle, , dat
'    End If

End Sub

Private Sub send_z (dz As Integer)
	
	If dz <> 0 Then
		SaveByte 64
		saveword Abs(dz)
	'cz = CNC_gcode.z
	End If

	If DesZ = z_down Then                    'Pause first time Z is down
	 If firstcut Then
		SaveByte (128 + 64 + 32)
		SaveByte (10)
		firstcut = False
	 End If
	End If


End Sub

Private Sub SendHome ()
	SaveByte (192)
	curt = 1            'Tool 1 will be selected
End Sub

Private Sub SetDirection (X, z)

Dim b As Integer

	b = 128
	If X = 0 Then
		If (dirbyte And 130) = 130 Then b = b Or 2      'Keep same as last time
	ElseIf X > 0 Then
		b = b Or 2      'x +ve
	End If
	
	If z = 0 Then
		If (dirbyte And 129) = 129 Then b = b Or 1      'Keep same as last time
	ElseIf z > 0 Then
		b = b Or 1      'Z +ve
	End If
	
	
	If dirbyte <> b Then
		SaveByte (b)
		dirbyte = b
	Else
	    '
	End If

	'If B = 128 Then MsgBox "Direction byte!"

End Sub

Private Sub setfeedrate ()

Dim i As Long


SaveByte (128 + 64 + 32)
SaveByte (7)

SaveByte (lathe_feedrates(Curf) Mod 256)
SaveByte (Fix(lathe_feedrates(Curf) / 256))
'i = 65551 - (600000 * Sqr(2) / (50 * (Mcopy(low(linenum),high(linenum)).F + 1)))
i = 65551 - (600000 * Sqr(2) / (100 * (Curf + 1)))
SaveByte (i Mod 256)
SaveByte (Fix(i / 256))



End Sub

Private Sub Tool1Pass (Dirn As Integer)

Dim J As Integer
Dim S As Integer
Dim e As Integer

Dim z As Integer
Dim DX As Integer
Dim dz As Integer




On Local Error GoTo NoTool1
J = UBound(Pass1, 2)
On Local Error GoTo 0


curt = 1

If Dirn = 1 Then
    LocalDesZ = Lcalib.Tool_z(curt) - options.zstock
Else
    LocalDesZ = Lcalib.Tool_z(curt)
End If
LocalDesX = Lcalib.Tool_x(curt) - options.xstock
g0
LastDesX = LocalDesX
LastDesZ = LocalDesZ
m0



For J = UBound(Pass1, 2) To 0 Step -1
    
    If J <> UBound(Pass1, 2) Then
	For S = 0 To UBound(Radii)
	    If Pass1(S, J).radius <> Pass1(S, J + 1).radius Then Exit For
	Next
	For e = UBound(Radii) To 0 Step -1
	    If Pass1(e, J).radius <> Pass1(e, J + 1).radius Then Exit For
	Next
    Else
	Curf = 6: setfeedrate
	S = 0
	e = UBound(Radii)
    End If
    
    If J = 0 Then                   'Last pass
	Curf = 6: setfeedrate
	Curs = 9: m3
    End If

    If J <> UBound(Pass1, 2) Then
	'Curs = 9: m3
	DX = LocalDesX
	LocalDesX = Lcalib.Tool_x(curt) - options.xstock - 5 * MMTOSTEPS
	If LocalDesX < 0 Then LocalDesX = 0
	g0
	LastDesX = LocalDesX
	LocalDesX = DX: g0: LastDesX = LocalDesX
	'Curs = 8: m3
    End If
	
	
	LocalDesX = Lcalib.Tool_x(curt) - options.xstock
	If Dirn = 1 Then
	    LocalDesZ = Lcalib.Tool_z(curt) - e
	    z = e
	Else
	    LocalDesZ = Lcalib.Tool_z(curt) - S
	    z = S
	    S = e
	    e = z
	End If
	g0
	LastDesX = LocalDesX
	LastDesZ = LocalDesZ
	
	Do
	    Do
		z = z - 1 * Dirn
		LocalDesZ = LocalDesZ + 1 * Dirn
		LocalDesX = Lcalib.Tool_x(curt) - Pass1(z, J).radius
		DX = Abs(LocalDesX - LastDesX)
		dz = Abs(LocalDesZ - LastDesZ)
		If DX <> 0 Then
		    Select Case dz
			Case 8
			    Exit Do
			Case Is > 8
			    z = z + 1 * Dirn
			    LocalDesZ = LocalDesZ - 1 * Dirn
			    LocalDesX = Lcalib.Tool_x(curt) - Pass1(z, J).radius
			    Exit Do
		    End Select
		End If
	    Loop Until z = S
	    g1
	    LastDesX = LocalDesX
	    LastDesZ = LocalDesZ
	Loop Until z = S
	PurgeBuffer

	'Dirn = Dirn * -1
    Next


NoTool1:
    On Error GoTo 0
    Exit Sub

End Sub

Private Sub Tool2Pass (Dirn As Integer)


Dim J As Integer
Dim S As Integer
Dim e As Integer

Dim z As Integer
Dim DX As Integer
Dim dz As Integer


On Local Error GoTo NoTool2
J = UBound(Pass2, 2)
On Local Error GoTo 0


curt = 2
ChangeTool


If Dirn = 1 Then
    LocalDesZ = Lcalib.Tool_z(curt) - options.zstock
Else
    LocalDesZ = Lcalib.Tool_z(curt) - Tool2Min
End If
LocalDesX = Lcalib.Tool_x(curt) - options.xstock
g0
LastDesX = LocalDesX
LastDesZ = LocalDesZ
m0

For J = UBound(Pass2, 2) To 0 Step -1
    If J <> UBound(Pass2, 2) Then
	For S = Tool2Min To UBound(Radii)
	    If Pass2(S, J).radius <> Pass2(S, J + 1).radius Then Exit For
	Next
	For e = UBound(Radii) To 0 Step -1
	    If Pass2(e, J).radius <> Pass2(e, J + 1).radius Then Exit For
	Next
	    Else
		S = Tool2Min
		e = UBound(Radii)
	End If
	
	LocalDesX = Lcalib.Tool_x(curt) - options.xstock
	If Dirn = 1 Then
	    LocalDesZ = Lcalib.Tool_z(curt) - e
	    z = e
	Else
	    LocalDesZ = Lcalib.Tool_z(curt) - S
	    z = S
	    S = e
	    e = z
	End If
	g0
	LastDesX = LocalDesX
	LastDesZ = LocalDesZ
	
	Do
	    Do
		z = z - 1 * Dirn
		LocalDesZ = LocalDesZ + 1 * Dirn
		LocalDesX = Lcalib.Tool_x(curt) - Pass2(z, J).radius
		DX = Abs(LocalDesX - LastDesX)
		dz = Abs(LocalDesZ - LastDesZ)
		If DX <> 0 Then
		    Select Case dz
			Case 8
			    Exit Do
			Case Is > 8
			    z = z + 1 * Dirn
			    LocalDesZ = LocalDesZ - 1 * Dirn
			    LocalDesX = Lcalib.Tool_x(curt) - Pass2(z, J).radius
			    Exit Do
		    End Select
		End If
	    Loop Until z = S
	    g1
	    LastDesX = LocalDesX
	    LastDesZ = LocalDesZ
	Loop Until z = S
	PurgeBuffer
    Next

NoTool2:
    On Error GoTo 0
    Exit Sub



End Sub

Private Sub Tool3Pass ()

Dim i As Integer

On Local Error GoTo NoTool3
i = UBound(ProfileThread)
On Local Error GoTo 0

curt = 3
ChangeTool

LocalDesZ = Lcalib.Tool_z(curt) - options.zstock
LocalDesX = Lcalib.Tool_x(curt) - options.xstock
g0
LastDesX = LocalDesX
LastDesZ = LocalDesZ
m0
	For i = 0 To UBound(ProfileThread)

	    LocalDesZ = Lcalib.Tool_z(curt) - ProfileThread(i).start
	    LocalDesX = Lcalib.Tool_x(curt) - ProfileThread(i).X
	    g0
	    LastDesX = LocalDesX
	    LastDesZ = LocalDesZ

	    Locali = ProfileThread(i).i
	    Localk = ProfileThread(i).k
	    CNC_gcode.z = ProfileThread(i).z
	    G33
	
	Next

	LocalDesX = 0
	LocalDesZ = 0
	g0
	LastDesX = LocalDesX
	LastDesZ = LocalDesZ

PurgeBuffer


NoTool3:
    On Error GoTo 0
    Exit Sub


End Sub

Private Sub Tool4Pass ()


If ProfileBore.BoreEnd <> ProfileBore.BoreStart Then
    curt = 4
    ChangeTool

    LocalDesZ = Lcalib.Tool_z(curt) - ProfileBore.BoreStart
    LocalDesX = 0
    g0
    LastDesX = LocalDesX
    LastDesZ = LocalDesZ

    
    LocalDesZ = ProfileBore.BoreStart - ProfileBore.BoreEnd
    g83
    
    
    LocalDesZ = 0
    LocalDesX = 0
    g0
    LastDesX = LocalDesX
    LastDesZ = LocalDesZ


End If





PurgeBuffer


End Sub

