Option Explicit
Option Compare Text
DefInt A-Z
Dim quit

Dim Lastx
Dim LastZ


Type radius_type
    radius As Integer
    N As Integer                ' Line used to create segment
    'G As Integer               'Type of segment
    'xc As Long               ' Centre of arc
    'zc As Long
End Type

Type radii_type
    radius As Integer
End Type

Global radii()  As radii_type    'Table of radii of stock  ZStock long


Dim curline As Long
Dim tmp_gcode() As tmp_gcode_type

Const Roughstep% = .5 * mmtosteps

Global Const stepstoPix = 3 / 40
Global Const PixtoSteps = 40 / 3


Type SubType
    LineNum As Long
    G As Integer
    Absolute As Integer
End Type


Dim Subptr As Integer
Dim SubVar() As SubType



Dim loopptr  As Integer
Dim LoopVar() As LoopType

Function Get_LatheGcode (LineNum As Long, UseToolOff As Integer) As Long

Static CallNo As Integer
Static Lcalib As LatheCalibType
Static xshift As Integer
Static zshift As Integer


Static Xposn As Single      'position in mm
Static Zposn As Single

Static Absolute_Prog As Integer


Get_LatheGcode = LineNum


Dim Tmp As Long





If LineNum <> 1 Then
    Select Case Mcopy(low(LineNum), high(LineNum)).t
    Case NotSet, CurT
    Case Else
        Select Case CallNo
            Case 0      'send tool to "0,0"
                CallNo = 1
                CNC_gcode.G = 0
                If UseToolOff Then
                    DesX = 0
                    DesZ = 0
                Else
                    DesX = Lcalib.Tool_x(CNC_gcode.t)
                    DesZ = Lcalib.Tool_z(CNC_gcode.t)
                End If
                Get_LatheGcode = LineNum - 1
                Exit Function
            Case 1
                CallNo = 0
                CurT = Mcopy(low(LineNum), high(LineNum)).t
                CNC_gcode.t = CurT
                ToolChange = True
        End Select
    End Select
End If




    Select Case CNC_gcode.G
        Case 0, 1, 2, 3, 92
            LastDesX = DesX
            LastDesZ = DesZ
    End Select


If LineNum = 1 Then
    ReadLatheCalib CNCFrmDat(CNCFrmNo).DevNo, Lcalib


    Select Case Mcopy(low(LineNum), high(LineNum)).t
    Case NotSet
        CurT = 1
        CNC_gcode.t = 1                 'Default tool
        ToolChange = False
    Case Else
        CurT = Mcopy(low(LineNum), high(LineNum)).t
        CNC_gcode.t = CurT
        ToolChange = True

    End Select



    CallNo = 0
    Absolute_Prog = True
    Xposn = 0
    Zposn = 0
    
    CNC_gcode.G = 0
    CNC_gcode.X = Lcalib.Tool_x(CNC_gcode.t)
    CNC_gcode.z = Lcalib.Tool_z(CNC_gcode.t)
    CNC_gcode.i = 0
    CNC_gcode.k = 0
    CNC_gcode.F = 7
    CNC_gcode.S = 7
    
    CNC_gcode.d = 0
    LastCNC_gcode = CNC_gcode
    

    xshift = 0
    zshift = 0

    DesX = 0
    DesZ = 0
    
    LastDesX = 0
    LastDesZ = 0

    loopptr = -1
    Subptr = -1

End If

'If Mcopy(low(LineNum), high(LineNum)).x = Home Then
'    Mcopy(low(LineNum), high(LineNum)).x = Lcalib.Tool_x(CNC_gcode.t)
'End If
'If Mcopy(low(LineNum), high(LineNum)).z = Home Then
'    Mcopy(low(LineNum), high(LineNum)).z = Lcalib.Tool_z(CNC_gcode.t)
'End If


    Select Case CNC_gcode.G
    Case 6, 36, 38, 39, 70, 71, 73, 90, 91, 92, 33
        CNC_gcode = LastCNC_gcode         'Reload default
    End Select
     
    
    If Mcopy(low(LineNum), high(LineNum)).F <> NotSet Then CNC_gcode.F = Mcopy(low(LineNum), high(LineNum)).F
    If Mcopy(low(LineNum), high(LineNum)).S <> NotSet Then CNC_gcode.S = Mcopy(low(LineNum), high(LineNum)).S
    
    If Mcopy(low(LineNum), high(LineNum)).d <> NotSet Then CNC_gcode.d = Mcopy(low(LineNum), high(LineNum)).d
    CNC_gcode.m = Mcopy(low(LineNum), high(LineNum)).m

    If CNC_gcode.m = 2 Then
        Get_LatheGcode = -1
        Exit Function
    End If


    LastCNC_gcode = CNC_gcode             'Set new defaults
    
     
     Select Case Mcopy(low(LineNum), high(LineNum)).G


    Case 65     'Call-Subroutine
        Subptr = Subptr + 1
        ReDim Preserve SubVar(Subptr)
        SubVar(Subptr).LineNum = LineNum
        SubVar(Subptr).Absolute = Absolute_Prog
        SubVar(Subptr).G = CNC_gcode.G

        'X Field has sub name
        'Search program for G28 X
        Tmp = 1
        Do
            If high(Tmp) > UBound(Mcopy, 2) Then
                MsgBox "Subroutine Not Defined"
                Get_LatheGcode = 0
                Exit Function
            Else
                If Mcopy(low(Tmp), high(Tmp)).G = 28 Then
                    If Mcopy(low(Tmp), high(Tmp)).X = Mcopy(low(LineNum), high(LineNum)).X Then
                        LineNum = Tmp + 1
                        Get_LatheGcode = Get_LatheGcode(LineNum, UseToolOff)   'Get First line of subroutine
                        Exit Function
                    End If
                End If
                Tmp = Tmp + 1
            End If
        Loop
        

    Case 28     'Start-Sub
        MsgBox "Start-Subroutine Should Not be called"
        Get_LatheGcode = 0
        Exit Function

    Case 5     'End-Subroutine
        If Subptr = -1 Then
            MsgBox "Subroutine Not Called"
            Get_LatheGcode = 0
            Exit Function
        Else
            LineNum = SubVar(Subptr).LineNum + 1
            Absolute_Prog = SubVar(Subptr).Absolute
            CNC_gcode.G = SubVar(Subptr).G
            
            Subptr = Subptr - 1
            Get_LatheGcode = Get_LatheGcode(LineNum, UseToolOff)     'Get line of mainprog
            Exit Function
        End If

     
     Case 73        'Loop
        If Mcopy(low(LineNum + 1), high(LineNum + 1)).G = 6 Then
            MsgBox "Empty loop"
            Get_LatheGcode = 0
            Exit Function
        End If
        
        
        loopptr = loopptr + 1
        ReDim Preserve LoopVar(loopptr)
        LoopVar(loopptr).LineNum = LineNum

        If Mcopy(low(LineNum), high(LineNum)).X <> NotSet Then
            LoopVar(loopptr).Count = Mcopy(low(LineNum), high(LineNum)).X * Mcopy(low(LineNum), high(LineNum)).steps_to_units
        Else
            LoopVar(loopptr).Count = 1
        End If

        Get_LatheGcode = Get_LatheGcode(LineNum + 1, UseToolOff) 'Get Next Line
        Exit Function
     
     Case 6
        If loopptr <> -1 Then
            LoopVar(loopptr).Count = LoopVar(loopptr).Count - 1
            If LoopVar(loopptr).Count > 0 Then
                Get_LatheGcode = Get_LatheGcode(LoopVar(loopptr).LineNum + 1, UseToolOff)'Get Next Line
                Exit Function
            Else
                loopptr = loopptr - 1
                Get_LatheGcode = Get_LatheGcode(LineNum + 1, UseToolOff) 'Get Next Line
                Exit Function
            End If
        Else
            MsgBox "Not In Loop"
            Get_LatheGcode = 0
            Exit Function
        End If


    Case 70                 'Imperial
        options.metric = 0
        Get_LatheGcode = Get_LatheGcode(LineNum + 1, UseToolOff) 'Get Next Line
        Exit Function

    Case 71                 'Metric
        options.metric = 1
        Get_LatheGcode = Get_LatheGcode(LineNum + 1, UseToolOff) 'Get Next Line
        Exit Function



     Case 33
        CNC_gcode.G = 33
        If Mcopy(low(LineNum), high(LineNum)).X <> NotSet Then CNC_gcode.X = Mcopy(low(LineNum), high(LineNum)).X
        If Mcopy(low(LineNum), high(LineNum)).z <> NotSet Then CNC_gcode.z = Mcopy(low(LineNum), high(LineNum)).z
        If Mcopy(low(LineNum), high(LineNum)).i <> NotSet Then CNC_gcode.i = Mcopy(low(LineNum), high(LineNum)).i
        If Mcopy(low(LineNum), high(LineNum)).k <> NotSet Then CNC_gcode.k = Mcopy(low(LineNum), high(LineNum)).k
        

     Case 38
        CNC_gcode.G = 38
     Case 39
        CNC_gcode.G = 39
     
     Case 90
        Absolute_Prog = True
        Get_LatheGcode = Get_LatheGcode(LineNum + 1, UseToolOff)
        Exit Function
    
     Case 91
        Absolute_Prog = False
        Get_LatheGcode = Get_LatheGcode(LineNum + 1, UseToolOff)
        Exit Function



     Case 92
        CNC_gcode.G = 92
        If Mcopy(low(LineNum), high(LineNum)).X <> NotSet Then CNC_gcode.X = Mcopy(low(LineNum), high(LineNum)).X Else CNC_gcode.X = 0
        If Mcopy(low(LineNum), high(LineNum)).z <> NotSet Then CNC_gcode.z = Mcopy(low(LineNum), high(LineNum)).z Else CNC_gcode.z = 0
        
        xshift = xshift + CNC_gcode.X
        zshift = zshift + CNC_gcode.z

        CNC_gcode.X = LastCNC_gcode.X
        CNC_gcode.z = LastCNC_gcode.z
        
     
     Case 38
        CNC_gcode.G = 38               'Will wait for X clear, Y set

     Case 39        'Set Output
        CNC_gcode.G = 39               'Will use X to clear, Y to set



    Case Else
        If Mcopy(low(LineNum), high(LineNum)).G <> NotSet Then CNC_gcode.G = Mcopy(low(LineNum), high(LineNum)).G
        
        If Absolute_Prog = True Then
            Select Case Mcopy(low(LineNum), high(LineNum)).X
            Case NotSet
            Case Home
                CNC_gcode.X = Lcalib.Tool_x(CNC_gcode.t)
                Xposn = Val(Format$(CNC_gcode.X * stepstomm, "##0.00"))
            Case Else
                CNC_gcode.X = Mcopy(low(LineNum), high(LineNum)).X
                Xposn = Val(Format$(CNC_gcode.X * stepstomm, "##0.00"))
            End Select
            
            Select Case Mcopy(low(LineNum), high(LineNum)).z
            Case NotSet
            Case Home
                CNC_gcode.z = Lcalib.Tool_z(CNC_gcode.t)
                Zposn = Val(Format$(CNC_gcode.z * stepstomm, "##0.00"))
            Case Else
                CNC_gcode.z = Mcopy(low(LineNum), high(LineNum)).z
                Zposn = Val(Format$(CNC_gcode.z * stepstomm, "##0.00"))
            End Select
        Else
            Select Case Mcopy(low(LineNum), high(LineNum)).X
            Case NotSet
            Case Home
                CNC_gcode.X = Lcalib.Tool_x(CNC_gcode.t)
                Xposn = Val(Format$(CNC_gcode.X * stepstomm, "##0.00"))
            Case Else
                Xposn = Xposn + Val(Format$(Mcopy(low(LineNum), high(LineNum)).X * stepstomm, "##0.00"))
                Tmp = Xposn * mmtosteps
                
                Select Case Tmp
                Case Is < -14
                    Tmp = 0
                    MsgBox "Data clamped in line " + Format$(LineNum)
                Case Is < 0
                    Tmp = 0         'Clamped
                Case Is > 8 * intosteps
                    Tmp = 8 * intosteps
                    MsgBox "Data clamped in line " + Format$(LineNum)
                End Select
                CNC_gcode.X = Tmp
            End Select
            
            Select Case Mcopy(low(LineNum), high(LineNum)).z
            Case NotSet
            Case Home
                CNC_gcode.z = Lcalib.Tool_z(CNC_gcode.t)
                Zposn = Val(Format$(CNC_gcode.z * stepstomm, "##0.00"))
            Case Else
                Zposn = Zposn + Val(Format$(Mcopy(low(LineNum), high(LineNum)).z * stepstomm, "##0.00"))
                Tmp = Zposn * mmtosteps
                
                Select Case Tmp
                Case Is < -14
                    Tmp = 0
                    MsgBox "Data clamped in line " + Format$(LineNum)
                Case Is < 0
                    Tmp = 0
                Case Is > 3 * intosteps
                    Tmp = 3 * intosteps
                    MsgBox "Data clamped in line " + Format$(LineNum)
                End Select
                CNC_gcode.z = Tmp
            End Select
        End If
        If Mcopy(low(LineNum), high(LineNum)).i <> NotSet Then CNC_gcode.i = Abs(Mcopy(low(LineNum), high(LineNum)).i)
        If Mcopy(low(LineNum), high(LineNum)).k <> NotSet Then CNC_gcode.k = Abs(Mcopy(low(LineNum), high(LineNum)).k)
    
    End Select

    
    If UseToolOff Then
        DesX = Lcalib.Tool_x(CNC_gcode.t) - CNC_gcode.X
        If DesX < 0 Then
            DesX = 0: MsgBox "X maximum is" + Format$(Lcalib.Tool_x(CNC_gcode.t) * stepstomm, " #0.00")
            Get_LatheGcode = 0
            Exit Function
        End If
        Select Case CNC_gcode.G
        Case 33, 83
            DesZ = CNC_gcode.z
        Case Else
            DesZ = Lcalib.Tool_z(CNC_gcode.t) - CNC_gcode.z
            If DesZ < 0 Then
                DesZ = 0: MsgBox "Z maximum is" + Format$(Lcalib.Tool_z(CNC_gcode.t) * stepstomm, " #0.00")
                Get_LatheGcode = 0
                Exit Function
            End If
        End Select
    Else
        Select Case CNC_gcode.G
            Case 0, 1, 2, 3, 92
                DesX = CNC_gcode.X + xshift
                DesZ = CNC_gcode.z + zshift
            Case 33, 83
                DesZ = CNC_gcode.z          'Incremental move
        End Select
    End If


End Function

Sub Lathe_addline ()
Dim emptyline

    If curline = 1 Then
        If tmp_gcode(low(curline), high(curline)).G = NotSet Then Exit Sub
        emptyline = False
    Else
        emptyline = True
        If tmp_gcode(low(curline), high(curline)).G <> tmp_gcode(low(curline - 1), high(curline - 1)).G Then emptyline = False Else tmp_gcode(low(curline), high(curline)).G = NotSet
        If tmp_gcode(low(curline), high(curline)).X <> tmp_gcode(low(curline - 1), high(curline - 1)).X Then emptyline = False Else tmp_gcode(low(curline), high(curline)).X = NotSet
        If tmp_gcode(low(curline), high(curline)).z <> tmp_gcode(low(curline - 1), high(curline - 1)).z Then emptyline = False Else tmp_gcode(low(curline), high(curline)).z = NotSet
        If tmp_gcode(low(curline), high(curline)).i <> tmp_gcode(low(curline - 1), high(curline - 1)).i Then emptyline = False
        If tmp_gcode(low(curline), high(curline)).j <> tmp_gcode(low(curline - 1), high(curline - 1)).j Then emptyline = False
        If tmp_gcode(low(curline), high(curline)).pen <> NotSet Then emptyline = False
        If tmp_gcode(low(curline), high(curline)).t <> NotSet Then emptyline = False
        If tmp_gcode(low(curline), high(curline)).m <> NotSet Then emptyline = False
    End If
    
    If Not emptyline Then
        If high(curline + 1) > UBound(tmp_gcode, 2) Then
            ReDim Preserve tmp_gcode(1 To CHUNK, 0 To UBound(tmp_gcode, 2) + 1)         'Faster to add as many as possible
        End If
        
        curline = curline + 1                               'Point to next line
        tmp_gcode(low(curline), high(curline)) = tmp_gcode(low(curline - 1), high(curline - 1))     'Seed next line
        tmp_gcode(low(curline), high(curline)).remarkPtr = 0
        
        tmp_gcode(low(curline), high(curline)).F = NotSet
        tmp_gcode(low(curline), high(curline)).S = NotSet
        tmp_gcode(low(curline), high(curline)).t = NotSet
        tmp_gcode(low(curline), high(curline)).pen = NotSet
        tmp_gcode(low(curline), high(curline)).d = NotSet
        tmp_gcode(low(curline), high(curline)).m = NotSet
    End If

End Sub

Sub Lathe_Addline1 ()

Dim i As Integer

curline = 1

'import_filename$ = "Roger.ex1"
'CNCFRMDAT(CNCfrmNo).Filename = Left$(import_filename$, Len(import_filename$) - 4) + ".NCL"

ReDim tmp_gcode(1 To CHUNK, 0 To 0)

tmp_gcode(low(curline), high(curline)).G = NotSet
tmp_gcode(low(curline), high(curline)).X = NotSet
tmp_gcode(low(curline), high(curline)).z = NotSet
tmp_gcode(low(curline), high(curline)).i = NotSet
tmp_gcode(low(curline), high(curline)).k = NotSet
tmp_gcode(low(curline), high(curline)).t = 1
tmp_gcode(low(curline), high(curline)).F = NotSet
tmp_gcode(low(curline), high(curline)).S = NotSet


If options.metric Then
    tmp_gcode(low(curline), high(curline)).steps_to_units = stepstomm      'Default to mm input
    tmp_gcode(low(curline), high(curline)).G = 71
Else
    tmp_gcode(low(curline), high(curline)).steps_to_units = stepstoin      'Imperial
    tmp_gcode(low(curline), high(curline)).G = 70
End If

tmp_gcode(low(curline), high(curline)).m = 68       'Close vice
Lathe_addline

tmp_gcode(low(curline), high(curline)).G = 90
tmp_gcode(low(curline), high(curline)).F = 2
tmp_gcode(low(curline), high(curline)).S = 6
tmp_gcode(low(curline), high(curline)).m = 3        'Spindle on
Lathe_addline


End Sub

Sub lathe_addlinelast ()


Lathe_addline


tmp_gcode(low(curline), high(curline)).m = 5        'Spindle off
Lathe_addline

'tmp_gcode(LOW(curline), HIGH(curline)).m = 69        'Spindle off
'Lathe_addline





insert_rows = curline - 1
Lathe_compress
CNCfrm(CNCFrmNo).EditFunc.Caption = "Get"   'Give copy of prog to Lathe Form

End Sub

Sub Lathe_compress ()
'copy tmp_gcode to mcopy

Dim i As Long
Dim highi As Integer
Dim lowi As Integer

ReDim Mcopy(1 To UBound(tmp_gcode, 1), 0 To UBound(tmp_gcode, 2))    'No extra lines
    
Dim DefaultG
Dim DefaultX
Dim DefaultZ
    
    DefaultG = NotSet
    DefaultX = NotSet
    DefaultZ = NotSet

    For i = 1 To insert_rows
        highi = high(i): lowi = low(i)
        Select Case tmp_gcode(lowi, highi).G
            Case NotSet
            Case DefaultG
                tmp_gcode(lowi, highi).G = NotSet
            Case Else
                DefaultG = tmp_gcode(lowi, highi).G
        End Select
        Mcopy(lowi, highi).G = tmp_gcode(lowi, highi).G

        Select Case tmp_gcode(lowi, highi).X
            Case NotSet
            Case DefaultX
                tmp_gcode(lowi, highi).X = NotSet
            Case Else
                DefaultX = tmp_gcode(lowi, highi).X
        End Select
        Mcopy(lowi, highi).X = tmp_gcode(lowi, highi).X
        
        Select Case tmp_gcode(lowi, highi).z
            Case NotSet
            Case DefaultZ
                tmp_gcode(lowi, highi).z = NotSet
            Case Else
                DefaultZ = tmp_gcode(lowi, highi).z
        End Select
        Mcopy(lowi, highi).z = tmp_gcode(lowi, highi).z
        
        Mcopy(lowi, highi).i = tmp_gcode(lowi, highi).i
        Mcopy(lowi, highi).k = tmp_gcode(lowi, highi).k
        
        Mcopy(lowi, highi).F = tmp_gcode(lowi, highi).F
        Mcopy(lowi, highi).S = tmp_gcode(lowi, highi).S
        Mcopy(lowi, highi).t = tmp_gcode(lowi, highi).t
        
        Mcopy(lowi, highi).d = tmp_gcode(lowi, highi).d
        Mcopy(lowi, highi).m = tmp_gcode(lowi, highi).m
        Mcopy(lowi, highi).steps_to_units = tmp_gcode(lowi, highi).steps_to_units
        Mcopy(lowi, highi).remarkPtr = tmp_gcode(lowi, highi).remarkPtr
    Next



End Sub

Private Function Rmsgbox (a$) As Integer

Load question
question.Label1 = a$
question.Show 1
Rmsgbox = question.Tag
Unload question


End Function

