include cyber.inc

invert = 0


.code


wait650 macro
	mov cx,19                       ;18 is just enough - 18*33=594
	.repeat
		timer2wait              ;wait 33uSec - 30K
	.untilcxz
	endm

wait75 macro
	mov cx,6                        ;5 is just enough - 5*15=75
	.repeat
		timer2wait              ;wait 33uSec - 30K
	.untilcxz
	endm




mentor_poke macro addr, dat, issue
	IF issue eq 2
		invoke xrj45poke, addr,dat
	else
		poke addr,dat
	endif
	endm

mentor_peek macro addr,issue
	if issue eq 2
		invoke xrj45peek, addr
	else
		peek addr
	endif
	endm




waiteoc macro
comment *
	wait for mentor ADC EOC - turbo bus only
*

	pushall
	mov si,robot.read[bx]
	
	dlwait
	mov al,es:[si+2]
	dlwait
	mov al,es:[si+2]
	and al,1
	
	.if al==1
		call putoffline
	.else
		wait650
		mov al,es:[si+2]
		dlwait
		mov al,es:[si+2]
		and al,1
		.if al!=1
			call putoffline
		.else
			call putonline
		.endif
	.endif
	popall
	endm



waiteoc1 macro
	pushall
	mov si,robot.read[bx]
	
	dlwait
	mov al,es:[si+2]
	dlwait
	mov al,es:[si+2]
	and al,3                        ;look at both ADC's
	
	.if al==0                       ;already converted - error
		call putoffline
	.else
		wait75
		mov al,es:[si+2]
		dlwait
		mov al,es:[si+2]
		and al,3
		.if al!=0               ;should be converted - error
			call putoffline
		.else
			call putonline
		.endif
	.endif
	popall

	endm



waiteoc2 macro
	pushall
	invoke xrj45peek, 2
	and al,3
	.if al==0
		call putoffline
	.else
		wait75
		invoke xrj45peek, 2
		and al,3
		.if al!=0
			call putoffline
		.else
			call putonline
		.endif
	.endif
	popall

	endm




set_wc_pulsestates macro
;sets wc_low and wc_high


	.if robot.pulsestretch[bx]!=0
		mov ax,robot.wc_high[bx]
		;mov robot.wcout[bx],ax
		mov robot.WC.DIG_output[bx+0],ax
	.endif
	
	;mov ax,robot.wcout[bx]   ;current output state
	mov ax,robot.WC.DIG_output[bx+0]
	MOV CX,robot.pulseop[bx]    ;OUTPUT TO PULSE
	mov dx,1
	sal dx,cl                   ;2 to power op-1
	or ax,dx
	mov cx,ax
	sub ax,dx
		
	mov robot.wc_low[bx],ax
	mov robot.wc_high[bx],cx
	;mov robot.wcout[bx],ax

endm


SERVICE_MENTOR_PULSES MACRO issue
	if issue eq 0
		mov di,robot.read[bx]
		add di,3
		add di,robot.pulseop[bx]
		;peek di
		dlwait
		mov al,es:[di]
	else
		set_wc_pulsestates      ;set wc_low and wc_high
		   
		if issue eq 1
			mov di,robot.write[bx]
			add di,7
			poke di,robot.wc_high[bx]
			poke di,robot.wc_low[bx]
		else
			invoke xrj45poke, 7,robot.wc_high[bx]                ;op high
			invoke xrj45poke, 7,robot.wc_low[bx]                 ;op low
		endif
		mov robot.pulsestretch[bx],8             ;keep low for 8 interrupts
		mov ax,robot.wc_low[bx]                  ;this state written for next
		mov robot.WC.DIG_output[bx+0],ax                ;few interrupts - start ADC
	ENDIF
ENDM



WCPulse Macro issue
	if issue eq 1
		mov di,robot.write[bx]      
		add di,7
		mov dx,robot.wc_low[bx]
		mov es:[di],dl
	else
		invoke xrj45poke,7,robot.wc_low[bx]
	endif

					
	if issue eq 1
		mov di,robot.write[bx]      
		add di,7
		mov dx,robot.wc_high[bx]
		mov es:[di],dl
	else
		invoke xrj45poke,7,robot.wc_high[bx]
	endif
Endm



ReadDigInputs Macro Issue

if issue eq 0                           ;Turbo bus mentor
	mov di,robot.read[bx]
	add di,2
	peek di
	test ax,2
	.if zero?
		mov robot.WC.DIG_inputs[bx+0],0
	.else
		mov robot.WC.DIG_inputs[bx+0],1
	.endif

	test ax,4
	.if zero?
		mov robot.WC.DIG_inputs[bx+2],0
	.else
		mov robot.WC.DIG_inputs[bx+2],1
	.endif
Else
if issue eq 1                           ;RJ45/Turbo bus mentor
	push cx
	mov di,robot.read[bx]
	add di,3
	peek di
				
	mov cx,1
	mov di,0
	.repeat
		test ax,cx
		.if zero?
			mov robot[bx].WC.DIG_inputs[di],0
		.else
			mov robot[bx].WC.DIG_inputs[di],1
		.endif
		shl cx,1
		add di,2
	.until di==16
	pop cx

Else                       

	push cx
	invoke xrj45peek, 3         ;read inputs
				
	mov cx,1
	mov di,0
	.repeat
		test ax,cx
		.if zero?
			mov robot[bx].WC.DIG_inputs[di],0
		.else
			mov robot[bx].WC.DIG_inputs[di],1
		.endif
		shl cx,1
		add di,2
	.until di==16
	pop cx
EndIf
EndIf
Endm


ReadDigInput Macro Issue
	
	push cx
if issue eq 1                           ;RJ45/Turbo bus mentor
	mov di,robot.read[bx]
	add di,3
	peek di
Else
	invoke xrj45peek, 3         ;read inputs
Endif
	
	mov dx,1
	mov cx,robot[bx].SerialIP
	shl dx,cl
	pop cx

	test ax,dx

Endm






SERVICE_MENTOR MACRO issue

	.if robot.online[bx]!=DEV_UNCONNECT
		.if robot.pulsecount[bx] == 1
			SERVICE_MENTOR_PULSES issue
			mov robot.pulsecount[bx],0
		.ENDIF
	.endif

	
	if issue eq 0                           ;Turbo bus mentor
		settimer2 30000                 ;set timer2 to 30k
	
	elseif issue eq 1                       ;RJ45 mentor on turbo bus
		settimer2 66000                 ;set timer2 to 66k
	
	elseif issue eq 2                       ;RJ45 mentor
		settimer2 66000                 ;set timer2 to 66k
	else
		echo <UNKNOWN MENTOR TYPE>
		.err
	endif


	.IF (robot.teachmode[bx]==EmerStop) 
		MOV robot.teachmode[bx],Keyboard
		mov robot[bx].stop[0],1      ; Stop waist
		mov robot[bx].stop[2],1      ; Stop Shoulder
		mov robot[bx].stop[4],1      ; Stop Elbow
		mov robot[bx].stop[6],1      ; Stop Wrist
		mov robot[bx].stop[8],1      ; Stop Wrist
		mov robot[bx].stop[10],1     ; Stop Gripper
	.ENDIF


	if issue eq 2
		invoke xrj45peek, 2
		and al,4
		.if al==0
			mov robot.SimPres[bx],0         ;Simulator not connected
			.IF (robot.teachmode[bx]==SIMULATOR) || (robot.teachmode[bx]==SIMULATOR2)
				mov robot.teachmode[bx],keyboard
			.endif
		.else
			mov robot.SimPres[bx],1         ;Simulator connected
		.endif
	else
		mov robot.SimPres[bx],1
	endif


	mov robot.inpos[bx],TRUE
	mov cx,0
	mov si,0
	.repeat
		push cx
		xchg cl,ch
		mov cl,4
		sal ch,cl
		mov dl,ch
		pop cx
		ADD DL,CL
		if issue eq 2
			mov di,dx
			invoke xrj45poke, 6,di
			invoke xrj45poke, 7,robot.WC.DIG_output[bx+0]
			waiteoc2
			invoke xrj45peek, 0
		else
			mov di,robot.write[bx]
			add di,6
			poke di,dx                      ;write mux
			inc di
			poke di,robot.WC.DIG_output[bx+0]      ;start conversion
			IF issue eq 0
				waiteoc                 ;turbo bus model
			ELSE
				waiteoc1                ;rj45/turbo bus model
			endif
			mov di,robot.read[bx]
			peek di
		endif
		
		.if robot.devtype[bx]==MENTOR           ;not yet certain about
							;device type - don't set feedback data
		.else

			   .if robot.teachmode[bx]==SIMULATOR2
				   .if si==3*2
					.if ax>185
						mov ax,185
					.elseif ax<70
						mov ax,70
					.endif
					mov robot[bx].learn[6*2],ax      ;Save data as Elevation
				   .elseif si==4*2
					mov robot[bx].learn[7*2],ax      ;Save data as rotation
				   .else
					mov robot[bx].learn[si],ax       ;save simulator data                       
				   .endif
			   .else
				mov robot[bx].learn[si],ax               ;save simulator data                       
			   .endif

			if issue eq 2
				invoke xrj45peek, 1
			else
				inc di
				peek di                               ;ax == feedback posn 
			endif
		
			.if robot.online[bx]!=DEV_ONLINE                
				mov ax,robot.despos[bx+si]
			.endif
			mov robot.feedback[bx+si],ax
		
			.if (robot.teachmode[bx]==INIT) || (robot[bx].stop[si]!=false)           ;|| (robot.teachmode[bx]==EmerStop) 
				mov robot[bx].despos[si],ax
				mov robot[bx].stop[si],false
			.endif
		
			.if robot.teachmode[bx]==NOSELEAD
				.if si != 10    ;Gripper is still controlled by keyboard
					mov robot.despos[bx+si],ax
				.endif
			.endif

			.if cx!=5                               ;don't test gripper
				sub ax,robot.despos[bx+si]      ;ax now == error
				.if sign?
					mov ax,robot.despos[bx+si]
					sub ax,robot.feedback[bx+si]
				.endif
				.if (ax > 3)                            
					mov robot.inpos[bx],FALSE
				.endif
			.else
				mov ax,robot.lastfeedback[bx+si]
				sub ax,robot.feedback[bx+si]
				.if sign?
					mov ax,robot.feedback[bx+si]
					sub ax,robot.lastfeedback[bx+si]
				.endif
				.if (ax > 1)                            
					mov robot.inpos[bx],FALSE
					mov robot.samefeedbackcnt[bx+si],0
					mov ax,robot.feedback[bx+si]
					mov robot.lastfeedback[bx+si],ax
				.else
					.if robot.samefeedbackcnt[bx+si] != 18
						mov robot.inpos[bx],FALSE
						inc robot.samefeedbackcnt[bx+si]
					.else
						mov ax,robot.despos[bx+si]
						.if robot.lastdespos[bx+si] != ax
							mov robot.lastdespos[bx+si],ax
							mov robot.inpos[bx],FALSE
							mov robot.samefeedbackcnt[bx+si],0
						.endif
					.endif
				.endif
			.endif
		.endif
		
		inc cx
		add si,2
	.until cx==6


comment *        
	Compute Elevation - If its in the valid range of 70 to 185
	then use the new data - else carry on with the old

	Compute Axes 3 and 4

*

	.if robot.teachmode[bx]>=SIMULATOR
		mov dx,false    ;Don't use simulator data
	
		.if robot.teachmode[bx]==SIMULATOR
			mov ax,robot[bx].learn[(3*2)]
			add ax,robot[bx].learn[(4*2)]
			shr ax,1
			.if (ax>=70) && (ax<=185)
				mov dx,true
			.endif
		.elseif robot.teachmode[bx]==SIMULATOR2
			mov ax,128
			add ax,robot[bx].learn[6*2]
			sub ax,robot[bx].learn[7*2]
			mov robot[bx].learn[4*2],ax
			
			.if !sign? && (ax<=255)
				mov ax,robot[bx].learn[6*2]
				add ax,robot[bx].learn[6*2]
				sub ax,robot[bx].learn[4*2]
				mov robot[bx].learn[3*2],ax
				.if !sign? && (ax<=255)
					mov dx,true
				.endif
			.endif

		.endif
		
		
		.if dx==true    ;Simulator data is good use it
			MOV SI,0
			MOV CX,8
			.REPEAT
				mov ax,robot.learn[bx+SI]
				mov robot.despos[bx+si],ax      ;in simulator mode - set desired  position
				ADD SI,2
			.UNTILCXZ
		.else
			
			;ONLY USE 0,1,2 AND 5
			mov ax,robot.learn[bx+0]
			mov robot.despos[bx+0],ax   
			mov ax,robot.learn[bx+1*2]
			mov robot.despos[bx+1*2],ax 
			mov ax,robot.learn[bx+2*2]
			mov robot.despos[bx+2*2],ax 
			
			mov ax,robot.learn[bx+5*2]
			mov robot.despos[bx+5*2],ax 

		.endif
	
	.endif

	if issue eq 0
	
	else        
		.if robot.pulsestretch[bx]!=0
			dec robot.pulsestretch[bx]
			.if robot.pulsestretch[bx]==0
				mov ax,robot.wc_high[bx]
				mov robot.WC.DIG_output[bx+0],ax
			.endif
		.endif
	
		.if robot.Serialflag[bx] == true   
			Mov robot.Serialflag[bx],False
			set_wc_pulsestates

			mov robot[bx].SerialOP,0
			
			mov cx,16
			.repeat
				WCPulse issue                   ;Low then High
				ReadDigInput Issue
				.if zero?
					CLC
				.else
					STC
				.endif
				rcl robot[bx].SerialOP,1
			.untilcxz
		.endif
		
		
		
		
		.if robot.rs232flag[bx] == true          ;data to be sent out as rs232
			mov robot.rs232flag[bx],false    ;via robot output
			set_wc_pulsestates      ;set wc_low and wc_high
			
			if invert eq 1
				mov ax,robot.wc_low[bx]          ;ax==low
				xchg ax,robot.wc_high[bx]        ;ax=high
				mov robot.wc_low[bx],ax 
			endif
			
			pushf                           ;disable interrupts 
			cli                             ;- want acurate timing
			settimer2 9600                  ;set timer 2 to toggle at 9600Hz
			mov si,robot.rs232data[bx]       ;word to be transmitted
			timer2wait                              ;wait for timer 2 flag toggle                     
			if issue eq 1
				mov di,robot.write[bx]       ;send start bit
				add di,7
				mov dx,robot.wc_low[bx]
				mov es:[di],dl
			else
				invoke xrj45poke,7,robot.wc_low[bx]
			endif
		
			mov cx,8
			.repeat
				timer2wait    ;wait for timer 2 flag toggle     AX is used
				rcr si,1
				.if !carry?
					if issue eq 1
						mov dx,robot.wc_low[bx]
						mov es:[di],dl
					else
						invoke xrj45poke,7,robot.wc_low[bx]
					endif
				.else
					if issue eq 1
						mov dx,robot.wc_high[bx]
						mov es:[di],dl
					else
						invoke xrj45poke,7,robot.wc_high[bx]
					endif
				.endif
			.untilcxz
			timer2wait                      ;wait for timer 2 flag toggle     
			if issue eq 1
				mov dx,robot.wc_high[bx]     ;send stop bit
				mov es:[di],dl
			else
				invoke xrj45poke,7,robot.wc_high[bx]
			endif
			
			popf                            ;restore interrupt state                    
			
			mov ax,robot.wc_high[bx]    
			mov robot.WC.DIG_output[bx+0],ax
		.endif
	endif


	if issue eq 0                           ;Turbo bus mentor
		ReadDigInputs Issue
		
		mov cx,6
		push cx
		xchg cl,ch
		mov cl,4
		sal ch,cl
		mov dl,ch
		pop cx
		ADD DL,CL
		mov di,robot.write[bx]
		add di,6
		poke di,dx                        ;write mux
		inc di
		poke di,robot.WC.DIG_output[bx+0]       ;start conversion
		waiteoc              
		mov di,robot.read[bx]
		peek di
		mov robot.WC.ANA_inputs[bx+0],ax
		inc di
		peek di        
		mov robot.WC.ANA_inputs[bx+4],ax
		
		
		mov cx,7
		push cx
		xchg cl,ch
		mov cl,4
		sal ch,cl
		mov dl,ch
		pop cx
		ADD DL,CL
		mov di,robot.write[bx]
		add di,6
		poke di,dx                         ;write mux
		inc di
		poke di,robot.WC.DIG_output[bx+0]       ;start conversion
		waiteoc              
		mov di,robot.read[bx]
		peek di
		mov robot.WC.ANA_inputs[bx+2],ax
		inc di
		peek di        
		mov robot.WC.ANA_inputs[bx+6],ax
	
	else
		if issue eq 1                           ;RJ45/Turbo bus mentor
			ReadDigInputs Issue
			
			mov cx,6
			push cx
			xchg cl,ch
			mov cl,4
			sal ch,cl
			mov dl,ch
			pop cx
			ADD DL,CL
			mov di,robot.write[bx]
			add di,6
			poke di,dx                        ;write mux
			inc di
			poke di,robot.WC.DIG_output[bx+0]       ;start conversion
			waiteoc1              
			mov di,robot.read[bx]
			peek di
			mov robot[bx].WC.ANA_inputs[4],ax
			inc di
			peek di        
			mov robot[bx].WC.ANA_inputs[0],ax
			
			
			mov cx,7
			push cx
			xchg cl,ch
			mov cl,4
			sal ch,cl
			mov dl,ch
			pop cx
			ADD DL,CL
			mov di,robot.write[bx]
			add di,6
			poke di,dx                         ;write mux
			inc di
			poke di,robot.WC.DIG_output[bx+0]       ;start conversion
			waiteoc1              
			mov di,robot.read[bx]
			peek di
			mov robot[bx].WC.ANA_inputs[6],ax
			inc di
			peek di        
			mov robot[bx].WC.ANA_inputs[2],ax
		
		else                            ;RJ45 mentor
			ReadDigInputs Issue
			
			
			invoke xrj45poke,6,066H    ;write mux, read ADC channels 6
			invoke xrj45poke,7,robot[bx].WC.DIG_output[0]       ;start conversion
			waiteoc2              
			
			invoke xrj45peek,0
			mov robot[bx].WC.ANA_inputs[4],ax
			
			invoke xrj45peek,1
			mov robot[bx].WC.ANA_inputs[0],ax

			invoke xrj45poke,6,077H    ;write mux
			invoke xrj45poke,7,robot[bx].WC.DIG_output[0]       ;start conversion
			waiteoc2              
			
			invoke xrj45peek,0
			mov robot[bx].WC.ANA_inputs[6],ax
			
			invoke xrj45peek,1
			mov robot[bx].WC.ANA_inputs[2],ax

		endif
	endif


	
	;Make up Elevation and rotation states
	
	mov ax,robot[bx].feedback[(3*2)]
	add ax,robot[bx].feedback[(4*2)]
	shr ax,1
	mov robot[bx].feedback[(6*2)],AX     ;A6 =(A3+A4)/2           

	MOV AX,255
	ADD ax,robot[bx].feedback[(3*2)]
	SUB ax,robot[bx].feedback[(4*2)]
	shr ax,1
	mov robot[bx].feedback[(7*2)],AX     ;A7 =(255+A3-A4)/2
	
	mov ax,robot[bx].despos[(3*2)]
	add ax,robot[bx].despos[(4*2)]
	shr ax,1
	mov robot[bx].despos[(6*2)],AX     ;A6 =(A3+A4)/2           

	MOV AX,255
	ADD ax,robot[bx].despos[(3*2)]
	SUB ax,robot[bx].despos[(4*2)]
	shr ax,1
	mov robot[bx].despos[(7*2)],AX     ;A7 =(255+A3-A4)/2



	.if robot.teachmode[bx]==INIT
		.if robot.online[bx] != DEV_UNCONNECT
		mov robot.teachmode[bx],KEYBOARD
		.endif
	
	.elseif robot.teachmode[bx]==NOSELEAD

	.elseIF (robot.online[bx]==DEV_ONLINE) 
		mov ax,robot[bx].despos[(6*2)]
		.if (ax>=70) && (ax<=185)
			mov si,0
			if issue eq 2
				mov di,0
			else
				mov di,robot.write[bx]
			endif
			mov cx,6
			.repeat
				mentor_poke di,robot.despos[bx+si],issue
				add si,2
				inc di
			.untilcxz
		.endif
	.ENDIF




ENDM


service_turbo_mentor_pulses proc
	SERVICE_MENTOR_PULSES 0
	ret
service_turbo_mentor_pulses endp

service_rj45_turbo_mentor_pulses proc
	SERVICE_MENTOR_PULSES 1
	poke di,robot.wc_high[bx]        ;Things get upset if the ouput is kept low for too long
	ret
service_rj45_turbo_mentor_pulses endp

service_rj45_mentor_pulses proc
	SERVICE_MENTOR_PULSES 2
	invoke xrj45poke, 7,robot.wc_high[bx]     ;Things get upset if the ouput is kept low for too long
	ret
service_rj45_mentor_pulses endp



service_turbo_mentor proc

comment *        
	ADC conversion times
	116uSec @ 640KHz
	116 x 640/125 = 594usec @ 125KHz

	Set timer2 to 30K - gives toggle period of 33usec
	33 x 18 = 594uSec
*
	SERVICE_MENTOR 0
	settimer2 66000                 ;set timer2 to 66k
	ret
service_turbo_mentor endp


service_rj45_turbo_mentor proc

comment *        
	ADC conversion times
	116uSec @ 640KHz
	116 x 640/1000 = 75usec @ 1MHz

	Set timer2 to 66K - gives toggle period of 15usec
	15 x 5 = 75uSec
*
	SERVICE_MENTOR 1
	settimer2 66000                 ;set timer2 to 66k
	ret
service_rj45_turbo_mentor endp



service_rj45_mentor proc
	SERVICE_MENTOR 2
	settimer2 66000                 ;set timer2 to 66k
	ret
service_rj45_mentor endp




getmentorissue proc

comment *

Issue 1 EOC lines bits 0 and 7 - high when converted - 650 usec conversion
Issue 2 EOC lines bit 0 and 1 - low when converted - 75 usec conversion

*

	mov robot.online[bx],DEV_UNCONNECT
	
	.if robot.write[bx] != -1               ;If its rj45 write==-1
		mov ax,es
		.if ax != 0
			mov si,robot.read[bx]
			mov di,robot.write[bx]
			add di,7
			poke di,robot.WC.DIG_output[bx+0]               ;start conversion
			dlwait
			mov al,es:[si+2]
			dlwait
			mov al,es:[si+2]
			and al,1
			;will equal 0 or 3
			;if 0 could be turbo or offline
			;if 3 could be rj45 or offline
			.if al==0       ;could be turbo or offline
				settimer2 30000                 ;set timer2 to 30k
				poke di,robot.WC.DIG_output[bx+0]                      ;start conversion
				wait650
				mov al,es:[si+2]
				dlwait
				mov al,es:[si+2]
				and al,1
				.if al==1
					CALL service_turbo_mentor               ;check robot is real
					.IF robot.online[bx]!=DEV_UNCONNECT
						mov robot.devtype[bx],MENTOR+0100h
					.endif
				.endif
		
			.elseif al==1                           ;could be rj45 or offline
				settimer2 66000                 ;set timer2 to 66k
				poke di,robot.WC.DIG_output[bx+0]                     ;start conversion
				wait75
				mov al,es:[si+2]
				dlwait
				mov al,es:[si+2]
				and al,3
				.if al==0
					CALL service_rj45_turbo_mentor          ;check robot is real
					.IF robot.online[bx]!=DEV_UNCONNECT
						mov robot.devtype[bx],MENTOR+0200h
					.endif
				.endif
			.endif
		.endif
	.else
		.if rj45base != 0    
			settimer2 66000
			invoke xrj45poke, 7,robot.WC.DIG_output[bx+0]                      ;start conversion    
			invoke xrj45peek, 2
			and al,3
			.if al==3
				invoke xrj45poke, 7,robot.WC.DIG_output[bx+0]              ;start conversion    
				wait75
				invoke xrj45peek, 2
				and al,3
				.if al==0
					CALL service_rj45_mentor            ;check robot is real
					.IF robot.online[bx]!=DEV_UNCONNECT
						mov robot.devtype[bx],MENTOR+0300h
					.endif
				.endif
			.endif
		.endif
		
	.endif
	
	.if robot.online[bx]==DEV_UNCONNECT                 ;still not found simulate
		call service_mentor_offline
	.endif

	ret
getmentorissue endp



service_mentor_offline proc
	
	.if robot[bx].teachmode == init
		mov robot[bx].teachmode,keyboard
		mov robot[bx].despos[0],128
		mov robot[bx].despos[2],128
		mov robot[bx].despos[4],128
		mov robot[bx].despos[6],128
		mov robot[bx].despos[8],128
		mov robot[bx].despos[10],128
		mov robot[bx].despos[12],128
		mov robot[bx].despos[14],128
		mov robot[bx].despos[16],128
		mov si,0
		.repeat
			mov ax,robot[bx].despos[si]
			mov robot[bx].lastdespos[si],ax
			mov robot[bx].feedback[si],ax
			add si,2
		.until si==18

	.endif
	
	
	mov robot.inpos[bx],TRUE        
;        mov si,0                        ;not present - fudge all the data
;        .repeat
;                mov robot[bx].stop[si],false
;                
;                mov ax,robot.despos[bx+si]
;                mov robot.learn[bx+si],ax
;                .if ax > robot.feedback[bx+si]
;                        inc robot.feedback[bx+si]
;                        mov robot.inpos[bx],FALSE
;                .elseif ax < robot.feedback[bx+si]
;                        dec robot.feedback[bx+si]
;                        mov robot.inpos[bx],FALSE
;                .endif
;                add si,2
;        .until si==12

	simulate 0,2
	simulate 1,2
	simulate 2,2
	simulate 3,2
	simulate 4,2
	simulate 5,10
	
	
	mov robot.pulsecount[bx],0

	mov robot.Serialflag[bx],false
	
	mov robot.rs232flag[bx],false


	;Make up Elevation and rotation states
	
	mov ax,robot[bx].feedback[(3*2)]
	add ax,robot[bx].feedback[(4*2)]
	shr ax,1
	mov robot[bx].feedback[(6*2)],AX     ;A6 =(A3+A4)/2           

	MOV AX,255
	ADD ax,robot[bx].feedback[(3*2)]
	SUB ax,robot[bx].feedback[(4*2)]
	shr ax,1
	mov robot[bx].feedback[(7*2)],AX     ;A7 =(255+A3-A4)/2
	
	mov ax,robot[bx].despos[(3*2)]
	add ax,robot[bx].despos[(4*2)]
	shr ax,1
	mov robot[bx].despos[(6*2)],AX     ;A6 =(A3+A4)/2           

	MOV AX,255
	ADD ax,robot[bx].despos[(3*2)]
	SUB ax,robot[bx].despos[(4*2)]
	shr ax,1
	mov robot[bx].despos[(7*2)],AX     ;A7 =(255+A3-A4)/2


	ret
service_mentor_offline endp



;putoffline proc near private
;        .if robot.offlinecnt[bx] != 5
;                inc robot.offlinecnt[bx]
;        .else
;                mov robot.online[bx],DEV_UNCONNECT
;
;                mov ax,robot.devtype[bx]        ;clear device id
;                mov ah,0                        ;but keep 
;                mov robot.devtype[bx],ax        ;device type
;        .endif
;        ret
;putoffline endp
;
;putonline proc near private
;        ;inc robot.onlinecnt[bx]
;        .IF robot.online[bx]!=DEV_OFFLINE
;                mov robot.online[bx],DEV_ONLINE
;        .ENDIF
;        mov robot.offlinecnt[bx],0
;        ret
;putonline endp



end


sendrs232  proc databyte:word
;sends one byte using expansion board output 1
	
	pushf                           ;disable interrupts 
	cli                             ;- want acurate timing
	
	settimer2 9600                  ;set timer 2 to toggle at 9600Hz
	mov dx,databyte
	xor dx,0ffh
	
	timer2wait                      ;;wait for timer 2 flag toggle                     
	mov es:[0e0h+14],byte ptr 1     ;send start bit
	mov cx,8
	.repeat
		timer2wait              ;wait for timer 2 flag toggle     
		mov es:[0e0h+14],dl     ;send D0 to D7
		ror dx,1
	.untilcxz
	timer2wait                      ;wait for timer 2 flag toggle     
	mov es:[0e0h+14],byte ptr 0     ;send stop bit
	
	popf                            ;restore interrupt state                    

	ret
sendrs232 endp




end
