Option Explicit
Option Compare Text
DefInt A-Z

Sub CellEditMenu (index)
    
Dim i, j, k
    
    Select Case index
    Case 1
        i = Definitions.Table1.RowIndex
        If MsgBox("Are you sure that you want to delete " + Definitions.Table1.ColumnText(1), MB_ICONQUESTION + mb_yesno) = idyes Then
            If devref(i) < 128 Then
                For j = 0 To UBound(subdev) 'Go through sub devices and delete refs to device
                    For k = 0 To 5
                        If subdev(j).Control_device(k) = devref(i) + 1 Then clearsubdev (j)
                    Next
                Next
                delete_device devref(i)
            Else
                clearsubdev (devref(i) - 128)
            End If
            redraw_devicegrid
        End If

    Case 2
        i = Definitions.Table1.RowIndex
        edit_subdev = devref(i) - 128
        editsubdev


    Case 3
        If MsgBox("Are you sure you want to delete all sub-devices", mb_yesno Or MB_ICONQUESTION) = idyes Then
            ReDim subdev(0)
            subdev(0).DevType = WC_UNDEF
            redraw_devicegrid
        End If
    End Select

End Sub

Sub CellMenu (index As Integer)
Dim i As Integer
Dim j As Integer
Dim k As Integer

    Select Case index
    Case 0 To 10
        Select Case index
            Case 0 To 9
                newdevtype = index + 2
            Case 10
                newdevtype = GryphonSlide
        End Select
        
        Devaddr = -1
        Select Case newdevtype
            Case Neptune1, Neptune2
                turbosel.Show 1
            Case Mentor, serpent1, serpent2, Xboard                     'Mentor and serpent  can be on either RJ45 or Turbo Board
                devselad.Show 1                                 'devaddr will be returned
            Case CncMill, CNCLathe, Gryphon, GryphonSlide, Kestrel   'Only on RJ45 board
                rj45sel.Show 1                                  'devaddr will be returned
        End Select
        If Devaddr <> -1 Then
            Select Case newdevtype
                Case serpent1
                    If Devaddr >= 16 Then newdevtype = SerpentEC1
                Case serpent2
                    If Devaddr >= 16 Then newdevtype = SerpentEC2
            End Select
            
            makeeditpane newdevtype, -1
            redraw_devicegrid
        End If
    
    Case 12     'Seperator
    
    Case 13 To 21
        Select Case index
        Case 13
            index = WC_CONV
        Case 14
            index = WC_itab
        Case 15
            index = wc_part
            If findsubdev(1, WC_CONV) > UBound(subdev) Then
                MsgBox "No Conveyors Available To Mount Dispenser On"
                Exit Sub
            End If
        Case 16
            index = WC_wgag
        Case 17
            index = WC_DIGwgag
        Case 18
            index = WC_vgag
        Case 19
            index = WC_DIGvgag
        Case 20
            index = WC_digsens
        Case 21
            index = WC_anasens
        End Select
        edit_subdev = -1
        Do
            edit_subdev = edit_subdev + 1
            If edit_subdev > UBound(subdev) Then ReDim Preserve subdev(edit_subdev)
        Loop Until subdev(edit_subdev).DevType = 0
        
        subdev(edit_subdev).DevType = index
        editsubdev


    End Select






End Sub

Sub FileMenu (index As Integer)

Dim Db
Dim sample As String * 1024
Dim i As Integer
Dim j As Integer
Dim inifile$
Dim a$

Select Case index
Case 0
    If Not CancelChanges() Then
        clear_all
        WalliDat(0).name = "Main"    'load in main walli edit pane
        walli_ed(0).Caption = "Main"
        redraw_devicegrid
    End If

Case 1  'open
    openwalli True

Case 2  'Save Project
    i = saveall(False)

Case 3 'Saveas
    i = saveall(True)

Case 5      'Load
    loadgrid

Case 6      'Save
    i = Savegrid(False)

Case 7       'Save as
    i = Savegrid(True)

Case 8  'Import
    Select Case CNCFrmDat(CNCFrmNo).DevType
    Case CncMill
        TimerForm.CMDialog1.DefaultExt = ""
        TimerForm.CMDialog1.Filename = import_filename$
        TimerForm.CMDialog1.Flags = &H400& Or &H1000& Or &H4& Or &H800&
        TimerForm.CMDialog1.Filter = "HPGL|*.prt;*.prn;*.plt|NC Drill|*.0??;*.drl;*.ht?|DXF|*.dxf|ASCII|*.txt;*.lst|GERBER|*.G??"
        
        a$ = import_filename$
        Do
            i = InStr(a$, ".")
            If i <> 0 Then a$ = Right$(a$, Len(a$) - i)
        Loop Until i = 0
        Select Case a$
            Case "PRT", "PRN", "PLT"
                TimerForm.CMDialog1.FilterIndex = 1
            Case "DXF"
                TimerForm.CMDialog1.FilterIndex = 3
            Case "TXT", "LST"
                TimerForm.CMDialog1.FilterIndex = 4
            Case "G10"
                TimerForm.CMDialog1.FilterIndex = 5
            Case Else
                TimerForm.CMDialog1.FilterIndex = 2
        End Select
        
        
        TimerForm.CMDialog1.DialogTitle = "File Import For " + CNCFrmDat(CNCFrmNo).name
        On Local Error GoTo file_err
        TimerForm.CMDialog1.Action = 1
        On Local Error GoTo 0
        import_filename$ = UCase$(TimerForm.CMDialog1.Filename)      'Import_filename$ is global

        outhandle = FreeFile
        Open TimerForm.CMDialog1.Filename For Binary Access Read As outhandle
        Get #outhandle, , sample            'Read part of file
        Close #outhandle
        If InStr(sample, "SECTION") <> 0 Then
            If DXF_MillImport() Then
                DoEvents
                i = Savegrid(True)
            End If
        ElseIf InStr(sample, "IN") <> 0 Then
            hpgl_millimport
            DoEvents
            i = Savegrid(True)
        ElseIf InStr(sample, "M48") <> 0 Then
            ncdrill_import
            DoEvents
            i = Savegrid(True)
        ElseIf InStr(sample, "G0") <> 0 Then
            ascii_import
            DoEvents
            i = Savegrid(True)
        ElseIf InStr(sample, "D0") <> 0 Then
            Gerber_Import
            Db = True
            If Dir$(app.Path + "\VBDB300.DLL") = "" Then Db = False
            If Dir$(app.Path + "\MSAJT110.DLL") = "" Then Db = False
            If Dir$(app.Path + "\MSAES110.DLL") = "" Then Db = False
            If Db = True Then
                Gerber_OutLine
                DoEvents
                i = Savegrid(True)
            Else
                a$ = "The following files are required to import a gerber image:-"
                If Dir$(app.Path + "\VBDB300.DLL") = "" Then a$ = a$ & Chr$(13) & "VBDB300.DLL"
                If Dir$(app.Path + "\MSAJT110.DLL") = "" Then a$ = a$ & Chr$(13) & "MSAJT110.DLL"
                If Dir$(app.Path + "\MSAES110.DLL") = "" Then a$ = a$ & Chr$(13) & "MSAES110.DLL"
                MsgBox a$
            End If
        Else
            MsgBox "Unknown format"
        End If
    
    
    Case CNCLathe
        TimerForm.CMDialog1.DefaultExt = ""
        TimerForm.CMDialog1.Filename = import_filename$
        TimerForm.CMDialog1.Flags = &H400& Or &H1000& Or &H4& Or &H800&
        TimerForm.CMDialog1.Filter = "DXF|*.dxf|HPGL|*.prt;*.prn;*.plt|ASCII|*.txt;*.lst"

        a$ = import_filename$
        Do
            i = InStr(a$, ".")
            If i <> 0 Then a$ = Right$(a$, Len(a$) - i)
        Loop Until i = 0
        Select Case a$
            Case "PRT", "PRN", "PLT"
                TimerForm.CMDialog1.FilterIndex = 2
            Case "TXT", "LST"
                TimerForm.CMDialog1.FilterIndex = 3
            Case Else
                TimerForm.CMDialog1.FilterIndex = 1
        End Select


        TimerForm.CMDialog1.DialogTitle = "File Import For " + CNCFrmDat(CNCFrmNo).name
        On Local Error GoTo file_err
        TimerForm.CMDialog1.Action = 1
        On Local Error GoTo 0
        import_filename$ = UCase$(TimerForm.CMDialog1.Filename)      'Import_filename$ is global

        outhandle = FreeFile
        Open TimerForm.CMDialog1.Filename For Binary Access Read As outhandle
        Get #outhandle, , sample            'Read part of file
        Close #outhandle
        
        If InStr(sample, "SECTION") <> 0 Then
            DXF_LatheImport
            DoEvents
            i = Savegrid(True)
        ElseIf InStr(sample, "IN") <> 0 Then
            HPGL_LATHEimport
            DoEvents
            i = Savegrid(True)
        ElseIf InStr(sample, "G0") <> 0 Then
            ascii_import
            DoEvents
            i = Savegrid(True)
        Else
            MsgBox "Unknown format"
        End If

    End Select

Case 9  'Export
    ascii_export

Case 11  'PRINT
    printall


Case 12  'PRINTER setup
    TimerForm.CMDialog1.Flags = &H8& Or &H40&
    TimerForm.CMDialog1.PrinterDefault = True
    On Local Error Resume Next
    TimerForm.CMDialog1.Action = 5
    On Local Error GoTo 0

Case 14  'RS232
    i = Shell("control ports", 1)

Case 16 'Colour
    colourfrm.Show 1


Case 17 'FONT
    TimerForm.CMDialog1.Flags = &H42001          ' &H400& Or &H200& Or
    TimerForm.CMDialog1.Min = 1
    TimerForm.CMDialog1.Max = 24

    TimerForm.CMDialog1.FontName = WalFont.FontName
    TimerForm.CMDialog1.FontBold = WalFont.FontBold
    TimerForm.CMDialog1.FontItalic = WalFont.FontItalic
    TimerForm.CMDialog1.FontSize = WalFont.FontSize
    
    On Local Error GoTo file_err
    TimerForm.CMDialog1.Action = 4
    On Local Error GoTo 0
    WalFont.FontName = TimerForm.CMDialog1.FontName
    WalFont.FontBold = TimerForm.CMDialog1.FontBold
    WalFont.FontItalic = TimerForm.CMDialog1.FontItalic
    WalFont.FontSize = TimerForm.CMDialog1.FontSize
    setfonts

Case 18 'END
    Unload Walli3

Case Else

End Select

file_err:
    Exit Sub


End Sub

Sub HelpMenu (index As Integer)
Dim PID As PromIdType
Dim ver, a$, LF$, i
Dim RETURNEDSTRING$, DEFAULT$


'0 = contents
'1
'2 = About
'3 = bugs

LF = Chr$(10)

Select Case index
Case 0
    winhelp ByVal Walli3.hWnd, ByVal app.Path & "\" & app.HelpFile, ByVal HELP_contents, CLng(0)

Case 1
    winhelp ByVal Walli3.hWnd, ByVal app.Path & "\" & app.HelpFile, ByVal HELP_partialKEY, ByVal ""

Case 2
    winhelp ByVal Walli3.hWnd, ByVal app.Path & "\" & app.HelpFile, ByVal HELP_helponhelp, CLng(0)
    
Case 4                                              'Command Summary
    TimerForm.CMDialog1.HelpFile = app.Path & "\" & app.HelpFile
    TimerForm.CMDialog1.HelpCommand = HELP_context
    TimerForm.CMDialog1.HelpContext = 600
    TimerForm.CMDialog1.Action = 6

Case 5                                              'Learning Walli
    TimerForm.CMDialog1.HelpFile = app.Path & "\" & app.HelpFile
    TimerForm.CMDialog1.HelpCommand = HELP_context
    TimerForm.CMDialog1.HelpContext = 500
    TimerForm.CMDialog1.Action = 6

Case 7
    about.Show 1
    'a$ = "Walli3 Version 1.000 18/12/94" + CRLF
    'a$ = "Walli3 Version 1.001 4/1/95" + LF
    'a$ = "Walli3 V1.003 20/2/95" + LF
    'a$ = "Walli3 Version 1.004 (23/2/94) " + Chr$(169) + " Cybernetic Applications 1994-5" + LF + LF

Case 8
    'MsgBox "RJ45 timeout " + Str$(readminrj()), 64
    For i = 0 To UBound(EditFrmDat)
        Select Case EditFrmDat(i).DevType
        Case Gryphon, GryphonSlide, CncMill, CNCLathe, Kestrel, SerpentEC1, SerpentEC2
            readId i, PID
            If PID.PromVer = "????" Then
                MsgBox "EPROM Version " + PID.PromVer, 64, "About " + EditFrmDat(i).name
            Else
                MsgBox "EPROM Version " + PID.PromVer + " " + PID.PromDate + Chr$(13) + "Checksum " + Hex$(PID.PromCsum) + Chr$(13) + PID.PromCopyright, 64, "About " + EditFrmDat(i).name
            End If
        End Select
    Next
    

End Select


End Sub

Sub next_device ()
Dim i As Integer

'Set focus to next Edit form

If TypeOf Walli3.ActiveForm Is WALLI_EDfrmtype Then
    i = 0
ElseIf TypeOf Walli3.ActiveForm Is RobotFrmType Then
    i = RobotFrmDat(RobotFrmNo).DevNo + 1
ElseIf TypeOf Walli3.ActiveForm Is MillFormType Then
    i = CNCFrmDat(CNCFrmNo).DevNo + 1
ElseIf TypeOf Walli3.ActiveForm Is XboardformType Then
    i = Xfrmdat(XfrmNo).DevNo + 1
End If

Do
    If i > UBound(EditFrmDat) Then i = 0
    Select Case EditFrmDat(i).DevType
        Case 0
            i = i + 1
        Case Xboard
            Xfrm(EditFrmDat(i).Frmno).WindowState = 0
            Xfrm(EditFrmDat(i).Frmno).SetFocus
            Exit Do
        Case CncMill, CNCLathe
            CncFrm(EditFrmDat(i).Frmno).WindowState = 0
            CncFrm(EditFrmDat(i).Frmno).SetFocus
            Exit Do
        Case Else
            RobotFrm(EditFrmDat(i).Frmno).WindowState = 0
            RobotFrm(EditFrmDat(i).Frmno).SetFocus
            Exit Do
    End Select
Loop

End Sub

Sub next_walli ()

Dim i As Integer
i = WalliFrmNo

Do
    i = i + 1
    If i > UBound(walli_ed) Then i = 0
Loop Until WalliDat(i).used = True

walli_ed(i).WindowState = 0
walli_ed(i).SetFocus

End Sub

Sub optMenu (index As Integer)

Dim Robotcntrl  As robotCNTRLtype

    OptMenuChecked(index) = Not OptMenuChecked(index)
    
    
    Select Case index
    Case 0                                  '0 = Graphics On/Off
        If OptMenuChecked(0) Then
            setupgraphics
        Else
            Unload Drawing(0)
            Unload Drawing(1)
            graphicsdevno = -1
        End If
    
    Case 1
        If OptMenuChecked(1) Then setupworkcellstatus Else Unload StatusFrm      '1 = Workcell status
    Case 2
        If OptMenuChecked(2) Then Load WalliCue Else Unload WalliCue
    Case 3
        If OptMenuChecked(3) Then Load MillCue Else Unload MillCue
    Case 4
        If OptMenuChecked(4) Then Load LatheCue Else Unload LatheCue

    Case 6
        READDATA CNCFrmDat(CNCFrmNo).DevNo, Robotcntrl
        If Robotcntrl.online = 0 Then
            MsgBox CNCFrmDat(CNCFrmNo).name + " is not connected", 64, CNCFrmDat(CNCFrmNo).name + " Control Panel"
        Else
            Select Case CNCFrmDat(CNCFrmNo).DevType
            Case CncMill
                Millmanual.Show 1
            Case CNCLathe
                Lathemanual.Show 1
            End Select

        End If

    Case 7
        READDATA CurrentDevno, Robotcntrl
        If Robotcntrl.online = 0 Then
            MsgBox EditFrmDat(CurrentDevno).name + " is not connected", 64, "Test Workcell"
        Else
            Select Case Robotcntrl.DevType
                Case Mentor, Mentor + &H100, Mentor + &H200, Mentor + &H300, serpent1, serpent2, Neptune1, Neptune2
                    mentorwc.Show 1
                Case Xboard, Xboard + &H100
                    Xwc.Show 1
                Case Else
                    millwc.Show 1
            End Select
        End If
    
    Case 9
        setfonts

    End Select


End Sub

Sub printall ()

Dim i As Integer
Dim j As Integer
Dim h As Integer
Dim sh As Integer

    screen.MousePointer = 11    'busy
    
    If Walli_Level = 1 Then
        Select Case EditFrmDat(0).DevType
            Case 0, Xboard
                
            Case CncMill, CNCLathe
                CncFrm(0).EditFunc.Caption = "Print"
                PRINTER.EndDoc

            Case Else
                RobotFrm(0).EDITFUNC.Caption = "Print"
                PRINTER.EndDoc
        End Select

    Else
        Load printwal
        
        sh = printwal.Height - printwal.ScaleHeight
        printwal.CellDef(0).Caption = "Cell Definition"
        j = 1
        For i = 0 To UBound(EditFrmDat)
            Select Case EditFrmDat(i).DevType
                Case 0, CncMill, CNCLathe, Xboard
                Case Else
                    Load printwal.CellDef(j)
                    printwal.CellDef(j).Caption = EditFrmDat(i).name
                    j = j + 1
            End Select
        Next
        
        For i = 0 To UBound(EditFrmDat)
            Select Case EditFrmDat(i).DevType
                Case CncMill, CNCLathe
                    Load printwal.CellDef(j)
                    printwal.CellDef(j).Caption = EditFrmDat(i).name
                    j = j + 1
            End Select
        Next
        
        For i = 0 To UBound(WalliDat)
            If WalliDat(i).used = True Then
                Load printwal.CellDef(j)
                printwal.CellDef(j).Caption = "Walli - " + WalliDat(i).name
                j = j + 1
            End If
        Next


        j = j - 1
        h = printwal.CellDef(0).Top
                                
        For i = 0 To j Step 2
            printwal.CellDef(i).Top = h
            printwal.CellDef(i).Visible = True
            If (i + 1) <= j Then
                printwal.CellDef(i + 1).Top = h
                printwal.CellDef(i + 1).Visible = True
                printwal.CellDef(i + 1).Left = printwal.Command1(2).Left
            End If
            h = h + printwal.CellDef(i).Height
        Next
            
        h = h + printwal.CellDef(0).Height
        printwal.Command1(0).Top = h: printwal.Command1(1).Top = h: printwal.Command1(2).Top = h: printwal.Command1(3).Top = h
        printwal.Height = sh + printwal.Command1(0).Top + printwal.Command1(0).Height * 1.5
        
        printwal.Show 1
    End If
    screen.MousePointer = 0

End Sub

Sub rOBMENU (index As Integer)
    Select Case EditFrmDat(index).DevType
    Case 0
    Case CncMill, CNCLathe
        CncFrm(EditFrmDat(index).Frmno).WindowState = 0
        CncFrm(EditFrmDat(index).Frmno).SetFocus
    Case Xboard
        Xfrm(EditFrmDat(index).Frmno).WindowState = 0
        Xfrm(EditFrmDat(index).Frmno).SetFocus
    Case Else
        RobotFrm(EditFrmDat(index).Frmno).WindowState = 0
        RobotFrm(EditFrmDat(index).Frmno).SetFocus
    End Select

End Sub

Sub SetUpStatus (title$)

Load statusdlg
statusdlg.Caption = title$
centreform statusdlg
showprogress 0
SetWindowPos statusdlg.hWnd, HWND_TOP, 0, 0, 0, 0, &H53&  'Bring window to top    13
DoEvents

End Sub

Sub Tidy_Win (index As Integer)
Dim i As Integer


Select Case index
Case 0
    Walli3.Arrange 3
    For i = 0 To forms.Count - 1
        Setwindowsize forms(i)
    Next

Case 3      'Mentor
    set_editfocus       'sets focus to first/only edit form

Case 6      'Main
    walli_ed(0).WindowState = 0
    walli_ed(0).SetFocus

Case 8
    Definitions.WindowState = 0
    Definitions.SetFocus
End Select


End Sub

