Comment *

*

include cyber.inc





xcal equ 068h
ycal equ 068h+2
zcal equ 068h+4

xback equ 043h
yback equ 044h
zback equ 045h


waitrjfree macro
	push ax
	push cx
	mov dx,rj45base         ;Wait til transmission complete
	mov cx,1000
	.repeat
		in al,dx
		and al,1
	.untilcxz al==0
	pop cx
	pop ax
	endm


.code

service_rj45_mill proc



	.if robot[bx].teachmode==init
		mov di,0
		.repeat
			mov robot[bx].Prom.PromId[di],'?'
			inc di
		.until di== sizeof Prom_Struc
		mov robot[bx].teachmode,keyboard
	.endif


	.if rj45base==0                             ; serial card not present
		mov robot[bx].mesgflag,false     ; do nothing
		mov robot[bx].rs232flag,false
		mov robot[bx].Serialflag,false
		ret
	.endif

	
comment *        
	At start of new program write 255 to locn 28
	Shows that all eight pages have been used.
*
	
	
	.if robot[bx].MillCalib.sendcal != 0
		invoke set8032page, INTERNAL 
		invoke peek_8032,executing           ; Bit-mapped 
		bt ax,6
		.if carry?
			mov robot[bx].MillCalib.sendcal,0
			.if robot[bx].MillCalib.calibrated==0
				invoke set8032page, INTERNAL 

				mov ax,robot[bx].MillCalib.X_calib
				invoke poke_8032,xcal,ax

				mov ax,robot[bx].MillCalib.X_calib
				xchg ah,al
				invoke poke_8032,xcal+1,ax

				mov ax,robot[bx].MillCalib.Y_calib
				invoke poke_8032,ycal,ax

				mov ax,robot[bx].MillCalib.Y_calib
				xchg ah,al
				invoke poke_8032,ycal+1,ax

				mov ax,robot[bx].MillCalib.Z_calib
				invoke poke_8032,zcal,ax

				mov ax,robot[bx].MillCalib.Z_calib
				xchg ah,al
				invoke poke_8032,zcal+1,ax

				mov ax,robot[bx].MillCalib.X_back     ; Send backlash correcetions
				invoke poke_8032,xback,ax
				
				mov ax,robot[bx].MillCalib.Y_back
				invoke poke_8032,yback,ax
				
				mov ax,robot[bx].MillCalib.Z_back
				invoke poke_8032,zback,ax


				;invoke poke_8032,MCNTRL,home_mill
			.endif
		.endif
		ret
	.endif 
	
	
	.if robot[bx].online!=DEV_OFFLINE
		invoke set8032page, 0
		invoke poke_8032, scratch,27
		invoke peek_8032, scratch
		.if al==27
			invoke poke_8032, scratch,72
			invoke peek_8032, scratch
			.if al==72
				.if robot[bx].online==DEV_UNCONNECT
					;invoke set8032page,0
					
					;0 - 3 Prom ID - should be MILL
					;4   Version Number
					;5-  Copyright Notice
					;    CheckSum
					
					mov si,0
					.repeat
						invoke peek_8032,si
						mov robot[bx].Prom.PromId[si],al 
						inc si
					.until si== sizeof Prom_Struc


					invoke set8032page, INTERNAL 

					invoke peek_8032,executing           ; Bit-mapped 
					bt ax,6
					.if !carry?
						invoke poke_8032,MCNTRL,reset_mill
					.endif
					
					mov robot[bx].errors,0
					call putonline
					mov robot[bx].MillCalib.sendcal,1
					ret
				.endif
				call putonline
			.else
				call putoffline
			.endif
		.else
			call putoffline
		.endif
	.endif
	

	.if robot[bx].online==DEV_ONLINE

		invoke set8032page, INTERNAL 

		
		
		invoke peek_8032,XPosn 
		mov cl,al
		invoke peek_8032,XPosn+1 
		mov ch,al
		mov robot[bx].feedback[2],cx 
		
		invoke peek_8032,YPosn 
		mov cl,al
		invoke peek_8032,YPosn+1 
		mov ch,al
		mov robot[bx].feedback[4],cx 
		
		invoke peek_8032,ZPosn 
		mov cl,al
		invoke peek_8032,ZPosn+1 
		mov ch,al
		mov robot[bx].feedback[6],cx 
		
		invoke peek_8032,CurrLine                ;read lsb cur
		mov cl,al
		invoke peek_8032,CurrLine+1 
		mov ch,al
		mov robot[bx].feedback[0],cx
		
		
		invoke peek_8032,spindle_speed       ;read current spindle speed
		mov robot[bx].feedback[8],ax 

		
		invoke peek_8032,executing           ; Bit-mapped 
		;.if ax != robot[bx].inpos
		;    .if ax != robot[bx].lastinpos
		;        mov robot[bx].lastinpos,ax
		;    .else
				mov robot[bx].inpos,ax              ; Bit 0 = executing
		;                                            ; Bit 1 = paused
		;    .endif
		;.endif

		invoke peek_8032,MCNTRL
		mov robot[bx].feedback[10],ax  

		call service_8032_workcell
		

		.if robot[bx].rs232flag==false       ; don't send pages if mill
													; is currently send data


		.if robot[bx].buffer_empty==false
			invoke set8032page, INTERNAL
			.if robot[bx].startmill==true
				mov robot[bx].table_page,2
				invoke poke_8032, table_used,0ffh        ;All pages invalid
			.endif

			
			invoke peek_8032, table_used             ;Read locn 28 - table entries used
								;Bit set high if its been used
		
			mov dx,robot[bx].table_page      ;data in buffer if for page dx
			sub dx,2
		
			bt ax,dx                ;Want it?
			
			.if carry?              ;yes
				;Write 256 bytes to the mill
				
				invoke set8032page, robot[bx].table_page
				mov si,0
				mov robot[bx].csum1,0
				.repeat
					mov al,robot[bx].buffer[si]     ;Read byte from string          
					add robot[bx].csum1,al
					invoke poke_8032, si,ax
					inc si
				.until si==256  
				
				
				;Read them all back
				
				invoke set8032page, robot[bx].table_page
				mov si,0
				mov robot[bx].csum2,0
				.repeat
					invoke peek_8032,si
					add robot[bx].csum2,al
					inc si
				.until si==256

				mov al,robot[bx].csum1
				.if al==robot[bx].csum2
					invoke set8032page, INTERNAL
					mov dx,robot[bx].table_page      ;data in buffer if for page dx
					sub dx,2
					mov ax,0
					bts ax,dx                               ;Set bit for page thats been updated
					invoke poke_8032, table_update,ax        ;8031 should clear corresponding bit in locn 28
					
					mov ax,robot[bx].table_page
					inc ax
					.if ax==10
						mov ax,2
					.endif
					mov robot[bx].table_page,ax
					mov robot[bx].buffer_empty,true

					.if robot[bx].startmill==true
						MOV robot[bx].startmill,FALSE
						;invoke set8032page, INTERNAL
						invoke poke_8032, MCNTRL,process_table       ;Process table
					.endif
				.else
					inc robot[bx].errors
				.endif
			.endif
		.endif

		.endif
		
		
		
		
		
		
		


	.else
		;Mill is offline - clear any flags 
		mov robot[bx].mesgflag,false
		mov robot[bx].rs232flag,false
		mov robot[bx].Serialflag,false
		

	.endif


	
	ret

service_rj45_mill endp





RJout macro addr,data
	ifdif <al>,<data>
		mov al,data
	endif
	mov dx,rj45base
	add dx,addr
	out dx,al
	endm


RJcycle macro cycle,nextaddress

	ifidn <3>,<cycle>       ;Dummy cycle 
		RJout 2,nextaddress
	endif
	
	mov ax,rj45id           ;Need to add ID to cycle
	add ax,cycle
	RJout 4,al

	RJout 8,0               ;Start transmit cycle                       
	waitrjfree
	
	ifidn <0>,<cycle>       ;Write data cycle 
		mov cx,5            ; 10        ******** 6 ok
	endif
	
	ifidn <1>,<cycle>       ;Read data cycle 
		mov cx,5        
	endif
	
	ifidn <2>,<cycle>       ;MSB addr cycle 
		mov cx,5        
	endif
	
	ifidn <3>,<cycle>       ;Dummy cycle 
		mov cx,5            ; 4 FAILS        
	endif


	.repeat                 ;wait for 8031 to process
		timer2wait
	.untilcxz

	
	ifidn <3>,<cycle>
		;waitrjfree      ;Wait for data to be clocked in
		add dx,2
		in al,dx
		mov ah,0
	endif
	
	endm


end
