Option Explicit
Option Compare Text
DefInt A-Z

Dim Curx As Integer         'Current position in steps
Dim curz As Integer         'Current position in steps


Dim Lcalib As LatheCalibType

Dim LineNum As Long


Dim r As Single
Dim xc As Single
Dim zc As Single
Dim dirn As Integer

Global Pass1() As radii_type
Global Pass2() As radii_type

Dim RoughCut  As Integer
Const FinalCut% = .1 * mmtosteps

        
Type ProfileThreadType
    start As Integer
    x  As Integer
    Z  As Integer
    i  As Integer
    k  As Integer
End Type

Type ProfileBoreType
    BoreStart As Integer
    BoreEnd As Integer
End Type


Global ProfileThread() As ProfileThreadType
Global ProfileBore As ProfileBoreType

Private Sub abortexe (Text$)
    LineNum = 0
End Sub

Private Sub Func1 ()

Dim Z As Integer    'Z in .1mm
Dim x As Integer

For Z = curz To desz Step Sgn(desz - curz)
    x = Curx + (DesX - Curx) * CSng(Z - curz) / (desz - curz)
    
    If x < 0 Then
        x = 0
    End If
    
    If Z <= UBound(Radii) Then
        If Radii(Z).radius > x Then
            Radii(Z).radius = x
            'Radii(z).N = LineNum
            'radii(z).G = cnc_gcode.G
        End If
    End If
Next
    
Curx = DesX
curz = desz


    

End Sub

Private Sub Func1b ()
    If ProfileBore.BoreEnd > desz Then ProfileBore.BoreEnd = desz
    curz = desz
End Sub

Private Sub Func2 ()
    If Radii(desz).radius > DesX Then
        Radii(desz).radius = DesX
        'Radii(desz).N = LineNum
        'radii(Desz).G = 1
    End If
    Curx = DesX
    curz = desz
End Sub

Private Sub Func3 ()
    
Dim Z As Integer
Dim x As Integer

For Z = curz To desz Step Sgn(desz - curz)
    If (r ^ 2) - (zc - Z) ^ 2 >= 0 Then              'When rounding down/up its possible to get sqr(-ve) ? oops
        
        x = xc + Sqr((r ^ 2) - (zc - Z) ^ 2) * dirn      'Know rad,Z calc X
        If x < 0 Then x = 0
        
        If Z <= UBound(Radii) Then
        
        If Radii(Z).radius > x Then
            Radii(Z).radius = x
            'Radii(z).N = LineNum
        End If
        End If
    End If
Next

Curx = DesX
curz = desz


End Sub

Private Sub generate_outline ()

Dim i As Integer
Dim j As Integer

    
    INITialise

    curz = 0
    
    For LineNum = 1 To CNCfrm(CNCFrmNo).Table1.Rows
        LineNum = Get_LatheGcode(LineNum, False)        'Returns DesX DesZ in steps
        If LineNum = 0 Then
            Exit For
        End If

        If desz > UBound(Radii) Then
         '   ReDim Preserve radii(desz)
            curz = desz
        Else
            If LineNum = 0 Then
                Exit For
            Else
                LatheGraphic
                If LineNum = 0 Then Exit For
            End If
        End If
    Next
        
    i = 0                                                     'Look for first "zero" rad
    While Radii(i).radius > 10 And (i < UBound(Radii))
        i = i + 1
    Wend
    If i = 0 Then Exit Sub
    If i <> UBound(Radii) Then
        For i = i To UBound(Radii)
            Radii(i).radius = 0
        Next
    End If
    
    'ReDim Preserve Radii(i)
    
    
    'i = UBound(Radii)
    '
    'Do
    '    j = i
    '    i = i - 1
    '
     ''   Do
     '       If i = 0 Then Exit Do
     '       i = i - 1
     '   Loop Until Radii(i).N <> Radii(j).N
     '   If i <> 0 Then
    '        i = i + 1
    '    End If
    
    'Loop Until i = 0
    
    Tool1Pass
    Tool2Pass

End Sub

Private Sub INITialise ()

Dim i As Integer



CNCfrm(CNCFrmNo).EditFunc.Caption = "Copy"       'Get copy of program

    Erase ProfileThread
    
    ReDim Radii(options.zstock)
    For i = 0 To UBound(Radii)
        Radii(i).radius = options.xstock
        'Radii(i).N = 0
        'radii(i).G = 0
    Next

    If options.MaxCutDepth = 0 Then options.MaxCutDepth = .5 * mmtosteps
    RoughCut = options.MaxCutDepth



    For i = LBound(Tool) To UBound(Tool)
        Tool(i).used = False
    Next
    
    CurT = 1
    cnc_gcode.t = 1
    
    ProfileBore.BoreEnd = UBound(Radii)
    ProfileBore.BoreStart = UBound(Radii)
    
    ReadLatheCalib CNCFRmDAt(CNCFrmNo).DevNo, Lcalib
    Curx = Lcalib.Tool_x(1)
    curz = Lcalib.Tool_z(1)
    


End Sub

Private Sub LatheGraphic ()

Dim Z As Integer
Dim x As Integer
Dim a$
Dim i As Integer
    
    Select Case cnc_gcode.m
        Case 0, notset, 3, 5, 68, 69    'Pause
        Case 2
            LineNum = 0
            Exit Sub
        Case Else
            
    End Select
    
    Select Case cnc_gcode.G
    Case notset
    
    Case 0, 92                                         'Fast = move don't draw
        GoSub checklimit
        Curx = DesX
        curz = desz
    
    Case 83
        If ProfileBore.BoreEnd > curz - desz Then ProfileBore.BoreEnd = curz - desz

    Case 33
        On Local Error GoTo Firtstthread
        i = UBound(ProfileThread)
        ReDim Preserve ProfileThread(i + 1)
DefThread:
        On Local Error GoTo 0
        i = UBound(ProfileThread)
        
        ProfileThread(i).start = curz
        ProfileThread(i).X = DesX
        ProfileThread(i).z = desz
        ProfileThread(i).i = cnc_gcode.i
        ProfileThread(i).k = cnc_gcode.k
        
        For z = curz To (curz - desz) Step -1
            If z <= UBound(Radii) Then
            
            If Radii(z).radius >= DesX Then
                Radii(z).radius = DesX
                'Radii(z).N = LineNum    'CNC_Gcode.N
                'radii(z).G = cnc_gcode.G
            End If
            End If
        Next
    
    Case 1                                          'Slow = draw straight line

        GoSub checklimit
        If desz = curz Then
            GoSub FaceSeg
        Else
            GoSub LineSeg
        End If
        

    Case 2
        Select Case desz
        Case curz
        Case Is < curz
            Select Case DesX
            Case Curx
            Case Is < Curx
                xc = CSng(Curx) - CSng(cnc_gcode.i)
                zc = CSng(curz) + CSng(cnc_gcode.k)
                dirn = 1
            GoSub arc
            Case Is > Curx
                xc = CSng(Curx) - CSng(cnc_gcode.i)
                zc = CSng(curz) - CSng(cnc_gcode.k)
                dirn = 1
                GoSub arc
            End Select
            
        Case Is > curz
            Select Case DesX
            Case Curx
            Case Is < Curx
                xc = CSng(Curx) + CSng(cnc_gcode.i)     'OK
                zc = CSng(curz) + CSng(cnc_gcode.k)     'OK
                dirn = -1
                GoSub arc
            Case Is > Curx
                xc = CSng(Curx) + CSng(cnc_gcode.i)     'OK
                zc = CSng(curz) - CSng(cnc_gcode.k)     'K was 0
                dirn = -1
                GoSub arc
            End Select
        End Select

        
    Case 3
        Select Case desz
        Case curz
        Case Is < curz
            Select Case DesX
            Case Is < Curx
                xc = CSng(Curx) + CSng(cnc_gcode.i)
                zc = CSng(curz) - CSng(cnc_gcode.k) 'Changed 16/9/95
                dirn = -1
                GoSub arc
            Case Is > Curx
                xc = CSng(Curx) + CSng(cnc_gcode.i)
                zc = CSng(curz) + CSng(cnc_gcode.k)
                dirn = -1
                GoSub arc
            End Select

        Case Is > curz
            Select Case DesX
            Case Is < Curx
                xc = CSng(Curx) - CSng(cnc_gcode.i)     'Tested OK
                zc = CSng(curz) - CSng(cnc_gcode.k)
                dirn = 1
                GoSub arc
            Case Is > Curx
                xc = CSng(Curx) - CSng(cnc_gcode.i)     'Tested OK
                zc = CSng(curz) + CSng(cnc_gcode.k)
                dirn = 1
                GoSub arc
            End Select

        End Select

    Case 4, 38, 39
    

    Case Else
        

    End Select

   On Local Error GoTo 0
   Exit Sub


checklimit:
    Return
    
    Select Case CurT
    Case 2
        If DesX < 0 Then GoTo Overlimit2
        If DesX > Lcalib.Tool_x(CurT) Then GoTo Overlimit2
        If desz < Tool2Min Then GoTo Overlimit2
        If desz > Lcalib.Tool_z(CurT) Then GoTo Overlimit2
    
    Case Else
        If DesX < 0 Then GoTo Overlimit
        If DesX > Lcalib.Tool_x(CurT) Then GoTo Overlimit
        If desz < 0 Then GoTo Overlimit
        If desz > Lcalib.Tool_z(CurT) Then GoTo Overlimit
    End Select
    Return


Overlimit:
    a$ = "Attempt to move to absolute position" + Format$(DesX * stepstomm, " #0.00") + "," + Format$(desz * stepstomm, " #0.00mm")
    a$ = a$ + Chr$(13) + "Limits with tool " + Format$(CurT) + " are :-"
    a$ = a$ + Chr$(13) + Chr$(9) + "X :- 0 to" + Format$(Lcalib.Tool_x(CurT) * stepstomm, " #0.00mm")
    a$ = a$ + Chr$(13) + Chr$(9) + "Z :- 0 to" + Format$(Lcalib.Tool_z(CurT) * stepstomm, " #0.00mm")
    abortexe a$
    Exit Sub

Overlimit2:
    a$ = "Attempt to move to absolute position" + Format$(DesX * stepstomm, " #0.00") + "," + Format$(desz * stepstomm, " #0.00mm")
    a$ = a$ + Chr$(13) + "Limits with tool " + Format$(CurT) + " are :-"
    a$ = a$ + Chr$(13) + Chr$(9) + "X :- 0 to" + Format$(Lcalib.Tool_x(CurT) * stepstomm, " #0.00mm")
    a$ = a$ + Chr$(13) + Chr$(9) + "Z :- 12 to" + Format$(Lcalib.Tool_z(CurT) * stepstomm, " #0.00mm")
    abortexe a$
    Exit Sub

arc:
    Select Case CurT
    Case 1, 2
        GoSub checklimit
        r = Sqr(CSng(cnc_gcode.i) ^ 2 + CSng(cnc_gcode.k) ^ 2)
        i = 0
        While (r ^ 2) - (zc - desz) ^ 2 < 0
            r = r + 1                               'Bodgery needed for rounding errors
            i = i + 1
            If i = 100 Then
                abortexe "Not Possible to draw arc"
                Exit Sub
            End If
        Wend
        X = xc + Sqr((r ^ 2) - (zc - curz) ^ 2) * dirn
        If Abs(X - Curx) > 16 Then
            abortexe "Not Possible to draw arc" + Chr$(13) + "Start X " + Format$(X * stepstomm, "##0.00") + " cf " + Format$(DesX * stepstomm, "##0.00")
            Exit Sub
        End If
        X = xc + Sqr(Abs((r ^ 2) - (zc - desz) ^ 2)) * dirn
        If Abs(X - DesX) > 32 Then
            abortexe "Not Possible to draw arc" + Chr$(13) + "End X " + Format$(X * stepstomm, "##0.00") + " cf " + Format$(DesX * stepstomm, "##0.00")
            Exit Sub
        End If
        Func3
    Case 3
        abortexe "You can't cut an arc with the threading tool"
        Exit Sub
    
    Case 4
        abortexe "You can't cut an arc with the boring tool"
        Exit Sub
    End Select
    Return

LineSeg:
    Select Case CurT
    Case 1, 2
        Func1
    Case 3
        abortexe "You can't cut with the threading tool!"
        Exit Sub
    Case 4
        If DesX = 0 Then
            Func1b
        Else
            abortexe "You can't cut with the boring tool"
        End If
        
    End Select
    Return


FaceSeg:
    If CurT = 3 Then
        abortexe "You can't cut with the threading tool"
        Exit Sub
    End If

    'move cutter inwards
    If Curx = DesX Then Return
    Func2
    Return


Firtstthread:
    ReDim ProfileThread(0)
    Resume DefThread

End Sub

Sub MakeProfile ()

screen.MousePointer = 11    'busy
generate_outline
screen.MousePointer = 0

End Sub

Private Sub Tool1Pass ()
    
Dim i As Integer
Dim j As Integer
Dim c As Single
Dim r As Single
Dim done As Integer

ReDim Pass1(UBound(Radii), options.xstock / RoughCut + 1)

'For i = 0 To UBound(radii)
'    Pass1(i, 0) = radii(i)
'Next
    
    i = UBound(Radii)                                       'Tool 1 OutLine
    r = Radii(i).radius
    Pass1(i, 0).radius = r
    For i = UBound(Radii) - 1 To 0 Step -1
        If Radii(i).radius >= r Then
            r = Radii(i).radius
        Else
            c = r - Radii(i).radius     'Change in steps
            If c > Tan(55 * pi / 180) Then
                r = r - Tan(55 * pi / 180)
            Else
                r = Radii(i).radius
            End If
        End If
        Pass1(i, 0).radius = r
    Next

    j = 0
    Do
    j = j + 1
    If j > UBound(Pass1, 2) Then
        ReDim Preserve Pass1(UBound(Radii), j)
    End If
    done = True
    For i = 0 To UBound(Radii)
        Pass1(i, j).radius = Pass1(i, 0).radius + FinalCut + RoughCut * (j - 1)
        If Pass1(i, j).radius > options.xstock Then
            Pass1(i, j).radius = options.xstock
        Else
            done = False
        End If
    Next

    Loop Until done
    ReDim Preserve Pass1(UBound(Radii), j - 1)


End Sub

Sub Tool2Pass ()

Dim i As Integer
Dim j As Integer
Dim r As Single
Dim c As Single
Dim done As Integer

ReDim Pass2(UBound(Radii), 0)

'For i = 0 To UBound(radii)
'    pass2(i, 0) = Pass1(i, 0)
'Next

    
    i = Tool2Min                                     'Tool 2 OutLine   cant't start before 10mm
    j = Radii(i).radius
    Pass2(i, 0).radius = j
    If Pass2(i, 0).radius >= Pass1(i, 0).radius Then
        Pass2(i, 0).radius = options.xstock
    Else
        done = False
    End If
    
    
    done = True
    Dim Tool2Active As Integer
    Tool2Active = False
    
    For i = (Tool2Min) + 1 To UBound(Radii)
        If Radii(i).radius >= r Then
            r = Radii(i).radius
        Else
            c = r - Radii(i).radius     'Change in steps
            If c > Tan(55 * pi / 180) Then
                r = r - Tan(55 * pi / 180)
            Else
                r = Radii(i).radius
            End If
        End If
        Pass2(i, 0).radius = r
        
        c = Pass2(i, 0).radius - Pass1(i, 0).radius
        Select Case c
            Case -13 To 13                    'Within .1mm
                If Not Tool2Active Then Pass2(i, 0).radius = options.xstock
            Case Is > 0
                Pass2(i, 0).radius = options.xstock
                Tool2Active = False
            Case Else
                Tool2Active = True
                done = False
        End Select
    
    Next
    
    If Not done Then
        j = 0
        Do
            Tool2Active = False
            j = j + 1
            ReDim Preserve Pass2(UBound(Radii), j)
            done = True
            For i = (Tool2Min) To UBound(Radii)
                Pass2(i, j).radius = Pass2(i, 0).radius + FinalCut + RoughCut * (j - 1)
                c = Pass2(i, j).radius - Pass1(i, 0).radius
                Select Case c
                    Case -13 To 13                    'Within .1mm
                        If Not Tool2Active Then Pass2(i, j).radius = options.xstock
                    Case Is > 0
                        Pass2(i, j).radius = options.xstock
                        Tool2Active = False
                    Case Else
                        Tool2Active = True
                        done = False
                End Select
                
                'If Pass2(i, j).radius >= Pass1(i, 0).radius Then
                '    Pass2(i, j).radius = options.Xstock
                'Else
                '    done = False
                'End If
            Next
        Loop Until done
        ReDim Preserve Pass2(UBound(Radii), j - 1)
    Else
        Erase Pass2
    End If

End Sub

