    page 
    subttl "ADC bits"

initadc:
    MOV DPTR,#0dd80h        ; ADC Configuration reg
    mov a,#00000010b        ; Reset/stop
    movx @dptr,a
    
    inc dptr
    mov a,#00000000b        ; Ram ptr = "00"
    movx @dptr,a        

    
    mov dptr,#0dd40h
    mov a,#00000010b        ; Channel 0 - pause
    lcall SetInstruction

    mov dptr,#0dd42h
    mov a,#00000100b        ; Channel 1
    lcall SetInstruction
    
    mov dptr,#0dd44h
    mov a,#00001000b        ; Channel 2
    lcall SetInstruction

    mov dptr,#0dd46h
    mov a,#00001100b        ; Channel 3
    lcall SetInstruction

    mov dptr,#0dd48h
    mov a,#00010000b        ; Channel 4
    lcall SetInstruction

    mov dptr,#0dd4ah
    mov a,#00010100b        ; Channel 5
    lcall SetInstruction
    
    mov dptr,#0dd4ch
    mov a,#00011000b        ; Channel 6
    lcall SetInstruction

    mov dptr,#0dd4eh
    mov a,#00011101b        ; Channel 7 - loop
    lcall SetInstruction

    
    
    MOV DPTR,#0dd80h        ; ADC Configuration reg
    mov a,#00001010b        ; Reset - calibrate
    movx @dptr,a
    clr a
    inc dptr                
    movx @dptr,a 
    
    
    MOV DPTR,#0dd82h        ; Interrupt enable Register
    clr  a
    movx @dptr,a
    
    
    MOV DPTR,#0dd84h        ; Interrupt status Register
    movx a,@dptr            ; Read clears 
    ret


startadc:
    MOV DPTR,#0dd80h        ; ADC Configuration reg
    mov a,#00000010b        ; Reset
    movx @dptr,a
    
    MOV DPTR,#0dd80h        ; ADC Configuration reg
;    mov a,#01000001b        ; Calibrate and Start


    mov a,#01000101b        ; Calibrate and Start   bit 2 added

    movx @dptr,a

    ret


 
readadc:
    jb   adcvalid,readadc2   ; Data not yet read by IBM
    MOV  DPTR,#0dd80h        ; ADC Configuration reg
    movx a,@dptr
    jnb  acc.0,readadc1      ; If paused then read FIFO buffer
readadc2:
    ret


readadc1:
    mov r0,#rawadc
readfifo:    
    mov dptr,#0dd85h        ; Read FIFO status
    movx a,@dptr
    anl a,#11111000b
    jz  fifoempty           ; jump if FIFO empty
    
    mov dptr,#0dd88h        ; Read FIFO lsb first
    movx a,@dptr
    mov @r0,a
    inc r0
    
    inc dptr
    movx a,@dptr
    jb acc.4,negadc         ; ADC negative?
    
    anl a,#00001111b        ; Mask off address/sign section
    mov @r0,a
    inc r0
    jmp posadc

negadc:
    dec r0                  ; Re-point to lsb
    clr a
    mov @r0,a               ; Store 0
    inc r0                  ; Point to msb
    mov @r0,a               ; Store 0
    inc r0

posadc:

    cjne r0,#rawadc+16,readfifo
fifoempty:    
    setb  adcvalid          ; Tell IBM data is good
    lcall startadc
    ret



SetInstruction:
    movx @dptr,a
    inc dptr
    mov a,#11110000b        ; Acquisition time max
    movx @dptr,a
    
    MOV  DPTR,#0dd80h        ; ADC Configuration reg
    mov  a,#00000010b        ; Reset
    movx @dptr,a
    ret
