;        
 
TITLE  ** 8031 Gryphon Encoders Monitor - Version 1, 4/1/95 **

PLEN 100

	load
	list




;r0     change in axis 0 position
;r1     change in axis 1 position
;r2     change in axis 2 position



;lastp1     is last state of p1 - Encoder inputs 0-3


led bit  p3.5

motor    bit p3.0
MotorDir bit p3.1


tacho bit p3.4  ;timer 0 counter 


bitadds equ     20h     ;bit addressable sector


lastp1 equ     bitadds       ;last encoder 0 - 3 states

last0A  bit lastp1.1
last0B  bit lastp1.0

last1A  bit lastp1.3        ; Axis 1 encoder reversed
last1B  bit lastp1.2        ; minor complication to keep wiring consitant

last2A  bit lastp1.4
last2B  bit lastp1.5


Enc0A   bit acc.1
Enc0B   bit acc.0

Enc1A   bit acc.3
Enc1B   bit acc.2

Enc2A   bit acc.4
Enc2B   bit acc.5


Ontime   equ     bitadds+1
Offtime  equ     Ontime+1

Flags     equ    Offtime+1       
lasttacho bit flags.0




stack   equ     30h



    base equ 0a000h
;    base equ 0

	org base
	pad $ff
	
	org base+00h            ;reset address
	jmp begin               ;start of program
	
	org base+03h            ;external interrupt 0 address, letterbox
	jmp send_get_posn

	org base+0bh
	reti

	org base+013h
	reti
	
	
	org base+01bh           
timer1: 
	djnz r4,exit_timer1
	
	setb Motordir           ;Normal direction
	mov  Ontime,#190        ;Normal power
	
	mov r3,#1
	mov r4,#10
exit_timer1:
	reti
	
	
	org base+02bh           
timer2:
	clr  t2con.7
	jb   motor,turnoff      
	Setb motor              
	reti                    

turnoff:
	Clr  motor     
	mov  tl2,Ontime
	reti          





db "Gryphon encoder monitor,1.00"  
db "4/1/95 (C) Cybernetic Applications 1993",0



begin:
	mov sp,#stack
	mov psw,#0
	
	mov dptr,#jmp_tbl      ; start of jump table
	movx a,@dptr           ; clear any current external interrupt

	mov  tmod,#00010000b   ; timer 1 8 bit
	mov  tcon,#01000000b   ; timer 1 running


	mov t2con, #00000100b  ;timer 2 counter
	mov rcap2l,#200
	mov rcap2h,#255

	
	mov r0,#0               ; axis 0 count
	mov r1,#0               ; axis 1 count
	mov r2,#0               ; axis 2 count

	mov r4,#10

	
	mov th1,#0
	mov Ontime,#100
	Mov Offtime,#155

	setb tacho
	
	
	mov acc,p1              ; read states of encoders 0 to 3
	mov lastp1,a
	
	mov ie,#10101001b       ; enable external interrupt, timer 1 int


waitmove:
	mov acc,p1              ; read states of encoders 0 to 3
	cjne a,lastp1,axis0     ; process if its changed


waittacho:
	jb tacho,w1

	jnb lasttacho,waitmove
	clr lasttacho
	djnz r3,waitmove
	
	Mov Ontime,#240
	Clr MotorDir            ;Opposite dir, brake

	ajmp waitmove


w1:
;tacho is high, was it last time
	jb lasttacho,waitmove
	setb lasttacho
	djnz r3,waitmove
	
	Mov Ontime,#240
	Clr MotorDir            ;Opposite dir, brake                    

	ajmp waitmove




;look for high to low transition on p1.0

axis0:                      ;if get high-> low transition then mod counter   
	jb  Enc0A, axis0lh      ;jump if encoder still high   
	jnb last0A,axis0q       ;jump if encoder was low last time also
	jb  Enc0B, incaxis0     ;get direction, jump positive

decaxis0:        
	dec r0
	jmp axis1

incaxis0:
	inc r0
	jmp axis1


axis0lh:                    ;test for low-> high transition   
	jb  last0A,axis0q       ;high this time, was it low last time    
	jb  Enc0B, decaxis0
	jmp incaxis0


axis0q:                  ;quadrature testing, ie. on other signal channel, p1.1
	
	jb  Enc0B,axis0lhq   ;jump if encoder still high
	jnb last0B,axis1      ;jump if encoder was low last time also
	jnb Enc0A,incaxis0  ;get direction, jump positive (phase)
	dec r0
	jmp axis1


axis0lhq:                ;test for low-> high transition
	jb  last0B,axis1      ;high this time, was it low last time
	jnb Enc0A,decaxis0
	jmp incaxis0



axis1:                   ;if get high-> low transition then mod counter   
	jb Enc1A,axis1lh     ;jump if encoder still high   
	jnb last1A,axis1q     ;jump if encoder was low last time also
	jb Enc1B,incaxis1    ;get direction, jump positive

decaxis1:        
	dec r1
	jmp axis2

incaxis1:
	inc r1
	jmp axis2


axis1lh:                 ;test for low-> high transition   
	jb  last1A,axis1q     ;high this time, was it low last time    
	jb  Enc1B,decaxis1
	jmp incaxis1


axis1q:                  ;quadrature testing, ie. on other signal channel, p1.1
	
	jb  Enc1B,axis1lhq   ;jump if encoder still high
	jnb last1B,axis2      ;jump if encoder was low last time also
	jnb Enc1A,incaxis1   ;get direction, jump positive (phase)
	dec r1
	jmp axis2


axis1lhq:                ;test for low-> high transition
	jb  last1B,axis2      ;high this time, was it low last time
	jnb Enc1A,decaxis1
	jmp incaxis1


axis2: 
	jb Enc2A,axis2lh     ;jump if encoder still high   
	jnb last2A,axis2q     ;jump if encoder was low last time also
	jb Enc2B,incaxis2    ;get direction, jump positive

decaxis2:        
	dec r2
	jmp axis3

incaxis2:
	inc r2
	jmp axis3


axis2lh:                 ;test for low-> high transition   
	jb  last2A,axis2q     ;high this time, was it low last time    
	jb  Enc2B,decaxis2
	jmp incaxis2


axis2q:                  ;quadrature testing, ie. on other signal channel, p1.1
	
	jb  Enc2B,axis2lhq   ;jump if encoder still high
	jnb last2B,axis3      ;jump if encoder was low last time also
	jnb Enc2A,incaxis2   ;get direction, jump positive (phase)
	dec r2
	jmp axis3


axis2lhq:                ;test for low-> high transition
	jb  last2B,axis3      ;high this time, was it low last time
	jnb Enc2A,decaxis2
	jmp incaxis2


axis3:
exit_axes0to3: 
	mov lastp1,a        ;last state now replaced by current
	jmp waittacho







; interrupt request from master for counter values

send_get_posn:
	push psw
	push acc
	
	djnz r7,lab0
;        cpl led
lab0:    
	
	
	movx a,@dptr                    ;read masters' control byte
	jmp @a+dptr                     ;jump to start+ctrl
jmp_tbl: 
	ajmp sendaxis0change            ;ctrl=0
	ajmp sendaxis1change            ;ctrl=2
	ajmp sendaxis2change            ;ctrl=4
	

sendaxis0change:
	mov a,#0
	xch a,r0                ;get change in posn, reset counter
	jmp exit_send_posn
sendaxis1change:
	mov a,#0
	xch a,r1                ;get change in posn, reset counter
	jmp exit_send_posn
sendaxis2change:
	mov a,#0
	xch a,r2                ;get change in posn, reset counter
	jmp exit_send_posn

exit_send_posn:        
	movx @dptr,a            ;put data onto master data latch
	pop acc
	pop psw
	reti












	db "END OF PROGRAM "
	db "Gryphon encoders "
	db 0,0,0,0

	org base+$1fcf
	
	db $ff
	
	end
