Option Explicit
Option Compare Text
DefInt A-Z

Function ReadAnaSensor (subdevno As Integer) As Integer
    Dim i     As Integer
    Dim r_no  As Integer
    Dim robotcntrl  As robotCNTRLtype
    Dim robotWC As robotWCtype
    
    ReadAnaSensor = 0
    i = findsubdev(subdevno, WC_Anasens)
    r_no = subdev(i).Control_device(0) - 1
    If r_no >= 0 Then
        READDATA r_no, robotcntrl
        If robotcntrl.online = 1 Then
            READWC r_no, robotWC
            ReadAnaSensor = robotWC.anainputs(subdev(i).Control_Pin(0))
        Else
            ReadAnaSensor = (MaxAsensor(subdevno) + 1) * Rnd
        End If
    End If

End Function

Function ReadDigSensor (subdevno As Integer) As Integer
    Dim i     As Integer
    Dim r_no  As Integer
    Dim robotcntrl  As robotCNTRLtype
    Dim robotWC As robotWCtype

    Dim Simulate As Integer
    
    Simulate = True
    i = findsubdev(subdevno, WC_Digsens)
    r_no = subdev(i).Control_device(0) - 1
    If r_no >= 0 Then
        READDATA r_no, robotcntrl
        If robotcntrl.online <> 0 Then
            READWC r_no, robotWC
            ReadDigSensor = robotWC.diginputs(subdev(i).Control_Pin(0))
            Simulate = False
        End If
    End If


    If Simulate Then
        ReadDigSensor = 1
    End If


End Function

Sub ShowAnaSensor (subdevno As Integer)
    
    Dim i     As Integer
    Dim r_no  As Integer
    Dim robotcntrl  As robotCNTRLtype
    Dim robotWC As robotWCtype

    Dim a$
    
    i = findsubdev(subdevno, WC_Anasens)
    
    r_no = subdev(i).Control_device(0) - 1
    
    If r_no >= 0 Then
        READDATA r_no, robotcntrl
        If robotcntrl.online <> 0 Then
            READWC r_no, robotWC
            asensor(subdevno).Value = robotWC.anainputs(subdev(i).Control_Pin(0))
            a$ = Format$(asensor(subdevno).Value)
        Else
            asensor(subdevno).Value = 0
            a$ = "Not Connected"
        End If
    Else
        asensor(subdevno).Value = 0
        a$ = "Not Connected"
    End If


    If a$ <> status(asensor(subdevno).gridrow).col2 Then
        status(asensor(subdevno).gridrow).col2 = a$
        statusfrm.Table1.RefreshRow = asensor(subdevno).gridrow
    End If

End Sub

Sub showDigsensor (subdevno As Integer)
    
    Dim i     As Integer
    Dim r_no  As Integer
    Dim robotcntrl  As robotCNTRLtype
    Dim robotWC As robotWCtype

    Dim a$
    
    i = findsubdev(subdevno, WC_Digsens)
    
    r_no = subdev(i).Control_device(0) - 1
    
    If r_no >= 0 Then
        READDATA r_no, robotcntrl
        If robotcntrl.online <> 0 Then
            READWC r_no, robotWC
            If robotWC.diginputs(subdev(i).Control_Pin(0)) = 1 Then
                dsensor(subdevno).Value = True
                a$ = "ON"
            Else
                dsensor(subdevno).Value = False
                a$ = "OFF"
            End If
        Else
            dsensor(subdevno).Value = True
            a$ = "Not Connected"
        End If
    Else
        dsensor(subdevno).Value = True
        a$ = "Not Connected"
    End If


    If a$ <> status(dsensor(subdevno).gridrow).col2 Then
        status(dsensor(subdevno).gridrow).col2 = a$
        statusfrm.Table1.RefreshRow = dsensor(subdevno).gridrow
    End If



End Sub

Function subdevcaption$ (sub_no As Integer)

Dim i As Integer
Dim j As Integer
Dim a$

    j = 0
    i = -1
    Do
        i = i + 1
        Select Case subdev(sub_no).devtype
        Case WC_wgag, WC_Digwgag
            Select Case subdev(i).devtype
                Case WC_wgag, WC_Digwgag
                     j = j + 1
            End Select
        
        Case WC_vgag, WC_Digvgag
            Select Case subdev(i).devtype
                Case WC_vgag, WC_Digvgag
                     j = j + 1
            End Select
        
        Case Else
            If subdev(sub_no).devtype = subdev(i).devtype Then j = j + 1
        End Select

    Loop Until i = sub_no

    Select Case subdev(sub_no).devtype
        Case WC_CONV
            a$ = "Conveyor"
        Case WC_itab
            a$ = "Index Table"
        Case WC_part
            a$ = "Dispenser"
        Case WC_wgag, WC_Digwgag
            a$ = "Width Gauge"
        Case WC_vgag, WC_Digvgag
            a$ = "Height Gauge"
        Case WC_Digsens
            a$ = "Digital Sensor"
        Case WC_Anasens
            a$ = "Analog Sensor"
    End Select
    
    subdevcaption$ = a$ + Str$(j)


End Function

