include cyber.inc
sent equ 2

sentMCNTRL equ 2
sentWCNTRL equ 3

ifdef winnt
extern tmpreg:word
endif

.code

ifdef winnt


ntout proc 
;simulate out dx,al        

	pusha
	mov di,dx
	mov cl,al
	
	mov dx,VDDout
	
	mov ax,hVDD
	DispatchCall
	popa
       
	ret
ntout endp

ntin proc
;simulate in al,dx
	

	pusha

	mov si,dx
	mov dx,VDDin
	
	mov ax,hVDD
	DispatchCall
	
	mov tmpreg,ax
	popa
	mov ax,tmpreg
	
	ret
ntin endp


endif


putoffline proc
	push si
	push ax
	
	.if robot.offlinecnt[bx] != 5
		inc robot.offlinecnt[bx]
	.else
		.if robot[bx].online != DEV_UNCONNECT
			mov robot[bx].online,DEV_UNCONNECT
			
			mov robot[bx].teachmode,keyboard
			
;            mov ax,robot.devtype[bx]        ;clear device id
;            mov ah,0                        ;but keep 
;            mov robot.devtype[bx],ax        ;device type
			
			mov si,0
			.repeat
				mov ax,robot[bx].despos[si]
				mov robot[bx].feedback[si],ax
				mov robot[bx].lastdespos[si],ax
				add si,2 
			.until si==18

		.endif
	.endif

	pop ax
	pop si
	ret
putoffline endp

putonline proc
	.IF robot.online[bx]!=DEV_OFFLINE
		mov robot.online[bx],DEV_ONLINE
	.ENDIF
	mov robot.offlinecnt[bx],0
	ret
putonline endp





RJcycle macro cycle,nextaddress

	ifidn <3>,<cycle>       ;Dummy cycle 
		echo <used>
		RJout 2,nextaddress
	endif
	
	mov ax,rj45id           ;Need to add ID to cycle
	add ax,cycle
	RJout 4,al

	RJout 8,0               ;Start transmit cycle                       
	waitrjfree
	
							;Delays altered from 5 to 6 24/6/95
							;Mill was miss-read

							;all 8's seem ok

	
	ifidn <0>,<cycle>       ;Write data cycle 
		mov cx,7            ;4 gives errors     5
	endif
	
	ifidn <1>,<cycle>       ;Read data cycle 
		mov cx,7            ;4 gives errors     6
	endif
	
	ifidn <2>,<cycle>       ;MSB addr cycle 
		mov cx,7            ;4 fails
	endif
	
	ifidn <3>,<cycle>       ;Dummy cycle 
		mov cx,7            ;3 Gives errors
	endif


	.repeat                 ;wait for 8031 to process
		timer2wait
	.untilcxz

	
	ifidn <3>,<cycle>
		add dx,2
		Portin al,dx
		mov ah,0
	endif
	
	endm





Axischanged proc pascal channel:word 
;Look through filter 
	push si
	push cx
	
	mov ax,channel
	mov cx,FilterLen*2
	mul cx
	mov si,ax
	
	mov ax,robot[bx].filterdata[si]
	mov dx,robot[bx].filterdata[si]
	
	mov cx,FilterLen-1
	.repeat
		.if robot[bx].filterdata[si]>dx
			mov dx,robot[bx].filterdata[si]
		.endif
		
		.if robot[bx].filterdata[si]<ax
			mov ax,robot[bx].filterdata[si]
		.endif

		add si,2
	.untilcxz

	;AX = Smallest
	;DX = Biggest

	sub dx,ax
	.if dx>3
		mov ax,1
	.else
		mov ax,0
	.endif

	pop cx
	pop si
	ret
Axischanged endp





filter proc pascal channel:word, data:word, default:word, change:word

;Look at filter[0] and filter[FilterLen-1]
	.if robot[bx].filterenable == True
	
	push si
	push cx
	push dx
	
	mov ax,channel
	mov cx,FilterLen*2
	mul cx
	
	mov si,ax                          ; point to start of filter q 
	push si
	
	mov cx,FilterLen-1                 ; shift filter data q     
	.repeat
		mov ax,robot[bx].filterdata[si+2]
		mov robot[bx].filterdata[si],ax
		add si,2
	.untilcxz
	
	mov ax,data
	mov robot[bx].filterdata[si],ax     ; Save new record at end of filter

										; Point back to first element    
	pop si                              
	
	mov cx,robot[bx].filterdata[si]
	
	.if ax > cx                         ; get change of current data (ax)
		sub ax,cx                       ; with data at start of q (cx)
	.else
		xchg ax,cx
		sub  ax,cx
	.endif

	
	.if ax>change
		;.if ax>256
		;    mov ax,default      ;Data is very different still use default
		;.else
			mov ax,data                     ; Data is different
		;.endif
	.else
		; Check for slowly changing signal
		mov ax,default                  ; Data unchanged return default
		
		.if ax > data
			sub ax,data
		.else
			mov ax,data
			sub ax,default
		.endif

		.if ax>change
			mov ax,data
		.else
			mov ax,default
		.endif

	.endif



	pop dx
	pop cx
	pop si
	.endif

	
	ret
filter endp



initfilters proc pascal
	
	mov ax,16000                    ; Large data, assures raw data will be used
	
	mov cx,16*FilterLen             ; 16 filters per robot
	mov si,0
	
	.repeat
		mov robot[bx].filterdata[si],ax
		add si,2
	.untilcxz
	
	ret
initfilters endp


;internal_8032_peek proc pascal address:word
;        push cx
;        waitrjfree
;        mov ax,address
;        RJcycle 3,al           ;Data next time from address al
;        pop cx
;        ret
;internal_8032_peek endp




peek_8032 proc pascal address:word

ifdef winnt

	pusha
	mov si,address
	mov cx,rj45id
	 
	mov dx,VDDpeek_8032
	
	mov ax,hVDD
	DispatchCall
	
	mov tmpreg,ax
	popa
	mov ax,tmpreg  
	mov ah,0

else
	push cx
	waitrjfree
	mov ax,address
	RJout 2,al
	RJout 6,0
	RJcycle 1               ;Start read data cycle
	
	
	waitrjfree
	RJcycle 3,0             ;Data returned in ax - no data next time
	pop cx
endif
	ret
peek_8032 endp

deek_8032 proc pascal address:word


ifdef winnt

	pusha
	mov si,address
	mov cx,rj45id
	 
	mov dx,VDDdeek_8032
	
	mov ax,hVDD
	DispatchCall
	
	mov tmpreg,ax
	popa
	mov ax,tmpreg  

else


	push cx
	waitrjfree
	mov ax,address
	RJout 2,al
	RJout 6,0
	RJcycle 1               ;Start read data cycle
	
	
	waitrjfree
	RJcycle 3,0             ;Data returned in ax
	push ax

	waitrjfree
	mov ax,address
	inc ax
	RJout 2,al
	RJout 6,0
	RJcycle 1               ;Start read data cycle
	
	waitrjfree
	RJcycle 3,0             ;Data returned in ax

	pop cx                  ; recover lsb
	mov ch,al               ; add in msb
	mov ax,cx               ; set return value

	pop cx
endif
	ret
deek_8032 endp


poke_8032 proc pascal address:word, data:word


ifdef winnt

	pusha
	mov si,address
	mov di,data
	mov cx,rj45id
	 
	mov dx,VDDpoke_8032
	
	mov ax,hVDD
	DispatchCall
	popa
	
else

	waitrjfree
	
	mov ax,data
	RJout 0,al
	mov ax,address
	RJout 2,al
	RJout 6,0

	RJcycle 0               ;Write data
	
endif

	ret
poke_8032 endp

doke_8032 proc pascal address:word, data:word

ifdef winnt

	pusha
	mov si,address
	mov di,data
	mov cx,rj45id
	 
	mov dx,VDDdoke_8032
	
	mov ax,hVDD
	DispatchCall
	popa
	
else


	waitrjfree
	
	mov ax,data
	RJout 0,al
	mov ax,address
	RJout 2,al
	RJout 6,0

	RJcycle 0               ;Write data
	
	
	
	waitrjfree
	
	mov ax,data
	RJout 0,ah
	mov ax,address
	inc ax
	RJout 2,al
	RJout 6,0

	RJcycle 0               ;Write data
endif
	
	ret
doke_8032 endp






set8032page proc pascal millpage:word


ifdef winnt

	pusha
	mov si,millpage
	mov cx,rj45id
	 
	mov dx,VDDpage_8032
	
	mov ax,hVDD
	DispatchCall
	popa
	
else

	waitrjfree

	mov ax,millpage
	RJout 0,al

	mov ax,millpage
	RJout 2,al

	RJout 6,0
	RJcycle 2               ;Write to MSB address               

endif
	ret
set8032page endp





service_8032_workcell proc
		
	       
	.if robot[bx].mesgflag == false
	
	.if robot.Serialflag[bx] == True
		invoke set8032page, INTERNAL
		invoke peek_8032,WCNTRL                      ;wait for mill to be free
		.if al==0
			invoke poke_8032,wc_pulses,1     ;One pulse
			invoke poke_8032,wc_pulses+1,0
			
			mov robot.Serialflag[bx],2
			mov ax,40
			add ax,robot[bx].pulseop
			add ax,robot[bx].pulseop
			invoke poke_8032,wcntrl,ax      ;ask 8032 to send pulse
			mov robot[bx].SerialOP,0
		.endif
	
	.ELSEif robot.Serialflag[bx] != False
		.repeat
		
		invoke set8032page, INTERNAL
		invoke peek_8032,WCNTRL                      ;wait for mill to be free
		.if al==0
			invoke set8032page, high workcellip
			invoke peek_8032, low workcellip
			
			mov dx,1
			mov cx,robot[bx].SerialIP
			shl dx,cl
			test ax,dx
			.if zero?
				CLC
			.else
				STC
			.endif
			rcl robot[bx].SerialOP,1        ;Shift bit into result
			
			inc robot.Serialflag[bx]
			.if robot.Serialflag[bx]==18
				mov robot.Serialflag[bx],False
			.else
				invoke set8032page, INTERNAL
				invoke poke_8032,wc_pulses,1     ;One pulse
				invoke poke_8032,wc_pulses+1,0

				mov ax,40
				add ax,robot[bx].pulseop
				add ax,robot[bx].pulseop
				invoke poke_8032,wcntrl,ax      ;ask 8032 to send pulse
			.endif
		.else
			.break
		.endif

		.until robot.Serialflag[bx]==False
	.endif

	.endif

		
		
		
		invoke set8032page, high workcellip
		invoke peek_8032, low workcellip

		mov cx,1
		mov di,0
		.repeat
			test ax,cx
			.if zero?
				mov robot[bx].WC.DIG_inputs[di],0
			.else
				mov robot[bx].WC.DIG_inputs[di],1
			.endif
			shl cx,1
			add di,2
		.until di==16

		
		invoke set8032page, INTERNAL
		invoke peek_8032, workcell_op_copy
		mov robot[bx].WC.DIG_output,ax


		comment *
			Send RS232 from mill as directed by WALLI
		*
		.if robot[bx].rs232flag==true
			
			invoke peek_8032,WCNTRL                      ;wait for mill to be free
			.if al==0
				mov robot[bx].rs232flag,sent
				invoke poke_8032,rsmesg ,robot[bx].rs232data
				
				mov ax,send_rs232
				add ax,robot[bx].pulseop
				add ax,robot[bx].pulseop
				invoke poke_8032,WCNTRL,ax
			.endif
		
		.elseif robot[bx].rs232flag==sent
			invoke peek_8032,WCNTRL
			.if al==0
				mov robot[bx].rs232flag,false
			.endif
		.endif


		
		
		comment *
			Send data to mill as directed by WALLI
		*
		.if robot[bx].mesgflag==true
			.if robot[bx].mesgaddr==MCNTRL
				invoke peek_8032,MCNTRL
				.if al==0
					invoke poke_8032,MCNTRL,robot[bx].mesg
					mov robot[bx].mesgflag,SentMCNTRL
				.endif
			
			.elseif robot[bx].mesgaddr==WCNTRL
				invoke peek_8032,WCNTRL
				.if al==0
					invoke poke_8032,WCNTRL,robot[bx].mesg
					mov robot[bx].mesgflag,SentWCNTRL
				.endif
			.else
				invoke poke_8032,robot[bx].mesgaddr,robot[bx].mesg
				mov robot[bx].mesgflag,false
			.endif
		.Elseif robot[bx].mesgflag==SentMCNTRL
			invoke peek_8032,MCNTRL
			.if al==0
				mov robot[bx].mesgflag,false
			.endif
		.Elseif robot[bx].mesgflag==SentWCNTRL
			invoke peek_8032,WCNTRL
			.if al==0
				mov robot[bx].mesgflag,false
			.endif
		.endif



		




		




		ret

service_8032_workcell endp


end
