;        
	plen 100
;    load
	list

	
	Motor bit p3.3       ;0 = Motor ON, 1 = Motor Off

	Led_Start bit p1.4
	Led_Stop  bit p1.5
	Led_Step  bit p1.6

	op_led   bit p3.7
	
	clear    bit p1.7
	
;    base equ 0a000h         ;Use when sending to SRAM   sb51 conveyor.asm
	base equ 0               ;Use when making EPROM      sb51 conveyor.asm h
	
	org base
	pad $ff
	
	org base+00h            ;reset address
	jmp begin               ;start of program
	
	org base+03h            ;external interrupt 0 address
	reti
	
	org base+0bh            ;timer 0 address
	jmp readencoder


	org base+13h            ;external interrupt 1 address
	reti

	org base+23h
	jmp serial

	
;23/3/94 (Version 0.0) - First Written - Not issued
;20/7/94 (Version 1.0) - Debounce inputs - Not issued
; 5/9/94 (Version 1.1) - Ignore stop - when held low - 2 to Happe on loan
;13/9/94 (Version 1.3) - Reset L297 to keep running
;14/9/94 (Version 1.4) - Removed L297!  - First Issue - 6 to Mexico
;15/9/94 (Version 1.5) - Diagnostics added
;24/11/94 (Version 1.6) - Prevent -ve encoder positions

;20/7/95 (Version 1.7) - Correct encoder reading


db "8031 Conveyor"
db "20/7/95 (C) Cybernetic Applications 1995 - (Version 1.7)"
	

counter     equ 20h
lsb_posn    equ counter+1
msb_posn    equ lsb_posn+1
tmp_msb     equ msb_posn+1

flags       equ tmp_msb+1
freerun     bit flags.0
lastEncA    bit flags.1     ;Used to detect +ve and -ve transitions
is_lsb      bit flags.3
init_serial bit flags.4
ignore_stop bit flags.5     ;Only use stop if started
cleared     bit flags.6

enable      equ flags+1
step_en     bit enable.0
start_en    bit enable.1
stop_en     bit enable.2 

p1copy      equ enable+1
in0         bit p1copy.0       ;Step Input
in1         bit p1copy.1       ;Start Input
in2         bit p1copy.2       ;Stop input

stack       equ p1copy+1


EncA        bit acc.1   ;7 to use serial      ;Encoder inputs - Gives count
EncB        bit acc.2           ;Gives direction

begin:
	mov sp,#stack
	
	acall set_start         ;Start belt - if stop not low
	
;    setb op_led
	MOV R0,#0
	MOV R1,#0
	mov r2,#3
waitpowerup:
	djnz r0,waitpowerup
	djnz r1,waitpowerup
;    cpl op_led
	djnz r2,waitpowerup
	
	acall set_stop
;    clr op_led
	
	setb clear              ;Clear 279 latch
	clr  clear
	setb clear

	mov enable,#255         ;Allow any pulse input
	mov p1copy,p1           ;Take copy of Control inputs

	clr is_lsb
	clr init_serial
	

	clr a
	
	mov psw,#0                      ;set reg bank 0  (addr 0-7)
	mov pcon,#0                     ;set SMOD low
	mov tmod,#00100010b             ;set timer 1 to mode 2 - timer 0 to mode 1
	mov tcon,#01010000b             ;start timer 1 and 0        
	
	
	mov th1,#253                    ;set countdown for 9600baud
	mov scon,#01010000b             ;set serial mode 1
	
	mov th0,#50            
	mov tl0,#1

	mov ie,#10010010b



;    clr ti
;    mov sbuf,a


toggle:        
	jb cleared,noclear
	
	mov p1copy,p1           ;Take copy of Control inputs before clearing

;Clear the 279 if
;Had step last time
;Had start last time
	
	jnb step_en,clear279
	jnb start_en,clear279
	ajmp noclear
clear279:
	clr  clear
	setb clear              ;Clear 279 latch
noclear:

	clr cleared
	
	
	jnb in0,notstep         ;Gets set by pulse on !step input
	jnb step_en,usedstep
	clr step_en

step:




;Old Conveyors  200*75/18= 833 steps/rev
;               833/pi*22.9  =11.5 steps/mm
;
;New Conveyors  4*44.3*5/4 = 221.5 counts/rev
;               221.5/(pi*23.8) = 2.96 counts/mm
;               221.5/(pi*23.6) = 2.99 counts/mm
;               221.5/(pi*24.3) = 2.90 counts/mm

	
	clr EA
	jnb freerun,stp1        ; if not already in step mode
	acall set_step          ; enter step mode fb=dp=0
stp1:
	inc lsb_posn            ; inc desired posn by 1 count
	mov a,lsb_posn
	jnz rg1
	inc msb_posn

rg1:
	setb EA
	
	mov r7,#0               ;don't cancel step mode yet
	mov r6,#16

	ajmp toggle


notstep:
	setb step_en            ;Clear used flag

usedstep:
	jnb in1,notstart
	jnb start_en,usedstart
	clr start_en
start:  
	clr ea
	acall set_start
	setb ea
	ajmp toggle

notstart:
	setb start_en

usedstart:
	
	jnb in2,notstop         ;Not stop    
	jnb stop_en,usedstop    ;Stop was used last time
	clr stop_en             ;Mark stop used
stop:        
	jb ignore_stop,toggle
	clr ea
	acall set_stop
	setb ea
	ajmp toggle


notstop:
	setb stop_en
usedstop:
	ajmp toggle




serial: 
	jb ri,receive 

;    push acc
;    clr  ti
;    mov  a,dpl
;
;    mov  sbuf,a
;    pop  acc
	
	reti    


receive:    
	push acc
	push psw

	mov a,sbuf
	clr ri
	jb is_lsb,mode4
	jb init_serial,readcntrl
	cjne a,#27,exit_serial  ;Start with ESC
	setb init_serial
	jmp exit_serial

readcntrl:
	clr init_serial
	cjne a,#254,mode2
	acall set_stop          ; put into stop mode
	jmp exit_serial

mode2:        
	cjne a,#255,mode3
	acall set_start         ; put into start mode
	jmp exit_serial

mode3:        
	mov tmp_msb,a
	setb is_lsb             ; next byte will be lsb
	jmp exit_serial
mode4:
	
	acall set_step          ; put into step mode
	mov r6,#0
	mov r7,#16
	
	mov lsb_posn,a
	mov a,tmp_msb
	mov msb_posn,a
	clr is_lsb 
	

exit_serial:        
	
	pop psw
	pop acc
	reti



readencoder:
	jnb freerun,servo       
	reti

servo:
	push acc
	push psw

;    setb p3.1            ;Ensure that the encoder lines   
;    setb p3.2            ;remain as inputs   








	mov acc,p3           ;read EncA and EncB
	push acc             ; 20/7/95 save encoder state   
						 ; acc gets used in the sums!


				 ;look for high to low transition on p1.0
				 ;if get high-> low transition then mod counter   
	jb  EncA,axislh      ;jump if encoder still high   
	jnb LastEncA,endmove ;jump if encoder was low last time
	jb  EncB,incaxis     ;get direction
decaxis:        
	mov a,dpl
	jnz deca
	
	mov a,dph
	jnz deca

	jmp  endmove
deca:        
	
	clr  c               ;dec dptr only if not 0  
	mov  a,dpl
	subb a,#1
	mov  dpl,a
	mov  a,dph
	subb a,#0
	mov  dph,a
	jmp  endmove

incaxis:
	inc  dptr
	jmp  endmove

axislh:                        ;test for low-> high transition   
	jb   LastEncA,endmove  ;high this time, was it low last time    
	jb   EncB,decaxis
	jmp  incaxis

endmove:
	pop  acc                ; 20/7/95 recover encoder state
	mov  C,EncA
	mov  lastEncA,C         ;save encoder A state
	
	
	
	
	clr  c
	mov  a,msb_posn          ;r2.r3 = desired position /4
	rrc  a
	mov  r2,a
	mov  a,lsb_posn
	rrc  a
	mov  r3,a
	
	clr  c
	mov  a,r2
	rrc  a
	mov  r2,a
	mov  a,r3
	rrc  a
	mov  r3,a
	
	
	clr  c
	mov  a,r3               ; lsb desired position
	subb a,dpl              ; a=(despos/4)-fb
	mov  b,a                ; save                   lsb error
	mov  a,r2               ; msb desired position
	subb a,dph              ; a=(despos/4)-fb        msb error

	jnc  high_speedfwd 
	
	Setb Motor              ; Stop motor
	
	djnz r7,noservo
	djnz r6,noservo
	
	acall set_stop          ; End of increment - go to stop mode
	jmp noservo

high_speedfwd:
	Clr Motor               ; Start Motor
	mov r7,#0               
	mov r6,#16               

noservo:
	pop psw
	pop acc
	reti



set_start:
	mov p1copy,p1           ;Take copy of Control inputs before clearing
	clr clear               ; Reset the 279
	setb clear               

	setb cleared            ; avoid missing step/start pulse
	
	
	jb p1.2,ignore_start    ;Read stop line - if low disable start
	
	setb Led_Start
	clr Led_Stop  
	clr Led_Step  

	clr ignore_stop         ;Allow stop line to do its stuff
	setb freerun            ;no servoing
	Clr Motor               ;Start Motor

ignore_start:

	ret



set_stop:
	mov p1copy,p1           ;Take copy of Control inputs before clearing
	clr clear               ; Reset the 279
	setb clear               

	setb cleared            ; avoid missing step/start pulse

	clr Led_Start
	Setb Led_Stop  
	clr Led_Step  

	setb freerun            ;no servoing
	setb Motor
	
	ret

set_step:
	push acc                ;20/7/95
	
	clr Led_Start
	clr Led_Stop  
	Setb Led_Step  

	setb ignore_stop        ;Disable stop line
	
	mov acc,p3              ;read EncA
	mov  C,EncA
	mov  lastEncA,C         ;save encoder A state
	
	clr freerun             ;servoing on
	
	mov dptr,#0             ;set feedback position to zero
	mov lsb_posn,#0
	mov msb_posn,#0

	pop acc
							;20/7/95
	ret


	

	db "END OF PROGRAM "
	db "8031 Conveyor"
	db 0,0,0,0

	org base+$1fcf
	db $ff
	
	end
