Option Explicit
Option Compare Text
DefInt A-Z

Function close_vgauge (Subdevno As Integer) As Integer

Dim i As Integer

close_vgauge = False
i = findsubdev(Subdevno, WC_Vgag)     'search through subdevices for gauge
If i > UBound(Subdev) Then
    MsgBox "Height Gauge" + Str$(Subdevno) + " not defined", , "Execution"
Else
    If Subdev(i).Control_device(1) = 0 Then       'not connected
        MsgBox "Height Gauge" + Str$(Subdevno) + " close line not connected", , "Execution"
    Else
        setpulseop Subdev(i).Control_device(1) - 1, Subdev(i).Control_Pin(1), 1, 1
        close_vgauge = True
    End If
End If


End Function

Function close_wgauge (Subdevno As Integer) As Integer

Dim i As Integer

close_wgauge = False
i = findsubdev(Subdevno, WC_wgag)     'search through subdevices for gauge
If i > UBound(Subdev) Then
    MsgBox "Width Gauge" + Str$(Subdevno) + " not defined", , "Execution"
Else
    If Subdev(i).Control_device(1) = 0 Then       'not connected
        MsgBox "Width Gauge" + Str$(Subdevno) + " close line not connected", , "Execution"
    Else
        setpulseop Subdev(i).Control_device(1) - 1, Subdev(i).Control_Pin(1), 1, 1
        close_wgauge = True
    End If
End If

End Function

Function DigGauge (Subdevno As Integer) As Integer
            
Dim i As Integer
Dim robotcntrl  As robotCNTRLtype
Dim robotWC As robotWCtype
Dim r_no

r_no = Subdev(Subdevno).Control_device(2) - 1
READDATA r_no, robotcntrl
If robotcntrl.online <> 0 Then
    READWC r_no, robotWC
    If robotWC.diginputs(Subdev(Subdevno).Control_Pin(2)) = 0 Then
        i = ReadSerial(r_no, Subdev(Subdevno).Control_Pin(1), Subdev(Subdevno).Control_Pin(2))
        If (i And &HA000) <> &HA000 Then
            'MsgBox "Error Reading Gauge - Check Connections"
            DigGauge = 998
        Else
            DigGauge = i And &HFFF
        End If
        
    Else
        DigGauge = 999
    End If
End If

End Function

Function dispensedpart (pd As Integer) As Integer

Dim i As Integer
Dim r_no As Integer
Dim robotcntrl  As robotCNTRLtype
Dim robotWC As robotWCtype


    i = findsubdev(pd, WC_part)     'search through subdevices for conveyors
    dispensedpart = True

    If i > UBound(Subdev) Then
        MsgBox "Dispenser" + Str$(pd) + " Not Defined", , "Execution"
    Else
        r_no = Subdev(i).Control_device(1) - 1
        If r_no >= 0 Then
            READDATA r_no, robotcntrl
            If robotcntrl.online <> 0 Then
                READWC r_no, robotWC
                If robotWC.diginputs(Subdev(i).Control_Pin(1)) = 1 Then dispensedpart = False
            End If
        End If
    End If

End Function

Function dispensepart (pd As Integer) As Integer
Dim i           As Integer
Dim conv        As Integer


'startconveyor subdev(edit_subdev).Control_device(2) + 1

i = findsubdev(pd, WC_part)     'search through subdevices for conveyors
If i > UBound(Subdev) Then
    MsgBox "Dispenser" + Str$(pd) + " not defined", , "Execution"
    dispensepart = False
Else
    conv = Subdev(i).Control_device(2) + 1
    dispensepart = startconveyor(conv)
    setpulseop Subdev(i).Control_device(0) - 1, Subdev(i).Control_Pin(0), 1, 1
End If



End Function

Function findsubdev (Subdevno As Integer, subdevtype As Integer) As Integer
Dim i As Integer
Dim j As Integer

j = 0

Select Case subdevtype
Case WC_Vgag, WC_Digvgag
    For i = 0 To UBound(Subdev)
        Select Case Subdev(i).DevType
        Case WC_Vgag, WC_Digvgag
            j = j + 1
        End Select
        If j = Subdevno Then Exit For
    Next

Case WC_wgag, WC_DigWgag
    For i = 0 To UBound(Subdev)
        Select Case Subdev(i).DevType
        Case WC_wgag, WC_DigWgag
            j = j + 1
        End Select
        If j = Subdevno Then Exit For
    Next

Case Else
    For i = 0 To UBound(Subdev)
        If Subdev(i).DevType = subdevtype Then j = j + 1
        If j = Subdevno Then Exit For
    Next
End Select

findsubdev = i

End Function

Function incconveyor (conv As Integer, Dist As Integer) As Integer

Dim count As Integer
Dim i As Integer


If Dist > 1400 Then Dist = 1400
'count = Dist * 11.5       'Convert to STEPS PER MM

count = Dist * 10.9       'Convert to STEPS PER MM          5% less 3/2/97
'count = count - 30        ' Always a bit of overshoot
If count < 0 Then count = 0


i = findsubdev(conv, WC_CONV)     'search through subdevices for conveyors
If i > UBound(Subdev) Then
    MsgBox "Conveyor" + Str$(conv) + " not defined", , "Execution"
    incconveyor = False
Else
    If Subdev(i).Control_device(2) = 0 Then       'either not connected or via serial
        If Subdev(i).Control_device(3) = 0 Then
            MsgBox "Conveyor" + Str$(conv) + " increment line not connected", , "Execution"
            incconveyor = False
        Else
            setrs232op Subdev(i).Control_device(3) - 1, Subdev(i).Control_Pin(3), 27
            setrs232op Subdev(i).Control_device(3) - 1, Subdev(i).Control_Pin(3), count \ 256
            setrs232op Subdev(i).Control_device(3) - 1, Subdev(i).Control_Pin(3), count Mod 256
            incconveyor = 2         'Tell EXE need to wait while pulses sent
        End If
    Else
        If Subdev(i).Control_device(3) <> 0 Then
            MsgBox "Conveyor" + Str$(conv) + " Increment and Serial connected", , "Execution"
            incconveyor = False
        Else
            setpulseop Subdev(i).Control_device(2) - 1, Subdev(i).Control_Pin(2), count, 25
            incconveyor = True
        End If
    End If
End If

End Function

Function incitab (itab As Integer, Dist As Integer, AbsPos As Integer) As Integer

Dim i       As Integer
Dim count   As Integer

incitab = 0 'Assume success and no delay

If AbsPos Then
    count = (Dist - indextablezero(itab).position) * 8      'Convert to degrees
    indextablezero(itab).position = Dist
Else
    count = Dist * 8        'Convert to degrees
    If indextablezero(itab).position <> -1 Then
        indextablezero(itab).position = (indextablezero(itab).position + Dist) Mod 360
    End If
End If



i = findsubdev(itab, WC_itab)     'search through subdevices for conveyors
If i > UBound(Subdev) Then
    MsgBox "Index Table" + Str$(itab) + " not defined", , "Execution"
    incitab = -2    'Show fail
Else
    If Subdev(i).Control_device(2) = 0 Then       'either not connected or via serial
        If Subdev(i).Control_device(3) = 0 Then
            MsgBox "Index Table" + Str$(itab) + " increment line not connected", , "Execution"
            incitab = -2      'Show fail
        Else
            If count > 0 Then
                setrs232op Subdev(i).Control_device(3) - 1, Subdev(i).Control_Pin(3), 27
                setrs232op Subdev(i).Control_device(3) - 1, Subdev(i).Control_Pin(3), count \ 256
                setrs232op Subdev(i).Control_device(3) - 1, Subdev(i).Control_Pin(3), count Mod 256
            Else
                count = Abs(count)
                setrs232op Subdev(i).Control_device(3) - 1, Subdev(i).Control_Pin(3), 27
                setrs232op Subdev(i).Control_device(3) - 1, Subdev(i).Control_Pin(3), (count \ 256) + 128
                setrs232op Subdev(i).Control_device(3) - 1, Subdev(i).Control_Pin(3), count Mod 256
            End If
            incitab = count / 120        'Set delay time
        End If
    Else
        If Subdev(i).Control_device(3) <> 0 Then
            MsgBox "Index Table" + Str$(itab) + " Increment and Serial connected", , "Execution"
            incitab = -2
        Else
            count = Abs(count)
            setpulseop Subdev(i).Control_device(2) - 1, Subdev(i).Control_Pin(2), count, 60
        End If
    End If
End If



End Function

Function ItabAtZero (itab As Integer) As Integer
    Dim i     As Integer
    Dim r_no  As Integer
    
    Dim robotcntrl  As robotCNTRLtype
    Dim robotWC As robotWCtype
    
    
    
    ItabAtZero = False
    
    i = findsubdev(itab, WC_itab)
    r_no = Subdev(i).Control_device(4) - 1
    If r_no >= 0 Then
        READDATA r_no, robotcntrl
        If robotcntrl.online <> 0 Then
            READWC r_no, robotWC
            If robotWC.diginputs(Subdev(i).Control_Pin(4)) <> 1 Then
                ItabAtZero = True
            End If
        End If
    End If

            
        
        
        
    

End Function

Function MaxAsensor (Subdevno As Integer) As Integer

Dim i       As Integer
Dim robotcntrl  As robotCNTRLtype
Dim r_no As Integer


MaxAsensor = 0
    i = findsubdev(Subdevno, WC_Anasens)
    r_no = Subdev(i).Control_device(0) - 1
    If r_no >= 0 Then
        READDATA r_no, robotcntrl
        Select Case robotcntrl.DevType And 255
        Case Mentor, Xboard
            MaxAsensor = 255
        Case Else
            MaxAsensor = 4095
        End Select
    End If




End Function

Function MaxVgauge (Subdevno As Integer) As Integer

Dim pot_dev As Integer
Dim i       As Integer
Dim robotcntrl  As robotCNTRLtype


MaxVgauge = 0

i = findsubdev(Subdevno, WC_Vgag)     'search through subdevices for gauge
If i <= UBound(Subdev) Then
    If Subdev(i).DevType = WC_Vgag Then
        If Subdev(i).Control_device(2) <> 0 Then       'not connected
            pot_dev = Subdev(i).Control_device(2) - 1
            READDATA pot_dev, robotcntrl
            Select Case robotcntrl.DevType And 255
            Case Mentor, Xboard
                MaxVgauge = 255
            Case Else
                MaxVgauge = 4095
            End Select
        End If
    Else
        MaxVgauge = HeightGauge(Subdevno).Stroke
    End If
End If


End Function

Function MaxWgauge (Subdevno As Integer) As Integer

Dim pot_dev As Integer
Dim i       As Integer
Dim robotcntrl  As robotCNTRLtype

MaxWgauge = 0

i = findsubdev(Subdevno, WC_wgag)     'search through subdevices for gauge
If i <= UBound(Subdev) Then
    If Subdev(i).DevType = WC_wgag Then
        If Subdev(i).Control_device(2) <> 0 Then       'not connected
            pot_dev = Subdev(i).Control_device(2) - 1
            READDATA pot_dev, robotcntrl
            Select Case robotcntrl.DevType And 255
            Case Mentor, Xboard
                MaxWgauge = 255
            Case Else
                MaxWgauge = 4095
            End Select
        End If
    Else
        MaxWgauge = WidthGauge(Subdevno).Stroke
    End If
End If

End Function

Function open_vgauge (Subdevno As Integer, mesg As Integer) As Integer
Dim i   As Integer
open_vgauge = False

i = findsubdev(Subdevno, WC_Vgag)     'search through subdevices for gauge
If i > UBound(Subdev) Then
    If mesg Then MsgBox "Height Gauge" + Str$(Subdevno) + " not defined", , "Execution"
Else
    If Subdev(i).DevType = WC_Vgag Then
    If Subdev(i).Control_device(0) = 0 Then       'not connected
        If mesg Then MsgBox "Height Gauge" + Str$(Subdevno) + " open line not connected", , "Execution"
    Else
        setpulseop Subdev(i).Control_device(0) - 1, Subdev(i).Control_Pin(0), 1, 1
        open_vgauge = True
    End If
    End If
End If

End Function

Function open_wgauge (Subdevno As Integer, mesg As Integer) As Integer

Dim i As Integer
open_wgauge = False

i = findsubdev(Subdevno, WC_wgag)     'search through subdevices for gauge




If i > UBound(Subdev) Then
    If mesg Then MsgBox "Width Gauge" + Str$(Subdevno) + " not defined", , "Execution"
Else
    If Subdev(i).DevType = WC_wgag Then
        If Subdev(i).Control_device(0) = 0 Then       'not connected
            If mesg Then MsgBox "Width Gauge" + Str$(Subdevno) + " open line not connected", , "Execution"
        Else
            setpulseop Subdev(i).Control_device(0) - 1, Subdev(i).Control_Pin(0), 1, 1
            open_wgauge = True
        End If
    End If
End If


End Function

Function startconveyor (conv As Integer)
Dim i As Integer



i = findsubdev(conv, WC_CONV)     'search through subdevices for conveyors
If i > UBound(Subdev) Then
    MsgBox "Conveyor" + Str$(conv) + " not defined", , "Execution"
    startconveyor = False
Else
    If Subdev(i).Control_device(0) = 0 Then       'either not connected or via serial
        If Subdev(i).Control_device(3) = 0 Then
                MsgBox "Conveyor" + Str$(conv) + " start line not connected", , "Execution"
                startconveyor = False
        Else
            setrs232op Subdev(i).Control_device(3) - 1, Subdev(i).Control_Pin(3), 27
            setrs232op Subdev(i).Control_device(3) - 1, Subdev(i).Control_Pin(3), 255
            startconveyor = True
        End If
    Else
        If Subdev(i).Control_device(3) <> 0 Then
            MsgBox "Conveyor" + Str$(conv) + " Start and Serial connected", , "Execution"
            startconveyor = False
        Else
            setpulseop Subdev(i).Control_device(0) - 1, Subdev(i).Control_Pin(0), 1, 1
            startconveyor = True
        End If
    End If
End If
    
End Function

Function StartDigHeightGauge (Subdevno)
    
Dim i   As Integer
Dim T As Single
Dim r_no
Dim robotcntrl  As robotCNTRLtype
Dim robotWC As robotWCtype
    
    StartDigHeightGauge = False
    
    i = findsubdev(Subdevno, WC_Digvgag)     'search through subdevices for gauge
    
    If i > UBound(Subdev) Then
        MsgBox "Height Gauge" + Str$(Subdevno) + " not defined", , "Execution"
    ElseIf Subdev(i).Control_device(0) = 0 Then       'not connected
        MsgBox "Height Gauge" + Str$(Subdevno) + " Start not connected", , "Execution"
    ElseIf Subdev(i).Control_device(1) = 0 Then       'not connected
        MsgBox "Height Gauge" + Str$(Subdevno) + " Read not connected", , "Execution"
    ElseIf Subdev(i).Control_device(2) = 0 Then       'not connected
        MsgBox "Height Gauge" + Str$(Subdevno) + " Out not connected", , "Execution"
    Else
        'setpulseop subdev(i).Control_device(0) - 1, subdev(i).Control_Pin(0), 1, 1
        setop Subdev(i).Control_device(1) - 1, Subdev(i).Control_Pin(1), 1  'Read high
        
        setop Subdev(i).Control_device(0) - 1, Subdev(i).Control_Pin(0), 1
        setop Subdev(i).Control_device(0) - 1, Subdev(i).Control_Pin(0), 0
        T = Timer + 2
        
        r_no = Subdev(i).Control_device(2) - 1
        If r_no >= 0 Then
        Do
            If Timer > T Then
                Screen.MousePointer = 0
                MsgBox "Error Reading Gauge - Check connections"
                Exit Do
            End If
            
            READDATA r_no, robotcntrl
            If robotcntrl.online <> 0 Then
                READWC r_no, robotWC
                If robotWC.diginputs(Subdev(i).Control_Pin(2)) = 1 Then
                    StartDigHeightGauge = True
                    Exit Do
                End If
            Else
                Exit Do
            End If
        Loop
    End If
    '



    End If
    
    









End Function

Function StartDigWidthGauge (Subdevno)
Dim i   As Integer
Dim T As Single
Dim r_no
Dim robotcntrl  As robotCNTRLtype
Dim robotWC As robotWCtype
    
    
    StartDigWidthGauge = False
    
    i = findsubdev(Subdevno, WC_DigWgag)     'search through subdevices for gauge
    
    If i > UBound(Subdev) Then
        MsgBox "Width Gauge" + Str$(Subdevno) + " not defined", , "Execution"
    ElseIf Subdev(i).Control_device(0) = 0 Then       'not connected
        MsgBox "Width Gauge" + Str$(Subdevno) + " Start not connected", , "Execution"
    ElseIf Subdev(i).Control_device(1) = 0 Then       'not connected
        MsgBox "Width Gauge" + Str$(Subdevno) + " Read not connected", , "Execution"
    ElseIf Subdev(i).Control_device(2) = 0 Then       'not connected
        MsgBox "Width Gauge" + Str$(Subdevno) + " Out not connected", , "Execution"
    Else
        'setpulseop subdev(i).Control_device(0) - 1, subdev(i).Control_Pin(0), 1, 1
        
        setop Subdev(i).Control_device(1) - 1, Subdev(i).Control_Pin(1), 1  'Read high
        
        setop Subdev(i).Control_device(0) - 1, Subdev(i).Control_Pin(0), 1
        setop Subdev(i).Control_device(0) - 1, Subdev(i).Control_Pin(0), 0
        T = Timer + 2
    
        r_no = Subdev(i).Control_device(2) - 1
        If r_no >= 0 Then
        Do
            If Timer > T Then
                Screen.MousePointer = 0
                MsgBox "Error Reading Gauge - Check connections"
                Exit Do
            End If
            
            READDATA r_no, robotcntrl
            If robotcntrl.online <> 0 Then
                READWC r_no, robotWC
                If robotWC.diginputs(Subdev(i).Control_Pin(2)) = 1 Then
                    StartDigWidthGauge = True
                    Exit Do
                End If
            Else
                Exit Do
            End If
        Loop
    End If
    
    End If

End Function

Function startitab (itab As Integer) As Integer

Dim i As Integer

indextablezero(itab).position = -1

i = findsubdev(itab, WC_itab)     'search through subdevices for conveyors
If i > UBound(Subdev) Then
    MsgBox "Index Table" + Str$(itab) + " not defined", , "Execution"
    startitab = False
Else
    If Subdev(i).Control_device(0) = 0 Then       'either not connected or via serial
        If Subdev(i).Control_device(3) = 0 Then
                MsgBox "Index Table" + Str$(itab) + " start line not connected", , "Execution"
                startitab = False
        Else
            setrs232op Subdev(i).Control_device(3) - 1, Subdev(i).Control_Pin(3), 27
            setrs232op Subdev(i).Control_device(3) - 1, Subdev(i).Control_Pin(3), 255
            startitab = True
        End If
    Else
        If Subdev(i).Control_device(3) <> 0 Then
            MsgBox "Index Table" + Str$(itab) + " Start and Serial connected", , "Execution"
            startitab = False
        Else
            setpulseop Subdev(i).Control_device(0) - 1, Subdev(i).Control_Pin(0), 1, 1
            startitab = True
        End If
    End If
End If

End Function

Function stopconveyor (conv As Integer, mesg As Integer) As Integer
Dim i As Integer

i = findsubdev(conv, WC_CONV)     'search through subdevices for conveyors
If i > UBound(Subdev) Then
    If mesg Then MsgBox "Conveyor" + Str$(conv) + " not defined", , "Execution"
    stopconveyor = False
Else
    If Subdev(i).Control_device(1) = 0 Then       'either not connected or via serial
        If Subdev(i).Control_device(3) = 0 Then
                If mesg Then MsgBox "Conveyor" + Str$(conv) + " stop line not connected", , "Execution"
                stopconveyor = False
        Else
            setrs232op Subdev(i).Control_device(3) - 1, Subdev(i).Control_Pin(3), 27
            setrs232op Subdev(i).Control_device(3) - 1, Subdev(i).Control_Pin(3), 254
            stopconveyor = True
        End If
    Else
        setpulseop Subdev(i).Control_device(1) - 1, Subdev(i).Control_Pin(1), 1, 1
        stopconveyor = True
    End If
End If

End Function

Function stopitab (itab As Integer) As Integer

Dim i As Integer

indextablezero(itab).position = -1

i = findsubdev(itab, WC_itab)     'search through subdevices for conveyors
If i > UBound(Subdev) Then
    MsgBox "Index Table" + Str$(itab) + " not defined", , "Execution"
    stopitab = False
Else
    If Subdev(i).Control_device(1) = 0 Then       'either not connected or via serial
        If Subdev(i).Control_device(3) = 0 Then
                MsgBox "Index Table" + Str$(itab) + " stop line not connected", , "Execution"
                stopitab = False
        Else
            setrs232op Subdev(i).Control_device(3) - 1, Subdev(i).Control_Pin(3), 27
            setrs232op Subdev(i).Control_device(3) - 1, Subdev(i).Control_Pin(3), 254
            stopitab = True
        End If
    Else
        setpulseop Subdev(i).Control_device(1) - 1, Subdev(i).Control_Pin(1), 1, 1
        stopitab = True
    End If
End If

End Function

Function vgauge (Subdevno As Integer) As Integer
Dim pot_dev As Integer
Dim i       As Integer
Dim robotcntrl  As robotCNTRLtype
Dim robotWC As robotWCtype

vgauge = 9999
i = findsubdev(Subdevno, WC_Vgag)     'search through subdevices for gauge
If i > UBound(Subdev) Then
    MsgBox "Height Gauge" + Str$(Subdevno) + " not defined", , "Execution"
Else
    If Subdev(i).DevType = WC_Vgag Then
        If Subdev(i).Control_device(2) = 0 Then       'not connected
            MsgBox "Height Gauge" + Str$(Subdevno) + " potentiometer not connected", , "Execution"
        Else
            pot_dev = Subdev(i).Control_device(2) - 1
            READDATA pot_dev, robotcntrl
            If robotcntrl.online = 1 Then
                READWC pot_dev, robotWC
                vgauge = robotWC.anainputs(Subdev(i).Control_Pin(2))
            Else
                vgauge = (MaxVgauge(Subdevno) + 1) * Rnd
            End If
        End If
    Else
        vgauge = (HeightGauge(Subdevno).Stroke) * Rnd
    End If
End If

End Function

Sub WalliErr (Message$)

WalliError.Label1.Caption = Message$
WalliError.Show 1
DoEvents

End Sub

Function wgauge (Subdevno As Integer) As Integer

Dim pot_dev As Integer
Dim i       As Integer
Dim robotcntrl  As robotCNTRLtype
Dim robotWC As robotWCtype


wgauge = 9999
i = findsubdev(Subdevno, WC_wgag)     'search through subdevices for gauge
If i > UBound(Subdev) Then
    MsgBox "Width Gauge" + Str$(Subdevno) + " not defined", , "Execution"
Else
    If Subdev(i).DevType = WC_wgag Then
        If Subdev(i).Control_device(2) = 0 Then       'not connected
            MsgBox "Width Gauge" + Str$(Subdevno) + " potentiometer not connected", , "Execution"
        Else
            pot_dev = Subdev(i).Control_device(2) - 1
            READDATA pot_dev, robotcntrl
            If robotcntrl.online = 1 Then
                READWC pot_dev, robotWC
                wgauge = robotWC.anainputs(Subdev(i).Control_Pin(2))
            Else
                wgauge = (MaxWgauge(Subdevno) + 1) * Rnd
            End If
        End If
    Else
        wgauge = (MaxWgauge(Subdevno) + 1) * Rnd
    End If
End If



End Function

Function Zeroitab (itab As Integer) As Integer
    

    Dim i     As Integer
    Dim r_no  As Integer
    Dim robotcntrl  As robotCNTRLtype
    Dim robotWC As robotWCtype
    Dim a$
    Dim dummy
    
    If indextablezero(itab).position <> 0 Then

        'If zero is covered then increment 20 degrees
        'Else Start
        i = findsubdev(itab, WC_itab)
        r_no = Subdev(i).Control_device(4) - 1
        If r_no >= 0 Then
            READDATA r_no, robotcntrl
            If robotcntrl.online <> 0 Then
                READWC r_no, robotWC
                If robotWC.diginputs(Subdev(i).Control_Pin(4)) <> 1 Then
                    dummy = incitab(itab, 20, False)
                End If
            End If
        End If

        dummy = startitab(itab)

        indextablezero(itab).position = 0
        Zeroitab = True
    End If
End Function

