Option Explicit
Option Compare Text
DefSng A-Z

Const r0 = 12000             'Steps per rev
Const r1 = 12000
Const r2 = 12000

Const r6 = 2000        '(360 / 140) * (1200 - 400)    'Elevation 140 degs
Const R7 = 2000        '360 / 320 * 1600


'Const F0 = 4500      '9000=270deg      centres
'
'Const F1 = 3960 - 3000     '3960 is vertical
'Const F2 = 5020

Const F6 = 800
Const F7 = 800


Const L1 = 216#      'lengths
Const Fo = 50#       'axis 0 to axis 1 centre
Const l3 = 138.6
Const Vo = 366#          '351.6    'floor to axis 1 centre
Const So = 18#          'Side Offset

Const L5 = 225#                  'Axle centre
Const L6 = 191.5
Const L7 = 38#
Const L8r = 85#
Const L8f = 55#

Const L11 = 225#
Const L12 = 147#
Const L13 = .1
Const L14r = 58#
Const L14f = 31#

Const L17 = 46#
'Const L18 = 73# + L17           'Gripper length


Const L19 = 24#

Const Fo9 = 140#

Const L30 = 85#             'Axis 0 centre to Axis 1 inside edge 75
Const L31 = L30# + 100#       'Axis 0 centre to Axis 1 outside edge

Const L32L = 68#              'L32l+L32r= width of axis 2 arm
Const L32R = 100# - L32L

Const l33l = 42#
Const L33r = 48# - l33l
Const L33c = l33l - 24#


Const l70 = 20#
Const L71 = 15#
Const L72 = 13#

'Dim initialised As Integer
Dim L18      'Gripper length


Dim A3
Dim A7
Dim A11
Dim A16

Sub Gryphon_drawing (redrawpic As Integer)          'draws feedback positions

Dim lppoints()  As pointapi_Single
Dim Centre      As pointapi_Single
Dim RobotCntrl  As robotCNTRLtype

Dim l1_0, l1_1  'Lengths computed with plan for use in elevation
Dim l2_0, l2_1
Dim l3_0, l3_1

Dim I As Integer
Dim changed As Integer

Dim a4, a8, a12, A17

Dim X4, X5, x10
Dim Y4, Y5, y10

Dim robno As Integer
robno = EditFrmDat(GraphicsDevno).Frmno
InitVars robno

If redrawpic Then changed = True

READDATA GraphicsDevno, RobotCntrl
For I = 0 To 7
    RobotFrmDat(robno).F(I) = RobotCntrl.Feedback(I)
    If RobotFrmDat(robno).lastgfb(I) <> RobotFrmDat(robno).F(I) Then
        RobotFrmDat(robno).lastgfb(I) = RobotFrmDat(robno).F(I)
        changed = True
    End If
Next


If changed = True Then
    a4 = A3 + (RobotFrmDat(robno).F(1) * 2 * pi) / r1
    a8 = (RobotFrmDat(robno).F(2) * 2 * pi) / r2 - A7
    a12 = A11 + (RobotFrmDat(robno).F(6) * 2 * pi) / r6
    A17 = A16 - (RobotFrmDat(robno).F(0) * 2 * pi) / r0
    
    X4 = Fo: Y4 = -Vo
    X5 = X4 + L5 * Sin(a4): Y5 = Y4 + L5 * Cos(a4)
    x10 = X5 + L11 * Sin(a4 + a8): y10 = Y5 + L11 * Cos(a4 + a8)
    

    cleardrawing (0)                                            'Clear port, draw axes

    'AXIS 1
        
    ReDim lppoints(3)
    Centre.x = X4: Centre.y = Y4                     'Axis 1 centre
    
    lppoints(0).x = -L8r: lppoints(0).y = -L6
    lppoints(1).x = L8r: lppoints(1).y = -L6
    lppoints(2).x = L8f: lppoints(2).y = L5 + L7
    lppoints(3).x = -L8f: lppoints(3).y = L5 + L7
    Rotate Centre, lppoints(), a4 - pi / 2
    l1_0 = smallestx(lppoints())                'Collect for plan
    l1_1 = largestx(lppoints())
    drawpolygon 0, 1, lppoints()                'drawing 0, axis 1
    



    'AXIS 0
    ReDim lppoints(10)
    lppoints(0).x = -25: lppoints(0).y = 0
    lppoints(1).x = 25: lppoints(1).y = 0
    lppoints(2).x = 25: lppoints(2).y = -175
    lppoints(3).x = 65: lppoints(3).y = -175
    lppoints(4).x = 65: lppoints(4).y = lppoints(3).y - l3 - 65
    lppoints(5).x = lppoints(4).x - 73: lppoints(5).y = lppoints(4).y
    lppoints(6).x = lppoints(5).x - 25: lppoints(6).y = lppoints(5).y + 25
    lppoints(7).x = lppoints(6).x: lppoints(7).y = lppoints(6).y + 40
    lppoints(8).x = -140: lppoints(8).y = lppoints(7).y
    lppoints(9).x = -140: lppoints(9).y = lppoints(7).y + l3
    lppoints(10).x = -25: lppoints(10).y = lppoints(9).y
    drawpolygon 0, 0, lppoints()               'drawing 0, axis 0



    
    ReDim lppoints(3)
    Centre.x = X5: Centre.y = Y5
    
    lppoints(0).x = -L14r: lppoints(0).y = -L12
    lppoints(1).x = L14r: lppoints(1).y = -L12
    lppoints(2).x = L14f: lppoints(2).y = L11 + L13
    lppoints(3).x = -L14f: lppoints(3).y = L11 + L13
    Rotate Centre, lppoints(), a4 + a8 - pi / 2
    l2_0 = smallestx(lppoints())                'Collect for plan
    l2_1 = largestx(lppoints())
    drawpolygon 0, 2, lppoints()                'drawing 0, axis 2
    
    lppoints(0).x = x10 - L14f: lppoints(0).y = y10 - L14f
    lppoints(1).x = x10 + L14f: lppoints(1).y = y10 + L14f
    drawcircle 0, 2, lppoints()                'drawing 0, axis 2



    'displaydrawing 0
    'Exit Sub



    'GRIPPER/WRIST
    
    Centre.x = x10: Centre.y = y10
    lppoints(0).x = L17: lppoints(0).y = -L19
    lppoints(1).x = L18: lppoints(1).y = -L19
    lppoints(2).x = L18: lppoints(2).y = L19
    lppoints(3).x = L17: lppoints(3).y = L19
    Rotate Centre, lppoints(), a4 + a8 - pi / 2 + a12
    l3_0 = smallestx(lppoints())                'Collect for plan
    l3_1 = largestx(lppoints())
    drawpolygon 0, 5, lppoints()                'drawing 0, axis 5

    displaydrawing 0
    
    


    cleardrawing (1)                                            'Clear port, draw axes
    
    'BASE
    Centre.x = 0: Centre.y = 0
        
    lppoints(0).x = -140: lppoints(0).y = -65
    lppoints(1).x = -140: lppoints(1).y = 65
    lppoints(2).x = 76: lppoints(2).y = 65
    lppoints(3).x = 76: lppoints(3).y = -65
    Rotate Centre, lppoints(), -(A17 - pi / 2)
    drawpolygon 1, 0, lppoints()                'drawing 1, axis 0
    
    'AXIS 1
    lppoints(0).x = l1_0: lppoints(0).y = -L31
    lppoints(1).x = l1_0: lppoints(1).y = -L30
    lppoints(2).x = l1_1: lppoints(2).y = -L30
    lppoints(3).x = l1_1: lppoints(3).y = -L31
    Rotate Centre, lppoints(), -(A17 - pi / 2)
    drawpolygon 1, 1, lppoints()                'drawing 1, axis 1

    'AXIS 2
    lppoints(0).x = l2_0: lppoints(0).y = -L32L
    lppoints(1).x = l2_0: lppoints(1).y = L32R
    lppoints(2).x = l2_1: lppoints(2).y = L32R
    lppoints(3).x = l2_1: lppoints(3).y = -L32L
    Rotate Centre, lppoints(), -(A17 - pi / 2)
    drawpolygon 1, 2, lppoints()                'drawing 0, axis 2
    
    
    'WRIST/GRIPPER
    lppoints(0).x = l3_0: lppoints(0).y = -L19 - 18
    lppoints(1).x = l3_0: lppoints(1).y = L19 - 18
    lppoints(2).x = l3_1: lppoints(2).y = L19 - 18
    lppoints(3).x = l3_1: lppoints(3).y = -L19 - 18
    Rotate Centre, lppoints(), -(A17 - pi / 2)
    drawpolygon 1, 5, lppoints()                'drawing 1, axis 5

    displaydrawing 1
    
End If



End Sub

Function Gryphon_InverseK (robno As Integer, d() As Integer, XYZ As XYZtype, Soln As Integer)

Dim r As Double
Dim Rad As Double
Dim F As Double
Dim G As Double
Dim B As Double
Dim H As Double
Dim alpha  As Double
Dim beta   As Double

Dim Phi0 As Double
Dim Phi1 As Double
Dim Phi2 As Double
Dim Phi6 As Double

Dim A As Double

A = XYZ.e * pi / 180#                   'Wrist angle

L18 = Position(robno).Gl + L17           'Gripper length

Rad = XYZ.x ^ 2 + XYZ.y ^ 2 - So ^ 2
If Rad < 0 Then Exit Function

Select Case Soln
    Case 0, 2 'R +ve
        Rad = Sqr(Rad)
    Case 1, 3 'R -ve
        Rad = -Sqr(Rad)
End Select
    
    r = Rad - Fo
    F = r - L18 * Sin(A)
    G = (XYZ.Z - Vo) + L18 * Cos(A)
    B = Sqr(F ^ 2 + G ^ 2)
    
    If B > L5 * 2 Then Exit Function        'B can't be more than sum of arm lengths

    H = L5 ^ 2 - (B / 2) ^ 2
Select Case Soln
Case 0, 1
    H = Sqr(Abs(H))
Case 2, 3
    H = -Sqr(Abs(H))
End Select

alpha = Atn(2 * H / B)

beta = Atn(G / F): If F < 0 Then beta = beta + pi
Select Case beta
Case Is > pi
    beta = beta - 2 * pi
Case Is < -pi
    beta = beta + 2 * pi
End Select


Phi1 = beta + alpha
d(1) = (Position(robno).F(1) + ((Phi1 * r1) / (2 * pi))) Mod r1

Phi2 = 2 * alpha
d(2) = (Position(robno).F(2) - ((Phi2 * r2) / (2 * pi))) Mod r2

Phi6 = pi / 2 + beta - alpha - A
d(6) = F6 - ((Phi6 * r6) / (2 * pi)) Mod r6



If Rad > 0 Then
    Select Case XYZ.x
        Case 0
            Phi0 = pi / 2 - Atn(So / Rad)     'Avoid divide by zero
        Case Is > 0
            Phi0 = Atn(XYZ.y / XYZ.x) - Atn(So / Rad)
        Case Else
            Phi0 = Atn(XYZ.y / XYZ.x) - Atn(So / Rad) + pi
    End Select
Else
    Select Case XYZ.x
        Case 0
            Phi0 = pi / 2 - Atn(So / Rad) + pi
        Case Is > 0
            Phi0 = Atn(XYZ.y / XYZ.x) - Atn(So / Rad) + pi
        Case Else
            Phi0 = Atn(XYZ.y / XYZ.x) - Atn(So / Rad)
    End Select
End If

d(0) = (Position(robno).F(0) + 3000 - ((Phi0 * r0) / (2 * pi))) Mod r0



d(7) = XYZ.r * R7 / 360 + F7        'Easy one first

d(4) = d(6) + 800 - d(7)
d(3) = 2 * d(6) - d(4)


Select Case d(0)
    Case -1
        d(0) = 0        'Allow for +/- 1 rounding errors
    Case 9001
        d(0) = 9000
    Case 0 To 9000
    Case Else
        Exit Function
End Select

Select Case d(1)
    Case -1
        d(1) = 0
    Case 5501
        d(1) = 5500
    Case 0 To 5500
    Case Else
        Exit Function
End Select

Select Case d(2)
    Case -1
        d(2) = 0
    Case 9951
        d(2) = 9950
    Case 0 To 9950
    Case Else
        Exit Function
End Select

Select Case d(3)
    Case 0 To 1600
    Case Else
        Exit Function
End Select
Select Case d(4)
    Case 0 To 1600
    Case Else
        Exit Function
End Select

Select Case d(6)
    Case 320 To 1280
    Case Else
        Exit Function
End Select

Gryphon_InverseK = True

End Function

Sub Gryphon_XYZ (robno As Integer, redrawpic As Integer)


Dim RobotCntrl  As robotCNTRLtype
Dim LastPosition As XYZ
Dim XYZ As XYZtype


If Not redrawpic Then LastPosition = Position(robno)

    READDATA RobotFrmDat(robno).DevNo, RobotCntrl
    Gryphon_XYZsums robno, RobotCntrl.Feedback(), XYZ
    
    Position(robno).x = Format$(XYZ.x, "##0.0")
    Position(robno).y = Format$(XYZ.y, "##0.0")
    Position(robno).Z = Format$(XYZ.Z, "##0.0")
    Position(robno).Ele = Format$(XYZ.e, "##0.0")
    Position(robno).Rot = Format$(XYZ.r, "##0")
    
    If XYZ.G = 0 Then Position(robno).Grip = "Open" Else Position(robno).Grip = "Shut"
    
    If LastPosition.x <> Position(robno).x Then XYZdata(robno).Table1.RefreshColumn = 1
    If LastPosition.y <> Position(robno).y Then XYZdata(robno).Table1.RefreshColumn = 2
    If LastPosition.Z <> Position(robno).Z Then XYZdata(robno).Table1.RefreshColumn = 3
    If LastPosition.Ele <> Position(robno).Ele Then XYZdata(robno).Table1.RefreshColumn = 4
    If LastPosition.Rot <> Position(robno).Rot Then XYZdata(robno).Table1.RefreshColumn = 5
    If LastPosition.Grip <> Position(robno).Grip Then XYZdata(robno).Table1.RefreshColumn = 6

    'Gryphon_InverseK Robno, xyz          ', x, y, -z, (A4 + A8 - pi / 2 + A12), RobotCntrl.feedback(0)

End Sub

Sub Gryphon_XYZsums (robno As Integer, Feedback() As Integer, XYZ As XYZtype)
    
Dim lppoints()  As pointapi_Single
Dim Centre  As pointapi_Single

Dim x As Single
'Dim y As Single
'Dim z As Single
'Dim Ele As Single
'Dim Rot As Single

Dim a4
Dim a8
Dim a12
Dim A17
Dim X4
Dim X5
Dim Y4
Dim Y5

Dim x10
Dim y10
    
    
    'InitVars robno

    'A17 = A16 - (Feedback(0) * 2 * pi) / r0          'Waist
    A17 = (Position(robno).F(0) - Feedback(0)) * 2 * pi / r0 + pi / 2          'Waist
    
    'A4 = A3 + (Feedback(1) * 2 * pi) / r1            'Axis 1
    a4 = (-Position(robno).F(1) + Feedback(1)) * 2 * pi / r1 + pi / 2      'Axis 1
    
    'A8 = (Feedback(2) * 2 * pi) / r2 - A7            'Axis 2
    a8 = -(Position(robno).F(2) - Feedback(2)) * 2 * pi / r2           'Waist
    
    'A12 = A11 + (Feedback(6) * 2 * pi) / R6          'Elevation
    a12 = (-F6 + Feedback(6)) * 2 * pi / r6 + pi / 2      'Elevation
    
    X4 = Fo: Y4 = -Vo                                           'axis 1 axle

    X5 = X4 + L5 * Sin(a4): Y5 = Y4 + L5 * Cos(a4)              'axis 2 axle
    
    x10 = X5 + L11 * Sin(a4 + a8): y10 = Y5 + L11 * Cos(a4 + a8) 'Wrist axle

    'x = x10 + L18 * Sin(a4 + a8 + a12)
    'x = y10 + L18 * Cos(a4 + a8 + a12)
    
    ReDim lppoints(0)
    
    Centre.x = x10: Centre.y = y10                              'Rotate wrist around wrist axle
    lppoints(0).x = L18: lppoints(0).y = 0
    Rotate Centre, lppoints(), a4 + a8 - pi / 2 + a12
    x = lppoints(0).x: XYZ.Z = -lppoints(0).y
    
    x = x10 + L18 * Sin(a4 + a8 + a12 - pi / 2)
    XYZ.Z = -(y10 + L18 * Cos(a4 + a8 + a12 - pi / 2))



    
    Centre.x = 0: Centre.y = 0                                  'Rotate arm around base axle
    lppoints(0).x = x: lppoints(0).y = -So
    Rotate Centre, lppoints(), -(A17 - pi / 2)
    XYZ.x = lppoints(0).x: XYZ.y = lppoints(0).y
    
    XYZ.e = (a4 + a8 - pi / 2 + a12) * 180 / pi
    XYZ.r = CSng(Feedback(7) - F7) * 360 / R7

    XYZ.G = Feedback(5)

End Sub

Private Sub InitVars (robno As Integer)

    L18 = Position(robno).Gl + L17           'Gripper length
    
    A16 = (Position(robno).F(0) * 2 * pi) / r0 + pi / 2     'Base offset angle
    
    A3 = pi / 2 - Position(robno).F(1) * 2 * pi / r1        'Axis 1 offset angle
    
    A7 = (Position(robno).F(2) * pi * 2) / r2               'Axis 2 offset angle
    
    A11 = pi / 2 - (F6 * 2 * pi) / r6                       'Wrist Elevation    offset angle

End Sub

