include cyber.inc

.code

ReadAna Macro HandShake
	
	if HandShake
		.if (robot[bx].teachmode == SIMULATOR) || (robot[bx].teachmode == SIMULATOR2)
			;Analogue inputs will be read with simulator    
		.else
			invoke peek_8032, 021H      ; simulator ready?
			bt ax,0
			.if carry?
	endif

				invoke deek_8032, 080H+2*6  ;Read workcell ip 1
				mov robot[bx].WC.ANA_inputs[0],ax
		
				invoke deek_8032, 080H+2*7  ;Read workcell ip 2
				mov robot[bx].WC.ANA_inputs[2],ax

	if HandShake
			.endif
			invoke poke_8032, 021H,0
		.endif
	endif
	endm

ReadAdc macro axis,change,range
	invoke deek_8032, 080H+2*axis
	invoke Filter,axis, ax ,robot[bx].rawlearn[axis*2],change
	mov robot[bx].rawlearn[axis*2],ax

	mov cx,range
	mul cx
	mov cx,4095
	div cx
	mov robot[bx].learn[2*axis],ax
	endm





ifdef Slide
service_rj45_gryphonslide proc
Else
service_rj45_gryphon proc
endif


	mov robot[bx].SimPres,1             ;Assume simulator connected - do proper later
	
	
	.if rj45base==0                      ; serial card not present
		ifdef Slide
		call service_gryphonslide_offline
		Else
		call service_gryphon_offline
		endif
	.else
		.if robot[bx].online!=DEV_OFFLINE
			invoke set8032page, INTERNAL
			invoke poke_8032, scratch,27
			invoke peek_8032, scratch
			.if al==27
				invoke poke_8032, scratch,72
				invoke peek_8032, scratch
				.if al==72
					.if robot[bx].online !=DEV_ONLINE
						invoke set8032page, EPROM
						
						mov si,030h
						mov di,0
						.repeat
							invoke peek_8032,si
							mov robot[bx].prom.promid[di],al
							inc si
							inc di
						.until di==sizeof Prom_struc

						invoke set8032page, INTERNAL
						invoke deek_8032,07eh
						mov robot[bx].prom.promcsum,ax

						mov robot[bx].teachmode,INIT
					.endif
					
					.if robot[bx].prom.promid == 'G'
						call putonline
					.endif
				.else
					call putoffline ; increments robot[bx].offlinecnt
				.endif
			.else
				call putoffline     ; increments robot[bx].offlinecnt
			.endif
		.endif


		.if robot[bx].online==DEV_ONLINE
			.if robot[bx].offlinecnt==0             ; really available ?
				ifdef Slide
				call service_gryphonslide_online
				Else
				call service_gryphon_online
				endif
			.endif
		.ELSE
			ifdef Slide
			call service_gryphonslide_offline    
			Else
			call service_gryphon_offline    
			endif
		.endif
	.endif
	ret
ifdef Slide
service_rj45_gryphonSlide endp
Else
service_rj45_gryphon endp
endif




ifdef Slide
service_gryphonSlide_online proc private
Else
service_gryphon_online proc private
endif


	call service_8032_workcell
	ReadAna True

	.if robot[bx].teachmode == zeroing
		invoke peek_8032, 027H      ; read in position flags
									; bit 7 = zeroing
									; bit 6 = jammed
									; bit 5 = axis 5 inpos
		bt ax,7
		.if !carry?
			mov robot[bx].teachmode,init
		.endif

	
	.else
		invoke peek_8032, 027H      ; read in position flags
									; bit 7 = zeroing
									; bit 6 = jammed
									; bit 5 = axis 5 inpos
		
	
	
		bt ax,7
		.if carry?
			mov robot[bx].teachmode,zeroing

		.else
			.if robot[bx].teachmode == jammed
				bt ax,6
				.if !carry?
					mov robot[bx].teachmode,init
				.endif
			.else
				bt ax,6
				.if carry?
					mov robot[bx].teachmode,jammed
					invoke peek_8032, 026H  ; read which axis is jammed
					mov ah,0
					mov robot[bx].errors,ax
					ret
				.endif
			.endif
		.endif
		
		ifdef Slide
			and al,0111111b
			.if al==0111111b
		else
			and al,01fh
			.if al==01fh
		endif
			mov robot[bx].inpos,true
		.else
			mov robot[bx].inpos,false
		.endif


		invoke peek_8032, 024H      ; read pendant active flag
		and al,0100000b
		.if al!=0
			mov robot[bx].inpos,false
			.if robot[bx].teachmode < jammed
				mov robot[bx].teachmode,pendant
			.ENDIF
		.endif


		.if (robot[bx].teachmode == SIMULATOR) || (robot[bx].teachmode == SIMULATOR2)
			invoke peek_8032, 021H      ; simulator ready?
			bt ax,0
			.if carry?
				ReadAna False
				
				ReadAdc 0,10,9000
				ReadAdc 1,10,5500
				ReadAdc 2,10,9950

				.if robot[bx].learn[(1*2)] < 100        ; If both axes 1
					.if robot[bx].learn[(2*2)] < 100    ; and 2 are small
						mov robot[bx].teachmode,keyboard
						jmp nosimulator                 ; assume that simulator is not connected
					.endif
				.endif


				invoke deek_8032, 080H+2*5  ;
				.if ax>2048
					mov robot[bx].learn[(5*2)],1
				.else
					mov robot[bx].learn[(5*2)],0
				.endif

				
				.if (robot[bx].teachmode == SIMULATOR) 
					ReadAdc 3,10,1600
					ReadAdc 4,10,1600

					mov ax,robot[bx].learn[(3*2)]
					add ax,robot[bx].learn[(4*2)]
					shr ax,1
					.if (ax>=320) && (ax <=1280 )          
						mov dx,true
					.else
						mov dx,false
					.endif

				.else
					ReadAdc 3,10,1600
					.if ax<320
						mov ax,320
					.elseif ax>1280
						mov ax,1280
					.endif
					mov robot[bx].learn[6*2],ax     ; Save as Elevation
					
					ReadAdc 4,10,1600
					mov robot[bx].learn[7*2],ax     ; Save as Rotation
		
					mov dx,false
					
					MOV AX,800                      ;Calculate axis 4
					ADD ax,robot[bx].learn[(6*2)]
					SUB ax,robot[bx].learn[(7*2)]
					mov robot[bx].learn[(4*2)],AX 
													;If axis 4 is in bounds then
					.if !sign? && ax<=1600          ;calculate axis 3    
						mov ax,robot[bx].learn[(6*2)]
						add ax,robot[bx].learn[(6*2)]
						SUB ax,robot[bx].learn[(4*2)]
						mov robot[bx].learn[(3*2)],AX 
						.if !sign? && ax<=1600
							mov dx,true
						.endif
					.endif
				.endif
				.if dx==true    ;Simulator data good use it all
					mov si,0
					mov cx,8
					.repeat
						mov ax,robot[bx].learn[si]
						mov robot[bx].despos[si],ax
						add si,2
					.untilcxz
				
				.else           ;Use only axes 0,1,2,5
					mov ax,robot[bx].learn[0*2]
					mov robot[bx].despos[0*2],ax
					
					mov ax,robot[bx].learn[1*2]
					mov robot[bx].despos[1*2],ax
					
					mov ax,robot[bx].learn[2*2]
					mov robot[bx].despos[2*2],ax
					
					mov ax,robot[bx].learn[5*2]
					mov robot[bx].despos[5*2],ax
				
				.endif
nosimulator:                
				
				invoke poke_8032, 021H,0
			.endif
		.endif


		ifdef Slide
			invoke deek_8032, 04eH
			.if ax>1024
				sub ax,1024
			.else
				mov ax,0
			.endif
			mov robot[bx].feedback[9*2],ax
		endif


		invoke deek_8032, 070H
		.if ax>1024
			sub ax,1024
		.else 
			mov ax,0
		.endif
		mov robot[bx].feedback[0],ax
	
		invoke deek_8032, 072H
		.if ax>1024
			sub ax,1024
		.else 
			mov ax,0
		.endif
		mov robot[bx].feedback[2],ax

		invoke deek_8032, 074H
		.if ax>1024
			sub ax,1024
		.else 
			mov ax,0
		.endif
		mov robot[bx].feedback[4],ax

		invoke deek_8032, 076H
		.if ax>1024
			sub ax,1024
		.else 
			mov ax,0
		.endif
		.if ax>1600 
			mov ax,1600
		.endif
		mov robot[bx].feedback[6],ax

		invoke deek_8032, 078H
		.if ax>1024
			sub ax,1024
		.else 
			mov ax,0
		.endif
		.if ax>1600 
			mov ax,1600
		.endif
		mov robot[bx].feedback[8],ax
		
		invoke peek_8032, 07aH              ; current gripper state
		and ax,16
		.if ax==16
			mov robot[bx].feedback[10],1    ; Shut
		.else
			mov robot[bx].feedback[10],0    ; Open
		.endif
		
		invoke peek_8032, 07bH              ; current speed
		mov robot[bx].feedback[16],ax
								   
		mov ax,robot[bx].feedback[(3*2)]
		add ax,robot[bx].feedback[(4*2)]
		shr ax,1
		mov robot[bx].feedback[(6*2)],AX     ;A6 =(A3+A4)/2           

		MOV AX,1600
		ADD ax,robot[bx].feedback[(3*2)]
		SUB ax,robot[bx].feedback[(4*2)]
		shr ax,1
		mov robot[bx].feedback[(7*2)],AX     ;A7 =(1600+A3-A4)/2
		
		
		mov ax,robot[bx].despos[(3*2)]
		add ax,robot[bx].despos[(4*2)]
		shr ax,1
		mov robot[bx].despos[(6*2)],AX     ;A6 =(A3+A4)/2           

		MOV AX,1600
		ADD ax,robot[bx].despos[(3*2)]
		SUB ax,robot[bx].despos[(4*2)]
		shr ax,1
		mov robot[bx].despos[(7*2)],AX     ;A7 =(1600+A3-A4)/2


		.if (robot[bx].teachmode==INIT ) || (robot[bx].teachmode==Pendant) || (robot[bx].teachmode==JAMMED)
			mov si,0
			.repeat
				mov ax,robot[bx].feedback[si]
				mov robot[bx].despos[si],ax
				mov robot[bx].lastdespos[si],ax
				add si,2
			ifdef slide
				.until si==20
			else
			    .until si==18
			endif

			.if robot[bx].teachmode==INIT
				mov robot[bx].teachmode,keyboard
			.endif
		
		.elseif  robot[bx].teachmode==NOSELEAD
			mov si,0
			.repeat
				mov ax,robot[bx].feedback[si]
				mov robot[bx].despos[si],ax
				mov robot[bx].lastdespos[si],ax
				add si,2
			.until si==10   ; Gripper still set by despos

		.endif



		mov si,0
		mov di,060h                                 ; start address in Gryphon
		.repeat
			mov cx,robot[bx].despos[si]             ; desired position
			.if robot[bx].resend==true
				mov robot[bx].lastdespos[si],-1
			.endif

			.if cx!=robot[bx].lastdespos[si]        ; already sent?
				mov robot[bx].lastdespos[si],cx     ; no, take copy
				add cx,1024                         ; shift, saves negative encoders
				invoke doke_8032,di,cx              ; write it out
			.endif
		   add di,2
		   add si,2
		.until si==10


		ifdef slide                        
			mov cx,robot[bx].despos[9*2]

			.if robot[bx].resend==true
				mov robot[bx].lastdespos[9*2],-1
			.endif

			.if cx!=robot[bx].lastdespos[9*2]        ; already sent?
				mov robot[bx].lastdespos[9*2],cx     ; no, take copy
				add cx,1024
				invoke doke_8032, 04cH,cx
			.endif
		endif





		mov robot[bx].resend,false

		mov cx,robot[bx].despos[10]             ; desired gripper
		.if cx!=robot[bx].lastdespos[10]        ; already sent?
			mov robot[bx].lastdespos[10],cx     ; no, take copy
			.if cx==1
				invoke poke_8032,06ah,16        ; write it out
			.else
				invoke poke_8032,06ah,0         ; write it out
			.endif
		.endif

		mov cx,robot[bx].despos[16]             ; desired speed
		.if cx!=robot[bx].lastdespos[16]        ; already sent?
			mov robot[bx].lastdespos[16],cx     ; no, take copy
			invoke poke_8032,06bh,cx            ; write it out
		.endif

		.if robot[bx].inpos==true
			mov si,0
			.repeat
				.if robot[bx].stop[si]!=false
					mov robot[bx].stop[si],false 
					mov ax,robot[bx].feedback[si]
					mov robot[bx].despos[si],ax
					mov robot[bx].lastdespos[si],ax
				.endif
				add si,2
			ifdef slide
				.until si==20
			else
				.until si==18
			endif
		.endif
	.endif

	ret
ifdef Slide
service_gryphonSlide_online endp
Else
service_gryphon_online endp
endif





ifdef Slide
service_gryphonSlide_offline proc private
Else
service_gryphon_offline proc private
endif



	.if robot[bx].teachmode == init
		mov robot[bx].teachmode,keyboard
		mov robot[bx].despos[0],4500
		mov robot[bx].despos[2],3000
		mov robot[bx].despos[4],3100
		mov robot[bx].despos[6],800
		mov robot[bx].despos[8],800
		mov robot[bx].despos[10],0
		mov robot[bx].despos[12],800
		mov robot[bx].despos[14],800
		mov robot[bx].despos[16],3

		ifdef Slide
		mov robot[bx].despos[18],0
		endif

		mov si,0
		.repeat
			mov ax,robot[bx].despos[si]
			mov robot[bx].lastdespos[si],ax
			mov robot[bx].feedback[si],ax
			add si,2
		ifdef Slide
		.until si==20
		else
		.until si==18
		endif

		mov di,0
		.repeat
			mov robot[bx].prom.promid[di],'?'
			inc di
		.until di==sizeof Prom_struc

	.endif

	
	mov robot.inpos[bx],TRUE        
	
	simulate 0,100          ; simulate movement of axis 0, increment of 100
	simulate 1,100
	simulate 2,100
	simulate 3,10
	simulate 4,10
	simulate 5,1
	mov robot[bx].stop[6*2],false
	mov robot[bx].stop[7*2],false
	simulate 8,3
	
	Ifdef slide
	simulate 9,10
	endif

	
	;Make up Elevation and rotation states
	
	mov ax,robot[bx].feedback[(3*2)]
	add ax,robot[bx].feedback[(4*2)]
	shr ax,1
	mov robot[bx].feedback[(6*2)],AX     ;A6 =(A3+A4)/2           

	MOV AX,1600
	ADD ax,robot[bx].feedback[(3*2)]
	SUB ax,robot[bx].feedback[(4*2)]
	shr ax,1
	mov robot[bx].feedback[(7*2)],AX     ;A7 =(1600+A3-A4)/2
	
	mov ax,robot[bx].despos[(3*2)]
	add ax,robot[bx].despos[(4*2)]
	shr ax,1
	mov robot[bx].despos[(6*2)],AX     ;A6 =(A3+A4)/2           

	MOV AX,1600
	ADD ax,robot[bx].despos[(3*2)]
	SUB ax,robot[bx].despos[(4*2)]
	shr ax,1
	mov robot[bx].despos[(7*2)],AX     ;A7 =(1600+A3-A4)/2
	
	mov robot.pulsecount[bx],0
	mov robot.rs232flag[bx],false
	mov robot.Serialflag[bx],false

	mov robot.mesgflag[bx],false

	ret

ifdef Slide
service_gryphonSlide_offline endp
Else
service_gryphon_offline endp
endif



				

end

