;        
 
TITLE  ** 8031 Gryphon Encoders Monitor - Version 1, 4/1/95 **

PLEN 100

;    load
	list

;    base equ 0a000h
	base equ 0

	org base
	pad $ff
	
	org base+00h            ;reset address
	jmp begin               ;start of program
	org base+03h            ;external interrupt 0 address, letterbox
	jmp send_get_posn


;r0     change in axis 0 position
;r1     change in axis 1 position
;r2     change in axis 2 position
;r3     change in axis 3 position
;r4     change in axis 4 position

;lastp1     is last state of p1 - Encoder inputs 0-3
;lastp3     is last state of p3 - Encoder input 4


led bit  p3.5


bitadds equ     20h     ;bit addressable sector


lastp1 equ     bitadds       ;last encoder 0 - 3 states
lastp3 equ     lastp1+1      ;last encoder 4 state

last0A  bit lastp1.1
last0B  bit lastp1.0

last1A  bit lastp1.3        ; Axis 1 encoder reversed
last1B  bit lastp1.2        ; minor complication to keep wiring consitant

last2A  bit lastp1.4
last2B  bit lastp1.5

last3A  bit lastp1.6
last3B  bit lastp1.7

last4A  bit lastp3.1
last4B  bit lastp3.0

Enc0A   bit acc.1
Enc0B   bit acc.0

Enc1A   bit acc.3
Enc1B   bit acc.2

Enc2A   bit acc.4
Enc2B   bit acc.5

Enc3A   bit acc.6
Enc3B   bit acc.7

Enc4A   bit acc.1
Enc4B   bit acc.0


stack   equ     30h


db "Gryphon encoder monitor,1.00"  
db "4/1/95 (C) Cybernetic Applications 1993",0



begin:
	mov sp,#stack
	mov psw,#0
	
	mov dptr,#jmp_tbl       ; start of jump table
	movx a,@dptr            ; clear any current external interrupt

	mov tcon,#0h            ; set external interrupt 0 low level trigggered 

	mov r0,#0
	mov r1,#0
	mov r2,#0
	mov r3,#0
	mov r4,#0
	
	mov acc,p1              ; read states of encoders 0 to 3
	mov lastp1,a

	mov acc,p3
	anl acc,#3              ; only interested in bits 0 and 1
	mov lastp3,a            ; set start case of encoder discs
	
	mov ie,#81h             ; enable external interrupt


waitmove:
	mov acc,p1              ; read states of encoders 0 to 3
	cjne a,lastp1,axis0     ; process if its changed

waitmove1:
	mov acc,p3
	anl acc,#3              ; read states of encoder 4
	cjne a,lastp3,axis4     ; process if its changed

	ajmp waitmove


axis4:                   ;if get high-> low transition then mod counter   
	jb  Enc4A, axis4lh   ;jump if encoder still high   
	jnb last4A,axis4q    ;jump if encoder was low last time also
	jb  Enc4B, incaxis4  ;get direction, jump positive

decaxis4:        
	dec r4
	jmp exit_axis4

incaxis4:
	inc r4
	jmp exit_axis4


axis4lh:                 ;test for low-> high transition   
	jb  last4A,axis4q     ;high this time, was it low last time    
	jb  Enc4B, decaxis4
	jmp incaxis4


axis4q:                  ;quadrature testing, ie. on other signal channel, p1.1
	
	jb  Enc4B,axis4lhq   ;jump if encoder still high
	jnb last4B,axis4      ;jump if encoder was low last time also
	jnb Enc4A,incaxis4  ;get direction, jump positive (phase)
	dec r4
	jmp exit_axis4


axis4lhq:                ;test for low-> high transition
	jb  last4B,exit_axis4 ;high this time, was it low last time
	jnb Enc4A,decaxis4
	jmp incaxis4


exit_axis4: 
	mov lastp3,a        ;last state now replaced by current
	jmp waitmove









;look for high to low transition on p1.0

axis0:                      ;if get high-> low transition then mod counter   
	jb  Enc0A, axis0lh      ;jump if encoder still high   
	jnb last0A,axis0q       ;jump if encoder was low last time also
	jb  Enc0B, incaxis0     ;get direction, jump positive

decaxis0:        
	dec r0
	jmp axis1

incaxis0:
	inc r0
	jmp axis1


axis0lh:                    ;test for low-> high transition   
	jb  last0A,axis0q       ;high this time, was it low last time    
	jb  Enc0B, decaxis0
	jmp incaxis0


axis0q:                  ;quadrature testing, ie. on other signal channel, p1.1
	
	jb  Enc0B,axis0lhq   ;jump if encoder still high
	jnb last0B,axis1      ;jump if encoder was low last time also
	jnb Enc0A,incaxis0  ;get direction, jump positive (phase)
	dec r0
	jmp axis1


axis0lhq:                ;test for low-> high transition
	jb  last0B,axis1      ;high this time, was it low last time
	jnb Enc0A,decaxis0
	jmp incaxis0



axis1:                   ;if get high-> low transition then mod counter   
	jb Enc1A,axis1lh     ;jump if encoder still high   
	jnb last1A,axis1q     ;jump if encoder was low last time also
	jb Enc1B,incaxis1    ;get direction, jump positive

decaxis1:        
	dec r1
	jmp axis2

incaxis1:
	inc r1
	jmp axis2


axis1lh:                 ;test for low-> high transition   
	jb  last1A,axis1q     ;high this time, was it low last time    
	jb  Enc1B,decaxis1
	jmp incaxis1


axis1q:                  ;quadrature testing, ie. on other signal channel, p1.1
	
	jb  Enc1B,axis1lhq   ;jump if encoder still high
	jnb last1B,axis2      ;jump if encoder was low last time also
	jnb Enc1A,incaxis1   ;get direction, jump positive (phase)
	dec r1
	jmp axis2


axis1lhq:                ;test for low-> high transition
	jb  last1B,axis2      ;high this time, was it low last time
	jnb Enc1A,decaxis1
	jmp incaxis1


axis2: 
	jb Enc2A,axis2lh     ;jump if encoder still high   
	jnb last2A,axis2q     ;jump if encoder was low last time also
	jb Enc2B,incaxis2    ;get direction, jump positive

decaxis2:        
	dec r2
	jmp axis3

incaxis2:
	inc r2
	jmp axis3


axis2lh:                 ;test for low-> high transition   
	jb  last2A,axis2q     ;high this time, was it low last time    
	jb  Enc2B,decaxis2
	jmp incaxis2


axis2q:                  ;quadrature testing, ie. on other signal channel, p1.1
	
	jb  Enc2B,axis2lhq   ;jump if encoder still high
	jnb last2B,axis3      ;jump if encoder was low last time also
	jnb Enc2A,incaxis2   ;get direction, jump positive (phase)
	dec r2
	jmp axis3


axis2lhq:                ;test for low-> high transition
	jb  last2B,axis3      ;high this time, was it low last time
	jnb Enc2A,decaxis2
	jmp incaxis2


axis3: 
	jb Enc3A,axis3lh     ;jump if encoder still high   
	jnb last3A,axis3q     ;jump if encoder was low last time also
	jb Enc3B,incaxis3    ;get direction, jump positive

decaxis3:        
	dec r3
	jmp exit_axes0to3

incaxis3:
	inc r3
	jmp exit_axes0to3


axis3lh:                 ;test for low-> high transition   
	jb  last3A,axis3q     ;high this time, was it low last time    
	jb  Enc3B,decaxis3
	jmp incaxis3


axis3q:                  ;quadrature testing, ie. on other signal channel, p1.1
	
	jb  Enc3B,axis3lhq   ;jump if encoder still high
	jnb last3B,exit_axes0to3   ;jump if encoder was low last time also
	jnb Enc3A,incaxis3   ;get direction, jump positive (phase)
	dec r3
	jmp exit_axes0to3



axis3lhq:                ;test for low-> high transition
	jb  last3B,exit_axes0to3      ;high this time, was it low last time
	jnb Enc3A,decaxis3
	jmp incaxis3


exit_axes0to3: 
	mov lastp1,a        ;last state now replaced by current
	jmp waitmove1







; interrupt request from master for counter values

send_get_posn:
	push psw
	push acc
	
	djnz r7,lab0
	cpl led
lab0:    
	
	
	movx a,@dptr                    ;read masters' control byte
	jmp @a+dptr                     ;jump to start+ctrl
jmp_tbl: 
	ajmp sendaxis0change            ;ctrl=0
	ajmp sendaxis1change            ;ctrl=2
	ajmp sendaxis2change            ;ctrl=4
	ajmp sendaxis3change            ;ctrl=6
	ajmp sendaxis4change            ;ctrl=8

sendaxis0change:
	mov a,#0
	xch a,r0                ;get change in posn, reset counter
	jmp exit_send_posn
sendaxis1change:
	mov a,#0
	xch a,r1                ;get change in posn, reset counter
	jmp exit_send_posn
sendaxis2change:
	mov a,#0
	xch a,r2                ;get change in posn, reset counter
	jmp exit_send_posn
sendaxis3change:
	mov a,#0
	xch a,r3                ;get change in posn, reset counter
	jmp exit_send_posn
sendaxis4change:
	mov a,#0
	xch a,r4                ;get change in posn, reset counter 
	jmp exit_send_posn

exit_send_posn:        


	movx @dptr,a            ;put data onto master data latch
	pop acc
	pop psw
	reti

	db "END OF PROGRAM "
	db "Gryphon encoders "
	db 0,0,0,0

	org base+$1fcf
	
	db $ff
	
	end
