Option Explicit
Option Compare Text
DefInt A-Z

Const R0 = 512      '180  -  360/180*256
Const R1 = 558      '165
Const R2 = 558      '165
Const R3 = 512      '180
Const R4 = 297      '310
Const R5 = 9

'Const F0 = 128      'centres
'Const F1 = 0
'Const F2 = 244
'Const F3 = 127.5
Const F4 = 128


Const L4 = 170 + 199    'Floor to axis 1 centre

Const L5 = 410           'Axis 1, Axle centre
Const L6 = 77
Const L7 = 25
Const L8r = 80
Const L8f = 40

Const L11 = 347         'Axis 2, Axle centre


Const L17 = 140         'Axis 3 Cylinder

Const L19t = 12
Const L19b = 63



Dim A3 As Single
Dim A7 As Single
Dim A11 As Single
Dim A14 As Single
Dim A16 As Single

Dim L14 As Single
Dim L20 As Single


'Dim iNITIALISED As Integer

Private Sub InitVars (RobNo)
Dim l12
Dim l13

'If Not iNITIALISED Then
'        iNITIALISED = True

	A3 = pi / 2 - Position(RobNo).F(1) * 2 * pi / R1
	A7 = (Position(RobNo).F(2) * pi * 2) / R2
	A11 = pi / 2 - (Position(RobNo).F(3) * 2 * pi) / R3
	A16 = (Position(RobNo).F(0) * 2 * pi) / R0 + pi / 2
	
	L20 = Sqr(L17 * L17 + L19t * L19t)

	l12 = L20 + 51 + 160
	l13 = L19t + 39
	L14 = Sqr(l12 ^ 2 + l13 ^ 2)
	A14 = Atn(l13 / l12)


'End If

End Sub

Sub Neptune1_Drawing (redrawpic)
'draws feedback positions

Dim lppoints()  As pointapi_Single
Dim centre  As pointapi_Single

ReDim lppoints(3)
Dim RobotCntrl  As robotCNTRLtype

Dim changed As Integer
Dim i As Integer

Dim a As Single
Dim a4 As Single
Dim a8 As Single
Dim a12 As Single
Dim a17 As Single
Dim x4, y4
Dim x5, y5
Dim x10, y10
Dim x11, y11

Dim l1_0
Dim l1_1

Dim l2_0
Dim l2_1

Dim l3_0
Dim l3_1

Dim l4_0
Dim l4_1

Dim l5_0
Dim l5_1

Dim RobNo As Integer
RobNo = EditFrmDat(GraphicsDevNo).Frmno

InitVars RobNo

If redrawpic Then changed = True



READDATA GraphicsDevNo, RobotCntrl
For i = 0 To 7
	RobotFrmDat(RobNo).F(i) = RobotCntrl.Feedback(i)
	If RobotFrmDat(RobNo).lastgfb(i) <> RobotFrmDat(RobNo).F(i) Then
	RobotFrmDat(RobNo).lastgfb(i) = RobotFrmDat(RobNo).F(i)
	changed = True
	End If
Next
If changed = True Then
	a4 = A3 + (RobotFrmDat(RobNo).F(1) * 2 * pi) / R1
	a8 = (RobotFrmDat(RobNo).F(2) * 2 * pi) / R2 - A7
	a12 = A11 + (RobotFrmDat(RobNo).F(3) * 2 * pi) / R3
	
	a17 = A16 - (RobotFrmDat(RobNo).F(0) * 2 * pi) / R0
	
	x4 = 0: y4 = -L4
	x5 = x4 + L5 * Sin(a4): y5 = y4 + L5 * Cos(a4)          'Axis 2 centre
	
	a = a4 + a8
	x10 = x5 + L11 * Sin(a): y10 = y5 + L11 * Cos(a)        'Axis 3 centre
	
	a = a4 + a8 - pi / 2 + a12 + A14
	x11 = x10 + L14 * Sin(a): y11 = y10 + L14 * Cos(a)        'Gripper centre


	
	cleardrawing (0)        'Clear port, draw axes
	
	ReDim lppoints(11)
	lppoints(0).X = x4 - 175: lppoints(0).Y = y4 - 18
	lppoints(1).X = x4 - 175: lppoints(1).Y = y4 + 82
	lppoints(2).X = x4 - 50: lppoints(2).Y = y4 + 82
	lppoints(3).X = x4 - 50: lppoints(3).Y = -200
	lppoints(4).X = x4 - 350: lppoints(4).Y = -200
	lppoints(5).X = x4 - 350: lppoints(5).Y = 0
	lppoints(6).X = x4 + 73 + 75: lppoints(6).Y = 0
	lppoints(7).X = x4 + 73: lppoints(7).Y = -200
	lppoints(8).X = x4 + 50: lppoints(8).Y = -200
	lppoints(9).X = x4 + 50: lppoints(9).Y = y4 + 82
	lppoints(10).X = x4 + 175: lppoints(10).Y = y4 + 82
	lppoints(11).X = x4 + 175: lppoints(11).Y = y4 - 18
	drawpolygon 0, 0, lppoints()                'drawing 0, axis 0



	ReDim lppoints(3)
	centre.X = x10: centre.Y = y10
	lppoints(0).X = -L20: lppoints(0).Y = L19t
	lppoints(1).X = -L20: lppoints(1).Y = -L19b
	lppoints(2).X = L20: lppoints(2).Y = -L19b
	lppoints(3).X = L20: lppoints(3).Y = L19t
	Rotate centre, lppoints(), a4 + a8 - pi / 2 + a12
	l3_0 = smallestx(lppoints())                'Collect for plan
	l3_1 = largestx(lppoints())
	drawpolygon 0, 3, lppoints()                'drawing 0, axis 3

	
	'AXIS 2
	ReDim lppoints(4)
	centre.X = x5: centre.Y = y5
	lppoints(0).X = -38 - 150: lppoints(0).Y = 32
	lppoints(1).X = -38 - 150: lppoints(1).Y = -108
	lppoints(2).X = -38: lppoints(2).Y = -108
	lppoints(3).X = 370: lppoints(3).Y = -78
	lppoints(4).X = 370: lppoints(4).Y = 2
	Rotate centre, lppoints(), a4 + a8
	l2_0 = smallestx(lppoints())                'Collect for plan
	l2_1 = largestx(lppoints())
	drawpolygon 0, 2, lppoints()                'drawing 0, axis 2
	
	
	ReDim lppoints(3)
	centre.X = x4: centre.Y = y4
	
	lppoints(0).X = -L8r: lppoints(0).Y = -L6
	lppoints(1).X = L8r: lppoints(1).Y = -L6
	lppoints(2).X = L8f: lppoints(2).Y = L5 + L7
	lppoints(3).X = -L8f: lppoints(3).Y = L5 + L7
	Rotate centre, lppoints(), a4 - pi / 2
	l1_0 = smallestx(lppoints())                'Collect for plan
	l1_1 = largestx(lppoints())
	drawpolygon 0, 1, lppoints()                'drawing 0, axis 1
	


	centre.X = x10: centre.Y = y10
	lppoints(0).X = L20: lppoints(0).Y = L19t
	lppoints(1).X = L20 + 51: lppoints(1).Y = L19t
	lppoints(2).X = L20 + 51: lppoints(2).Y = L19t + 51
	lppoints(3).X = L20: lppoints(3).Y = L19t + 51
	Rotate centre, lppoints(), a4 + a8 - pi / 2 + a12
	l4_0 = smallestx(lppoints())                'Collect for plan
	l4_1 = largestx(lppoints())
	drawpolygon 0, 4, lppoints()                'drawing 0, axis 4

	lppoints(0).X = L20 + 51: lppoints(0).Y = L19t + 39 - 25.4
	lppoints(1).X = L20 + 51 + 160: lppoints(1).Y = L19t + 39 - 25.4
	lppoints(2).X = L20 + 51 + 160: lppoints(2).Y = L19t + 39 + 25.4
	lppoints(3).X = L20 + 51: lppoints(3).Y = L19t + 39 + 25.4
	Rotate centre, lppoints(), a4 + a8 - pi / 2 + a12
	l5_0 = smallestx(lppoints())                'Collect for plan
	l5_1 = largestx(lppoints())
	drawpolygon 0, 5, lppoints()                'drawing 0, Gripper


	'X4,Y4 = Axis 1 axle
'       lppoints(0).X = x4 - 20: lppoints(0).Y = y4 - 20
'       lppoints(1).X = x4 + 20: lppoints(1).Y = y4 + 20
'       drawcircle 0, 3, lppoints()
'
 '       lppoints(0).X = x5 - 20: lppoints(0).Y = y5 - 20
 '       lppoints(1).X = x5 + 20: lppoints(1).Y = y5 + 20
 '       drawcircle 0, 3, lppoints()
 '
 '       lppoints(0).X = x10 - 20: lppoints(0).Y = y10 - 20
 '       lppoints(1).X = x10 + 20: lppoints(1).Y = y10 + 20
  '      drawcircle 0, 3, lppoints()
 '
 '       lppoints(0).X = x11 - 20: lppoints(0).Y = y11 - 20
 '       lppoints(1).X = x11 + 20: lppoints(1).Y = y11 + 20
 '       drawcircle 0, 3, lppoints()

'        lppoints(0).X = x25 - 20: lppoints(0).Y = y25 - 20
'        lppoints(1).X = x25 + 20: lppoints(1).Y = y25 + 20
'        drawcircle 0, 3, lppoints()
'

	displaydrawing 0


	cleardrawing (1)        'Clear port, draw axes
	centre.X = 0: centre.Y = 0
	ReDim lppoints(3)

	lppoints(0).X = -204: lppoints(0).Y = -351
	lppoints(1).X = -204: lppoints(1).Y = 73
	lppoints(2).X = 204: lppoints(2).Y = 73
	lppoints(3).X = 204: lppoints(3).Y = -351
	drawpolygon 1, 0, lppoints()                'drawing 0, axis 0
	
	lppoints(0).X = l1_0: lppoints(0).Y = -50
	lppoints(1).X = l1_0: lppoints(1).Y = 50
	lppoints(2).X = l1_1: lppoints(2).Y = 50
	lppoints(3).X = l1_1: lppoints(3).Y = -50
	Rotate centre, lppoints(), a17 - pi / 2
	drawpolygon 1, 1, lppoints()                'drawing 0, axis 1
	
	lppoints(0).X = l2_0: lppoints(0).Y = -45
	lppoints(1).X = l2_0: lppoints(1).Y = 45
	lppoints(2).X = l2_1: lppoints(2).Y = 45
	lppoints(3).X = l2_1: lppoints(3).Y = -45
	Rotate centre, lppoints(), a17 - pi / 2
	drawpolygon 1, 2, lppoints()                'drawing 0, axis 2

	lppoints(0).X = l3_0: lppoints(0).Y = -40
	lppoints(1).X = l3_0: lppoints(1).Y = 40
	lppoints(2).X = l3_1: lppoints(2).Y = 40
	lppoints(3).X = l3_1: lppoints(3).Y = -40
	Rotate centre, lppoints(), a17 - pi / 2
	drawpolygon 1, 3, lppoints()                'drawing 0, axis 3

	lppoints(0).X = l4_0: lppoints(0).Y = -105
	lppoints(1).X = l4_0: lppoints(1).Y = 105
	lppoints(2).X = l4_1: lppoints(2).Y = 105
	lppoints(3).X = l4_1: lppoints(3).Y = -105
	Rotate centre, lppoints(), a17 - pi / 2
	drawpolygon 1, 4, lppoints()                'drawing 0, axis 4

	lppoints(0).X = l5_0: lppoints(0).Y = -30
	lppoints(1).X = l5_0: lppoints(1).Y = 30
	lppoints(2).X = l5_1: lppoints(2).Y = 30
	lppoints(3).X = l5_1: lppoints(3).Y = -30
	Rotate centre, lppoints(), a17 - pi / 2
	drawpolygon 1, 5, lppoints()                'drawing 0, axis 5
	
	displaydrawing 1
	
End If


End Sub

Sub Neptune1_xyz (RobNo As Integer, redrawpic As Integer)

Dim RobotCntrl  As robotCNTRLtype
Dim LastPosition As XYZ


Dim a As Single
Dim a4 As Single
Dim a8 As Single
Dim a12 As Single
Dim a17 As Single

Dim x4
Dim y4 As Single

Dim x5
Dim y5  As Single

Dim x10 As Single
Dim y10 As Single

Dim x11
Dim y11

InitVars RobNo
If Not redrawpic Then LastPosition = Position(RobNo)


	READDATA RobotFrmDat(RobNo).DevNo, RobotCntrl
	a4 = A3 + (RobotCntrl.Feedback(1) * 2 * pi) / R1
	a8 = (RobotCntrl.Feedback(2) * 2 * pi) / R2 - A7
	a12 = A11 + (RobotCntrl.Feedback(3) * 2 * pi) / R3
	a17 = A16 - (RobotCntrl.Feedback(0) * 2 * pi) / R0
	
	x4 = 0: y4 = -L4
	x5 = x4 + L5 * Sin(a4): y5 = y4 + L5 * Cos(a4)          'Axis 2 centre
	
	a = a4 + a8
	x10 = x5 + L11 * Sin(a): y10 = y5 + L11 * Cos(a)        'Axis 3 centre
	
	'a = a4 + a8 - pi / 2 + a12
	'x25 = x10 + l17 * Sin(a): y25 = y10 + l17 * Cos(a)
	
	a = a4 + a8 - pi / 2 + a12 + A14
	x11 = x10 + L14 * Sin(a): y11 = y10 + L14 * Cos(a)        'Gripper centre

	
	Position(RobNo).X = Format$(x11 * Cos(a17), "##0")
	Position(RobNo).Y = Format$(x11 * Sin(a17), "##0")
	Position(RobNo).z = Format$(y11 * -1, "##0")
	
	a = (a4 + a8 - pi / 2 + a12) * 180 / pi
	Position(RobNo).Ele = Format$(a, "##0")
	
	a = (RobotCntrl.Feedback(4) - F4)
	a = a * 360 / R4  ' * 2 * pi
	Position(RobNo).Rot = Format$(a, "##0")
	
	
	If RobotCntrl.Feedback(5) < 30 Then Position(RobNo).Grip = "Open" Else Position(RobNo).Grip = "Shut"
	
	If LastPosition.X <> Position(RobNo).X Then XYZdata(RobNo).Table1.RefreshColumn = 1
	If LastPosition.Y <> Position(RobNo).Y Then XYZdata(RobNo).Table1.RefreshColumn = 2
	If LastPosition.z <> Position(RobNo).z Then XYZdata(RobNo).Table1.RefreshColumn = 3
	If LastPosition.Ele <> Position(RobNo).Ele Then XYZdata(RobNo).Table1.RefreshColumn = 4
	If LastPosition.Rot <> Position(RobNo).Rot Then XYZdata(RobNo).Table1.RefreshColumn = 5
	If LastPosition.Grip <> Position(RobNo).Grip Then XYZdata(RobNo).Table1.RefreshColumn = 6


'End If



End Sub

