include cyber.inc

.code

Turbopoke proto near pascal, :word, :word
Turbopeek proto near pascal, :word


assume ds:seg robot



ReadDigInput Macro Issue
	
	push cx
	.if robot[bx].SerialIP <=7
		if issue eq 1                           ;RJ45/Turbo bus mentor
			Invoke TurboPeek, 0 
		Else
			invoke xrj45peek, 0         ;read inputs
		Endif
	.else
		if issue eq 1                           ;RJ45/Turbo bus mentor
			Invoke TurboPeek, 1 
		Else
			invoke xrj45peek, 1         ;read inputs
		Endif
		mov ah,al
	.endif
	
	mov dx,1
	mov cx,robot[bx].SerialIP
	shl dx,cl
	pop cx
	test ax,dx
Endm





WriteLow macro Issue
	if issue eq 1
		push di
		mov di,robot.write[bx]
		.IF robot.pulseop[bx] <= 7
			add di,6
			MOV DX,robot[bx].wc_low[0] 
		.ELSE
			add di,7
			MOV DX,robot[bx].wc_low[2] 
		.ENDIF
		mov es:[di],dl
		pop di
	else
		invoke xrj45poke, 0,robot[bx].wc_low[0] 
		invoke xrj45poke, 1,robot[bx].wc_low[2]
	endif
	endm

WriteHigh macro Issue
	if issue eq 1
		push di
		mov di,robot.write[bx]
		.IF robot.pulseop[bx] <= 7
			add di,6
			MOV DX,robot[bx].wc_high[0] 
		.ELSE
			add di,7
			MOV DX,robot[bx].wc_high[2] 
		.ENDIF
		mov es:[di],dl
		pop di
	else
		invoke xrj45poke, 0,robot[bx].wc_high[0]   
		invoke xrj45poke, 1,robot[bx].wc_high[2]
	endif
	endm

WCPulseL Macro issue
	if issue eq 1
		invoke TurboPoke, 6,robot[bx].wc_low[0] 
		invoke TurboPoke, 6,robot[bx].wc_High[0] 
	else
		invoke xrj45poke, 0,robot[bx].wc_low[0] 
		invoke xrj45poke, 0,robot[bx].wc_High[0] 
	endif
Endm

WCPulseH Macro issue
	if issue eq 1
		invoke TurboPoke, 7,robot[bx].wc_low[2] 
		invoke TurboPoke, 7,robot[bx].wc_High[2] 
	else
		invoke xrj45poke, 1,robot[bx].wc_low[2] 
		invoke xrj45poke, 1,robot[bx].wc_High[2] 
	endif
Endm






service_xboard_pulses macro issue          
	set_wc_pulsestates      ;set wc_low and wc_high
	
	.if robot.pulsecount[bx] == 1             
		if issue eq 1
			mov di,robot.write[bx]
			add di,6
			poke di,robot[bx].wc_high[0]
			poke di,robot[bx].wc_low[0]
			inc di
			poke di,robot[bx].wc_high[2]
			poke di,robot[bx].wc_low[2]
		else
			invoke xrj45poke, 0,robot[bx].wc_high[0]
			invoke xrj45poke, 0,robot[bx].wc_low[0]
			   
			invoke xrj45poke, 1,robot[bx].wc_high[2]
			invoke xrj45poke, 1,robot[bx].wc_low[2]
		endif
				
		mov robot.pulsestretch[bx],8             ;keep low for 8 interrupts
				
		mov ax,robot[bx].wc_low[0]                  ;this state written for next
		mov robot[bx].WC.DIG_output[0],ax
				
		mov ax,robot[bx].wc_low[2]                  ;this state written for next
		mov robot[bx].WC.DIG_output[2],ax
	.else
		if issue eq 1
			mov di,robot.write[bx]
			add di,6
			poke di,robot[bx].wc_low[0]
			poke di,robot[bx].wc_high[0]
			inc di
			poke di,robot[bx].wc_low[2]
			poke di,robot[bx].wc_high[2]
		else
			invoke xrj45poke, 0,robot[bx].wc_low[0]
			invoke xrj45poke, 0,robot[bx].wc_high[0]
			   
			invoke xrj45poke, 1,robot[bx].wc_low[2]
			invoke xrj45poke, 1,robot[bx].wc_high[2]
		endif
	.endif
	endm


wait650 macro
	mov cx,19
	.repeat
		timer2wait
	.untilcxz
	endm

wait75 macro
	mov cx,6
	.repeat
		timer2wait
	.untilcxz
	endm

set_wc_pulsestates macro        ;sets wc_low and wc_high
	.if robot.pulsestretch[bx]!=0
		mov ax,robot[bx].wc_high[0]
		mov robot[bx].WC.DIG_output[0],ax
		
		mov ax,robot[bx].wc_high[2]
		mov robot[bx].WC.DIG_output[2],ax
	.endif

	MOV CX,robot.pulseop[bx]     ;OUTPUT TO PULSE
	.if cx<=7
		mov ax,robot.WC.DIG_output[bx+0]    ;current output state
		mov dx,1
		sal dx,cl                   ;2 to power op-1
		or ax,dx
		mov cx,ax
		sub ax,dx
		mov robot[bx].wc_low[0],ax   ;set changes for bank 1
		mov robot[bx].wc_high[0],cx

		mov ax,robot[bx].WC.DIG_output[2]   ; keep bank 2 static
		mov robot[bx].wc_low[2],ax
		mov robot[bx].wc_high[2],ax

	.else
		sub cx,8
		mov ax,robot[bx].WC.DIG_output[2]    ;current output state
		mov dx,1
		sal dx,cl                   ;2 to power op-1
		or ax,dx
		mov cx,ax
		sub ax,dx
		mov robot[bx].wc_low[2],ax   ;set changes for bank 2
		mov robot[bx].wc_high[2],cx

		mov ax,robot[bx].WC.DIG_output[0]   ; keep bank 1 static
		mov robot[bx].wc_low[0],ax
		mov robot[bx].wc_high[0],ax

	.endif
endm



service_xboard macro issue
	
		if issue eq 1
			settimer2 30000
		Else
			settimer2 66000
		endif
			
			if issue eq 1
				mov dx,0
				.repeat
					Mov di,robot.write[bx]
					add di,4
					poke di,dx       ; set adc MUX
					inc di
					poke di,dx        ; start conversion
					
					mov di,robot.read[bx]
					add di,3
					peek di             ; read EOC
					
					bt ax,0
					.if carry?          ; it should be high
						wait650
						peek di         ; re-read EOC
						bt ax,0
						.if !carry?      ; it should be low now
							dec  di
							peek di     ; read ADC
							mov di,dx
							ADD di,di
							mov robot[bx].WC.ANA_inputs[di],ax
							call putonline
						.else 
							call putoffline
						.endif
					.else
						call putoffline
					.endif
					inc dx
				.until dx==8
				
			else
			mov si,0
			mov di,0
			.repeat        
				invoke xrj45poke, 2,si       ; set adc MUX
				invoke xrj45poke, 3,0        ; start conversion
				invoke xrj45peek, 3          ; read EOC
				bt ax,0
				.if !carry?         ; it should be low
					wait75
					invoke xrj45peek, 3      ; re-read EOC
					bt ax,0
					.if carry?      ; it should be high now
						invoke xrj45peek, 2          ; read adc
						mov robot[bx].WC.ANA_inputs[di],ax
						call putonline
					.else 
						call putoffline
					.endif
				.else
					call putoffline
				.endif
				inc di
				inc di
				inc si
			.until si==8
			Endif
		
		if issue eq 1
			mov di,robot.read[bx]
			peek di                         ; read inputs 1 to 8
		else
			invoke xrj45peek, 0              ; read inputs 1 to 8
		Endif
		mov cx,1
		mov di,0
		.repeat
			test ax,cx
			.if zero?
				mov robot[bx].WC.DIG_inputs[di],0
			.else
				mov robot[bx].WC.DIG_inputs[di],1
			.endif
			shl cx,1
			add di,2
		.until di==16


 
		if issue eq 1
			mov di,robot.read[bx]
			inc di
			peek di                         ; read inputs 9 to 16
		else
			invoke xrj45peek, 1              ; read inputs 9 to 16
		endif
		mov di,16
		mov cx,1
		.repeat
			test ax,cx
			.if zero?
				mov robot[bx].WC.DIG_inputs[di],0
			.else
				mov robot[bx].WC.DIG_inputs[di],1
			.endif
			shl cx,1
			add di,2
		.until di==32

		

		
		if issue eq 1
			mov di,robot.write[bx]
			add di,6
			poke di,robot[bx].WC.DIG_output[0]
			inc di
			poke di,robot[bx].WC.DIG_output[2]
		else
			invoke xrj45poke, 0,robot[bx].WC.DIG_output[0]
			invoke xrj45poke, 1,robot[bx].WC.DIG_output[2]
		endif



		.if robot.pulsecount[bx] != 0
			service_xboard_pulses issue
			mov robot.pulsecount[bx],0

		.elseif robot.pulsestretch[bx]!=0
			dec robot.pulsestretch[bx]
			.if robot.pulsestretch[bx]==0
				mov ax,robot[bx].wc_high[0]
				mov robot[bx].WC.DIG_output[0],ax
				
				mov ax,robot[bx].wc_high[2]
				mov robot[bx].WC.DIG_output[2],ax

			.endif
		.endif


		
		.if robot.Serialflag[bx] == true   
			Mov robot.Serialflag[bx],False
			set_wc_pulsestates

			mov robot[bx].SerialOP,0
			
			mov cx,16
			
			.IF robot.pulseop[bx] <= 7
				.repeat
					WCPulseL issue                   ;Low then High
					ReadDigInput Issue
					.if zero?
						CLC
					.else
						STC
					.endif
					rcl robot[bx].SerialOP,1
				.untilcxz
			.else
				.repeat
					WCPulseH issue                   ;Low then High
					ReadDigInput Issue
					.if zero?
						CLC
					.else
						STC
					.endif
					rcl robot[bx].SerialOP,1
				.untilcxz
			.endif
		.endif





		.if robot[bx].rs232flag == true
			mov robot[bx].rs232flag,false
			set_wc_pulsestates

			pushf       ; disable interrupts
			cli         ; want accurate timing

			settimer2 9600  ; set timer2 to toggle at 9600Hz

			mov si,robot[bx].rs232data   ;word to be transmitted

			mov di,7

			timer2wait
		
			WriteLow issue  ;send start bit

			mov cx,8
			.repeat
				timer2wait
				rcr si,1
				.if !carry?
					WriteLow issue
				.else
					WriteHigh issue
				.endif
			.untilcxz
			timer2wait
			WriteHigh issue             ;send stop bit

			popf        ;recover interrupt state

			mov ax,robot[bx].wc_high[0]
			mov robot[bx].WC.DIG_output[0],ax
			
			mov ax,robot[bx].wc_high[2]
			mov robot[bx].WC.DIG_output[2],ax
		.endif
	
	settimer2 66000
endm


service_turbo_xboard proc
comment *
	W+4 ADC MUX
	W+5 ADC SC
	W+6 Ops 1-8
	W+7 Ops 9-16

	R   Ips 1-8
	R+1 Ips 9-16
	R+2 ADC
	R+3 ADC EOC bit 0
*

	mov ax,es
	.if ax!=0
		Service_Xboard 1    
	.endif
	ret
service_turbo_xboard endp

service_rj45_xboard proc
comment *
	W+0 Ops 1-8
	W+1 OPs 9-16
	W+2 ADC MUX
	W+3 ADC SC

	R   Ips 9-16
	R+1 Ips 1-8
	R+2 ADC
	R+3 ADC EOC bit 0

*
	
	.IF rj45base==0                             ; Serial card not present
		mov robot[bx].rs232flag,false    ; do nothing    
		mov robot[bx].Serialflag,false    ; do nothing    
		mov robot.pulsecount[bx],0           
		ret
	.endif
	
	Service_Xboard 2    
	ret                                         
	
service_rj45_xboard endp




service_turbo_xboard_pulses proc
	service_xboard_pulses 1
	ret
service_turbo_xboard_pulses endp


service_rj45_xboard_pulses proc
	service_xboard_pulses 2
	ret
service_rj45_xboard_pulses endp



TurboPoke proc near pascal uses di address:word, data:word
	mov di,robot.write[bx]
	add di,Address
	Poke di,data
	ret
TurboPoke Endp


TurboPeek proc near pascal uses di address:word
	mov di,robot.read[bx]
	Add di,Address
	peek di
	Ret
TurboPeek Endp



ifdef winnt
xrj45poke proc pascal address:word, data:word
	ret
xrj45poke endp

xrj45peek proc pascal address:word
	ret
xrj45peek endp

else


xrj45poke proc pascal address:word, data:word
	
	PUSHa
	rj45wait                ;side effect sets dx as base pointer
	   
	mov dx,rj45base
	mov ax,data
	out dx,al

	add dx,2
	mov ax,address
	out dx,al

	add dx,2
	mov ax,rj45id            ;status - write device
	out dx,al

	add dx,2
	out dx,al               ;send cycle

	add dx,2
	out dx,al               ;start cycle

	POPa

	ret

xrj45poke endp

xrj45peek proc pascal address:word
	PUSH CX
	rj45wait                ;side effect sets dx as base pointer
	
	add dx,2
	mov ax,address
	out dx,al

	add dx,2
	mov ax,rj45id             ;status - read device
	inc ax
	
	out dx,al

	add dx,2
	out dx,al               ;send cycle

	add dx,2
	out dx,al               ;start cycle

	rj45wait                ;side effect sets dx as base pointer

	add dx,4
	mov ax,254              ;dummy status - read device
	out dx,al

	add dx,4
	out dx,al               ;start cycle

	rj45wait

	add dx,2
	in al,dx
	mov ah,0
	POP CX

	ret
xrj45peek endp


endif


service_xboard_offline proc
	mov robot.pulsecount[bx],0
	mov robot.Serialflag[bx],false
	mov robot.rs232flag[bx],false
	ret
service_xboard_offline Endp


end






