SUBTTL Constants     
TITLE **  Control Program for 8032 GRYPHON - Version 1.0 14/02/95 **

PLEN 100

;LOAD
    
LIST ; to allow 'L' switch at command line


NULL        equ 0     ;timer 0/1 function call - set r4/5


EPROM       equ 0ffh   ; IBM peek EPROM page
INTERNAL    equ 0feh   ; IBM peek internal RAM page
window      equ 99


AXIS0_SPD equ 00000000b     ; Axis 0 is channel 0 on slave 1
AXIS3_SPD equ 00100000b     ; Axis 3 is channel 1 on slave 1
AXIS4_SPD equ 01000000b     ; Axis 4 is channel 2 on slave 1

AXIS1_SPD equ 00000000b     ; Axis 1 is channel 0 on slave 2
AXIS2_SPD equ 00100000b     ; Axis 2 is channel 1 on slave 2



maxdelay    EQU 0      ; Maximum seed value for timer2 


; HARDWARE ADDRESSES


lsblatch        equ     0a000h  ; latch for lsb address
intlatch        equ     0a001h  ; interrupt from IBM, Ext0
datalatch       equ     0a002h  ; 

workcell_i      equ     0c600h  ; inputs from workcell          - r
workcell_o      equ     0ca00h  ; outputs to workcell           - w

datastrobe      equ     0d200h  ; write strobe at RJ45 interface
dataoen         equ     0d600h  ; data out enable

slave0          equ     0dc00h  ; encoder slave letterbox address r/w
slave1          equ     0dc40h  ; Axes 0,3,4 slave letterbox address r/w
slave2          equ     0dc80h  ; Axes 1,2 slave letterbox address r/w


; INTERNAL RAM MAP



rbank0          equ     00h      ; register bank 0 - Baseloop
rbank1          equ     08h      ; register bank 1 - IBM interrupt
rbank2          equ     010h     ; register bank 2 - 
rbank3          equ     018h     ; register bank 3  

lastjam    equ 20h
last_stalled0 bit lastjam.0 
last_stalled1 bit lastjam.1 
last_stalled2 bit lastjam.2 
last_stalled3 bit lastjam.3 
last_stalled4 bit lastjam.4 


adccontrol equ 21h
adcvalid    bit adccontrol.0    ; set by 8032, cleared by IBM


wco_stat        equ     023h     ; states of workcell outputs - FIXED LOCATION
wco_stat0       bit     wco_stat.0
wco_stat1       bit     wco_stat.1
wco_stat2       bit     wco_stat.2
wco_stat3       bit     wco_stat.3
wco_stat4       bit     wco_stat.4
wco_stat5       bit     wco_stat.5
wco_stat6       bit     wco_stat.6
wco_stat7       bit     wco_stat.7

flags       equ 024h
pen0        bit flags.0
pen1        bit flags.1
pen2        bit flags.2
pen3        bit flags.3
pen4        bit flags.4

pen_active  bit flags.5
enable_pen  bit flags.6
dir         bit flags.7


stallflags equ 025h
stalled0   bit stallflags.0
stalled1   bit stallflags.1
stalled2   bit stallflags.2
stalled3   bit stallflags.3
stalled4   bit stallflags.4

stallflags_ibm equ 026h ; copy for IBM to read
    

inpos       equ 027h          ;fixed location
axis0_inpos bit inpos.0
axis1_inpos bit inpos.1
axis2_inpos bit inpos.2
axis3_inpos bit inpos.3
axis4_inpos bit inpos.4
axis5_inpos bit inpos.5
jammed      bit inpos.6
zeroing     bit inpos.7


flags2 equ inpos+1

grip_press bit flags2.0
ibm_mode   bit flags2.1
enable_jam bit flags2.2
inner0     bit flags2.3
inner1     bit flags2.4
inner2     bit flags2.5
inner3     bit flags2.6
inner4     bit flags2.7


timer2_func     equ     flags2+1
wco_low         equ     timer2_func+1
wco_high        equ     wco_low +1
wco_next        equ     wco_high  +1
pulse_width     equ     wco_next +1

control0        equ     pulse_width+1
control1        equ     control0+1
control2        equ     control1+1
control3        equ     control2+1
control4        equ     control3+1

stall0  equ control4+1
stall1  equ stall0+1
stall2  equ stall1+1
stall3  equ stall2+1
stall4  equ stall3+1

last_encpos0 equ stall4+1    
last_encpos1 equ last_encpos0+2
last_encpos2 equ last_encpos1+2
last_encpos3 equ last_encpos2+2
last_encpos4 equ last_encpos3+2

E equ last_encpos4+2
R equ E+2
;stalledcnt equ R+2

led_cnt         equ     R+2
led_cnt_seed    equ     led_cnt+1



mcntrl          equ     050H            ; FIXED LOCATION
wcntrl          equ     mcntrl+1        ; workcell control
scntrl          equ     wcntrl+1
mcntrl_copy     equ     scntrl+1   
pen_copy        equ     mcntrl_copy+1

rs232_mess      equ     05bh            ; Byte to send as "RS232" via workcell
pulses_no       equ     rs232_mess+1    ; number of workcell pulses to be sent
pulses_rate     equ     pulses_no+2     ; rate to send workcell pulses


despos0         equ 060h
despos1         equ 062h
despos2         equ 064h
despos3         equ 066h
despos4         equ 068h
despos_grip     equ 06ah
despos_speed    equ 06bh
maxerror        equ 06ch
seqcnt          equ 06dh

encpos0         equ 070h
encpos1         equ 072h
encpos2         equ 074h
encpos3         equ 076h
encpos4         equ 078h
encpos_grip     equ 07ah
encpos_speed    equ 07bh

seqptr          equ 07ch

csum            equ 07eh      


rawadc          equ 080h            ;Result from ADC chip


stack           equ     090H


runcnt          equ 0f0h
stallcnt0       equ runcnt+2
stallcnt1       equ stallcnt0+1
stallcnt2       equ stallcnt1+1
stallcnt3       equ stallcnt2+1
stallcnt4       equ stallcnt3+1

scratch         equ 0ffh        ; used only by IBM    



; PROGRAM MEMORY MAP

PAGE 
SUBTTL Interrupt Vectors

;base           equ     08000h  ; alternatives for RAM and ROM versions
base           equ     0h

ORG     base
PAD     0ffh                    ; to fill unallocated locations


; SET-UP INTERRUPT VECTORS AT START OF PROGRAM SPACE


ORG     base+0h                 ; reset vector address
        jmp     begin           ; start of initialisation

ORG     base+03h                ; external interrupt 0 vector address
        jmp     ibmint          ; used for IBM communications

ORG     base+0bh                ; timer0 interrupt vector
        jmp timer0

ORG     base+13h                ; external interrupt 1 vector address
        reti

ORG     base+1bh                ; timer1 interrupt vector
        RETI

ORG     base+23h                ; serial port vector address
        reti

org     base+2bh                ; timer2 interrupt vector
        jmp     timer2
        ;reti

ORG     base+30h                ; to be tidy


; PROM IDENTIFICATION


        db      "GRYP","1.02"     ; Gryphon program, version 1



        db      "5/07/95 ",169," Cybernetic Applications 1995",0    ; Null terminated






PAGE
     
SUBTTL INITIALISATION / RESET

;nb. uses register set 0, as does Baseloop

begin:
        mov  sp,#stack          ; initialise stack pointer 
        
        mov  dptr,#intlatch     ; clear possible IBM interrupt states
        movx a,@dptr

        mov dptr,#Slave0        ; Clear possible interrupt state on encoder slave
        movx a,@dptr
        
        mov dptr,#Slave1
        movx a,@dptr
        
        mov dptr,#Slave2
        movx a,@dptr

        clr a                   ; Clear all internal RAM
        mov r0,#255
clearram:
        mov @r0,a
        djnz r0,clearram
        
        
        mov  wco_stat,#0ffh     ; Set all workcell outputs high
        mov  a,wco_stat         ; send to workcell outputs
        mov  dptr,#workcell_o
        movx @dptr,a            

        mov  dptr,#0ce00h       ; send gripper data
        mov  a,despos_grip
        mov  encpos_grip,a
        movx @dptr,a

        lcall initadc
        
        
        
        
        mov dptr,#0         ; Calculate EPROM checksum
        mov r0,#0
        mov r1,#0
gc1:
        clr a
        movc a,@a+dptr

        add a,r0
        mov r0,a

        clr a
        addc a,r1
        mov r1,a

        inc dptr
        mov a,dph
        cjne a,#40h,gc1     ; done all EPROM?

        mov csum,r0      ; save for IBM
        mov csum+1,r1

        mov led_cnt,#8          ; set led flash freq    
        mov led_cnt_seed,#8



; Set-up Interrupts and their Priorities


        mov rcap2l,#low  maxdelay
        mov rcap2h,#high maxdelay
        mov t2con,#00000100b    ; timer2, 16bit autoreload timer

        ; To enable serial debugger:        
        ; replace following

;       mov t2con,#00110100b    ; serial generat
;       mov rcap2l,#low  65484  ; gives 9615 baud
;       mov rcap2h,#high 65484
;       mov scon,#01000000b
;       mov sbuf,a
        
        mov  tmod,#00010001b    ; timer0, timer1 both 16 bit timers
        mov  tcon,#00010000b    ; ext0 and ext1 level triggered, timer 0 running
        
        mov  ie  ,#10100011b    ; enable ext0 timer2,timer0  
        mov  ip  ,#00000001b    ; ext0 high priority


    clr  jammed
;    mov control0,#AXIS0_SPD
;    mov control1,#AXIS1_SPD
;    mov control2,#AXIS2_SPD
;    mov control3,#AXIS3_SPD
     
     
;    mov control4,#AXIS4_SPD

    setb enable_jam

    mov despos_speed,#3         ; Default to fastest
    acall setmaxerror
    acall home
    


;    clr enable_jam


    page
     
     
    SUBTTL Baseloop

    lcall startadc
    
    setb enable_pen    
    

BASELOOP:


    lcall readadc

    mov a,mcntrl
    jz bl1

    mov mcntrl,#0
    mov mcntrl_copy,a
    mov dptr,#master_decode
    jmp @a+dptr             ; will return to bl0
bl0:
    mov scntrl,mcntrl_copy


bl1:
    
    mov dptr,#0ce00h        ; read pendant
                            ; bits 0,1,2,3 = function
                            ; bit 4 = gripper
                            ; bit 5 = speed
    movx a,@dptr
;    jb acc.7,bl1a           ; power on?
;    acall nopower
;    jmp baseloop
;
;
;bl1a:
    jnb enable_pen,bl2
    anl a,#63
    mov pen_copy,a
    cjne a,#63,bl4          ; any key pressed
    clr pen_active          ; no - speed will be set by IBM
    jmp bl5
bl4:
    setb pen_active         ; yes - put in charge
    mov maxerror,#26
    jb  acc.5,bl5           
    mov maxerror,#2

bl5:
    
    jnb acc.4,bl6           ; gripper switch down
    clr grip_press          ; no
    jmp bl7
bl6:    
    jb   grip_press,bl7     ; yes, but it was last time as well
    setb grip_press         ; mark pressed, for next time
    mov a,despos_grip       ; toggle the gripper
    cpl acc.4
    mov despos_grip,a
    
bl7:
    
    anl a,#15 
    rl  a
    mov dptr,#pen_decode
    jmp @a+dptr             ; will return to bl2
bl2:
    
    lcall testjams_noread
    
    jb pen_active,bl3
    
    acall setmaxerror

bl3:    
    
    mov   a,stallflags      ; any axis jammed?
    jz    bl8

    mov  stallflags_ibm,a   ; tell ibm which axes are jammed
    mov  stallflags,#0      ; re-enable servo
                            ; want to be able to use pendant to back off
    
;    mov a,stalledcnt
;    jz bl9
;    djnz stalledcnt,bl8     ; only report multiple jams
;                            ; stalledcnt incremented by timer
;bl9:    
    setb jammed             ; tell IBM

emer_stop:
    orl flags,#01011111b     ; == setb pen0 etc   
    ;setb  pen0              ; causes despos=encpos when stopped
    ;setb  pen1              ; causes despos=encpos when stopped
    ;setb  pen2              ; causes despos=encpos when stopped
    ;setb  pen3              ; causes despos=encpos when stopped
     
     
    ;setb  pen4              ; causes despos=encpos when stopped
    ;setb  enable_pen
    JMP BASELOOP


bl8:
    acall servoarm
    JMP BASELOOP


nopower:
    clr   a 
    mov   r0,#encpos0       ; point to data to change
    lcall update_posn
    mov   a,#30
    lcall send_control0
    
    mov   a,#2
    mov   r0,#encpos1       ; point to data to change
    lcall update_posn
    mov   a,#30
    lcall send_control1
    
    mov   a,#6
    mov   r0,#encpos3         ; point to data to change
    lcall update_posn
    mov   a,#30
    lcall send_control2
    
    mov   a,#4
    mov   r0,#encpos2         ; point to data to change
    lcall update_posn
    mov   a,#30
    lcall send_control3
    
    mov   a,#8
    mov   r0,#encpos4         ; point to data to change
    lcall update_posn
    mov   a,#30
    lcall send_control4
    

    mov  dptr,#0ce00h       ; send gripper data
    mov  a,despos_grip
    mov  encpos_grip,a
    movx @dptr,a

    ret




servoarm:
    mov dptr,#0ce00h
    movx a,@dptr
    jb acc.7,servoarm_1     ; power on?
    acall nopower
    ret

servoarm_1:
    clr   a 
    mov   r0,#encpos0       ; point to data to change
    lcall update_posn
    acall servo0
    
    mov   a,#2
    mov   r0,#encpos1       ; point to data to change
    lcall update_posn
    acall servo1

    mov a,#6
    mov r0,#encpos3         ; point to data to change
    lcall update_posn
    acall servo3
    
    mov a,#4
    mov r0,#encpos2         ; point to data to change
    lcall update_posn
    acall servo2
    
    mov a,#8
    mov r0,#encpos4         ; point to data to change
    lcall update_posn
    acall servo4


    mov  dptr,#0ce00h       ; send gripper data
    mov  a,despos_grip
    mov  encpos_grip,a
    movx @dptr,a

    ret



pen_decode:
    ajmp pen_0m         ;0
    ajmp pen_0p         ;1
    ajmp pen_1m         ;2
    ajmp pen_1p         ;3
    ajmp pen_2m         ;4
    ajmp pen_2p         ;5
    ajmp pen_em         ;6
    ajmp pen_ep         ;7
    ajmp pen_rm         ;8
    ajmp pen_rp         ;9
    ajmp bl2            ;10     
    ajmp pen_runin      ;11
    ajmp bl2            ;12
    ajmp bl2            ;13
    ajmp bl2            ;14
    ajmp pen_end        ;15


master_decode:                   ; jump table for IBM intructions
    ajmp bl0                     ; 0 - unused
    ajmp nojams                  ; 2 - turn arm jam off
    ajmp jams                    ; 4 - turn arm jams back on
    ajmp nopen                   ; 6 - turn pendant off
    ajmp emer_stop               ; 8 
    ajmp jog_0m                  ; 10 - move axis 0 towards 0   
    ajmp jog_0p                  ; 12
    ajmp jog_1m                  ; 14 - move axis 1 towards 0   
    ajmp jog_1p                  ; 16
    ajmp jog_2m                  ; 18 - move axis 2 towards 0   
    ajmp jog_2p                  ; 20
    ajmp jog_3m                  ; 22 - move axis 3 towards 0   
    ajmp jog_3p                  ; 24
    ajmp jog_4m                  ; 26 - move axis 4 towards 0   
    ajmp jog_4p                  ; 28
    ajmp jog_5m                  ; 30 - open gripper  
    ajmp jog_5p                  ; 32
    ajmp jog_em                  ; 34 - move axes 3 and 4 towards 0   
    ajmp jog_ep                  ; 36
    ajmp jog_rm                  ; 38 - move axes 3 towards 0  4 +ve 
    ajmp jog_rp                  ; 40
    ajmp jog_sm                  ; 42 - Speed -ve
    ajmp jog_sp                  ; 44 - Speed +ve  
    
    ajmp jog_end                 ; 46 - end of jog, re-enable pendant
    ajmp jog_end                 ; 48
    ajmp jog_clearjam            ; 50
    ajmp jog_home                ; 52
    ajmp jog_reset               ; 54

nopen:
    clr enable_pen
    ajmp bl0

nojams:
    clr  enable_jam
    ajmp bl0

jams:
    setb enable_jam
    ajmp bl0

jog_clearjam:
    clr jammed                  ; clear arm jammed flag
    mov stallflags,#0
    mov stall0,#10
    mov stall1,#10
    mov stall2,#10
    mov stall3,#10
    mov stall4,#10

;    mov control0,#AXIS0_SPD
;    mov control1,#AXIS1_SPD
;    mov control2,#AXIS2_SPD
;    mov control3,#AXIS3_SPD
;    mov control4,#AXIS4_SPD

    ajmp bl0

jog_sm:
    mov a,despos_speed
    jz  sm_1
    dec a
sm_1:    
    mov despos_speed,a
    ajmp bl0

jog_sp:
    mov a,despos_speed
    cjne a,#3,sp_1
    ajmp bl0
     
     
sp_1:    
    inc a
    mov despos_speed,a
    ajmp bl0


jog_0m:
    clr enable_pen
    ajmp pen_0m
jog_0p:
    clr enable_pen
    ajmp pen_0p
jog_1m:
    clr enable_pen
    ajmp pen_1m
jog_1p:
    clr enable_pen
    ajmp pen_1p
jog_2m:
    clr enable_pen
    ajmp pen_2m
jog_2p:
    clr enable_pen
    ajmp pen_2p
jog_3m:
    clr enable_pen
    jb pen3,jog_3m1
    lcall setmin3
    setb pen3
jog_3m1:    
    ajmp bl2 
jog_3p:
    clr enable_pen
    jb pen3,jog_3m1
    lcall setmax3
    setb pen3
    ajmp bl2 
jog_4m:
    clr enable_pen
    jb pen4,jog_3m1
    lcall setmin4
    setb pen4
    ajmp bl2 
jog_4p:
    clr enable_pen
    jb pen4,jog_3m1
    lcall setmax4
    setb pen4
    ajmp bl2 

jog_5m:
    mov despos_grip,#0
    ajmp bl2 

jog_5p:
    mov despos_grip,#16
    ajmp bl2 

jog_em:
    clr enable_pen
    ajmp pen_em
jog_ep:
    clr enable_pen
    ajmp pen_ep
jog_rm:
    clr enable_pen
    ajmp pen_rm
jog_rp:
    clr enable_pen
    ajmp pen_rp
jog_end:
    setb enable_pen
    ajmp pen_end
jog_home:
jog_reset:

    jmp bl0


pen_0m:
    mov despos0  , #low 1024
    mov despos0+1, #high 1024
    setb pen0
    ajmp bl2
pen_0p:
    mov despos0  , #low 10024       ; 9000 + 1024 = 10024       
    mov despos0+1, #high 10024
    setb pen0
    ajmp bl2

pen_1m:
    mov despos1  , #low 1024
    mov despos1+1, #high 1024
     
     
    setb pen1
    ajmp bl2
pen_1p:
    mov despos1  , #low 6524        ; 5500 + 1024
    mov despos1+1, #high 6524
    setb pen1
    ajmp bl2

pen_2m:
    mov despos2  , #low 1024
    mov despos2+1, #high 1024
    setb pen2
    ajmp bl2
pen_2p:
    mov despos2  , #low 10974       ; 9950 + 1024 = 10974
    mov despos2+1, #high 10974
    setb pen2
    ajmp bl2 

pen_em:
    jb pen3,pen_em1
    jb pen4,pen_em1
    lcall setmine
pen_em1:    
    ajmp bl2 

pen_ep:
    jb pen3,pen_em1
    jb pen4,pen_em1
    lcall setmaxe
    ajmp bl2 

pen_rm:
    jb pen3,pen_em1
    jb pen4,pen_em1
    lcall setminr
    ajmp bl2 

pen_rp:
    jb pen3,pen_em1
    jb pen4,pen_em1
    lcall setmaxr
    ajmp bl2 


pen_end:
    jnb pen0,pen_end1
    mov despos0  ,encpos0
    mov despos0+1,encpos0+1
    acall servo0
    jnb axis0_inpos,pen_end1
    clr pen0

pen_end1:
    jnb pen1,pen_end2
    mov despos1  ,encpos1
    mov despos1+1,encpos1+1
    acall servo1
    jnb axis1_inpos,pen_end2
    clr pen1

pen_end2:
    jnb pen2,pen_end3
    mov despos2  ,encpos2
    mov despos2+1,encpos2+1
    acall servo2
    jnb axis2_inpos,pen_end3
    clr pen2

pen_end3:
    jnb pen3,pen_end4
    mov despos3  ,encpos3
    mov despos3+1,encpos3+1
    lcall limit3
    acall servo3
    jnb axis3_inpos,pen_end4
    clr pen3

pen_end4:
    jnb pen4,pen_end5
    mov despos4  ,encpos4
    mov despos4+1,encpos4+1
    lcall limit4
    acall servo4
    jnb axis4_inpos,pen_end5
    clr pen4

pen_end5:

    ajmp bl2




pen_runin:
    
    clr a 
    mov r0,#runcnt
    
pen_clear:    
    mov @r0,a
    inc r0
    cjne r0,#stallcnt4 + 1,pen_clear


    mov seqptr  ,#low runseq        ; set pointer to start of sequence
    mov seqptr+1,#high runseq
    mov seqcnt,#1
    mov seqcnt+1,#1

    ajmp pen_run2                   ; send first line
    

pen_run0:    
    mov  a,mcntrl
    jz   pen_run1
    ajmp baseloop       ; return to baseloop
    
pen_run1:
    mov stallflags,#0   ; reset jmammed axes

    mov a,inpos
    anl a,#01fh
    cjne a,#01fh,pen_run4
                         ;arm inposition, set up new data

pen_run2:
    djnz seqcnt  ,pen_run4
    djnz seqcnt+1,pen_run4

    mov seqcnt+1,#16
    
    mov dpl,seqptr
    mov dph,seqptr+1
    mov r0,#despos_speed

    clr  a
    movc a,@a+dptr
    inc  dptr
    jnz  pen_run3

    mov r0,#runcnt
    inc @r0
    mov a,@r0
    jnz pen_run2a
    
    inc r0
    inc @r0
    mov a,@r0
    jnz pen_run2a
    
    jmp baseloop

pen_run2a:    
    mov seqptr  ,#low runseq    ;at end of sequence point back to start
    mov seqptr+1,#high runseq
    ajmp pen_run2


pen_run3:
    clr a
    movc a,@a+dptr
    mov @r0,a
    inc dptr            ; inc pointer to source
    dec r0              ; dec pointer to dest
    mov a,r0
    cjne a,#despos0-1,pen_run3

    mov seqptr,dpl
    mov seqptr+1,dph

pen_run4:
    acall servoarm
    lcall testjams_noread
    ajmp pen_run0


     

servo0:
    clr  c
    mov  a,despos0
    subb a,encpos0
    mov  r6,a           ; LSB error
    
    mov  a,despos0+1
    subb a,encpos0+1
    mov  r7,a           ; MSB error
    
    mov dir,c          ; save direction
    jnc setspd0

    clr  c
    mov  a,encpos0
    subb a,despos0
    mov  r6,a           ; absolute LSB error
    
    mov  a,encpos0+1
    subb a,despos0+1
    mov  r7,a           ; absolute MSB error

setspd0:
    anl a,#11111100b
    jz setspd0_1
    
    mov a,maxerror      ; 14 for fast, 12, 10, or 6 for slow
    jmp setdir0

setspd0_1:
    
    mov a,r7
    add a,  #HIGH error0
    mov dph,a
    mov dpl,#LOW  error0

    acall readerror     ; pointed to by dptr,r6
    cjne a,#window,setdir0 
    mov a,#2
    jnb inner0,setdir0
    clr a
setdir0:
    jz   send0_in       ; stopped? - don't add direction
    clr  inner0             
    mov  c,dir
    cpl  c              ; reverse - keeps wiring for axes same
    mov  acc.0,c        ; make signed speed
send0:   
    acall send_control0
    ret

send0_in:
    setb inner0         ; real stop open window
    jmp send0





servo1:
    clr  c
    mov  a,despos1
    subb a,encpos1
    mov  r6,a           ; LSB error
    
    mov  a,despos1+1
    subb a,encpos1+1
    mov  r7,a           ; MSB error
    mov dir,c           ; save direction
    jnc setspd1

    clr  c
    mov  a,encpos1
    subb a,despos1
    mov  r6,a           ; absolute LSB error
    
    mov  a,encpos1+1
    subb a,despos1+1
    mov  r7,a           ; absolute MSB error

setspd1:
    anl a,#11111100b
    jz setspd1_1
    
    mov a,maxerror      ; = 14 for fast
    jmp setdir1

setspd1_1:
    
    mov a,r7
    add a,  #HIGH error1
    mov dph,a
    mov dpl,#LOW  error1
    
    acall readerror     ; pointed to by dptr,r6
    cjne a,#window,setdir1
    mov a,#2
    jnb inner1,setdir1
    clr a

setdir1:
    jz   send1_in       ; stopped? - don't add direction
    clr  inner1
    mov  c,dir
    mov  acc.0,c        ; make signed speed
    
send1:   
    acall send_control1
    ret

send1_in:  
    setb inner1
    jmp send1



servo2:
    clr  c
    mov  a,despos2
    subb a,encpos2
    mov  r6,a           ; LSB error
    
    mov  a,despos2+1
    subb a,encpos2+1
    mov  r7,a           ; MSB error
    mov dir,c          ; save direction
    jnc setspd2

    clr  c
    mov  a,encpos2
    subb a,despos2
    mov  r6,a           ; absolute LSB error
    
    mov  a,encpos2+1
    subb a,despos2+1
    mov  r7,a           ; absolute MSB error

setspd2:
    anl a,#11111100b    ; 1024 error entries for axis 2
    jz setspd2_1
    
    mov a,maxerror      ; = 14 for fast
    jmp setdir2

setspd2_1:
    
    mov a,r7
    add a,  #HIGH error2
    mov dph,a
    mov dpl,#LOW  error2
    
    acall readerror     ; pointed to by dptr,r6
    cjne a,#window,setdir2
    mov a,#2
    jnb inner2,setdir2
    clr a

setdir2:
    jz   send2_in       ; stopped? - don't add direction
    clr  inner2
    mov  c,dir
    cpl  c              ; reverse - keeps wiring for axes same
    mov  acc.0,c        ; make signed speed
    
send2:   
    lcall send_control2
    ret
send2_in:
    setb inner2
    jmp  send2


servo3:
    clr  c
    mov  a,despos3
    subb a,encpos3
    mov  r6,a           ; LSB error
    
    mov  a,despos3+1
    subb a,encpos3+1
    mov  r7,a           ; MSB error
    mov dir,c          ; save direction
    jnc setspd3

    clr  c
    mov  a,encpos3
    subb a,despos3
    mov  r6,a           ; absolute LSB error
    
    mov  a,encpos3+1
    subb a,despos3+1
    mov  r7,a           ; absolute MSB error

setspd3:
    jz setspd3_1        ; 256 error entries for axis 3 
    
    mov a,maxerror      ; = 14 for fast
    jmp setdir3

setspd3_1:
    mov dptr,#error3      
    acall readerror     ; pointed to by dptr,r6
    cjne a,#window,setdir3
    mov a,#2
    jnb inner3,setdir3
    clr a
setdir3:
    jz   send3_in       ; stopped? - don't add direction
    clr  inner3
    mov  c,dir
    mov  acc.0,c        ; make signed speed
    
send3:   
    lcall send_control3
    ret

send3_in:
    setb inner3
    jmp send3


servo4:
    clr  c
    mov  a,despos4
    subb a,encpos4
    mov  r6,a           ; LSB error
    
    mov  a,despos4+1
    subb a,encpos4+1
    mov  r7,a           ; MSB error
    mov dir,c          ; save direction
    jnc setspd4

    clr  c
    mov  a,encpos4
    subb a,despos4
    mov  r6,a           ; absolute LSB error
    
    mov  a,encpos4+1
    subb a,despos4+1
    mov  r7,a           ; absolute MSB error

setspd4:
    jz setspd4_1        ; 256 error entries for axis 4
    
    mov a,maxerror      ; = 14 for fast
    jmp setdir4

setspd4_1:
    mov dptr,#error4
    acall readerror     ; pointed to by dptr,r6
    cjne a,#window,setdir4
    mov a,#2
    jnb inner4,setdir4
    clr a
setdir4:
    jz   send4_in       ; stopped? - don't add direction
    clr  inner4
    mov  c,dir
    mov  acc.0,c        ; make signed speed
    
send4:   
    lcall send_control4
    ret

send4_in:
    setb inner4
    jmp send4


setmaxerror:
    mov a,despos_speed
    mov encpos_speed,a
    jnz spd1
    mov maxerror,#2
    ret
spd1:
    cjne a,#1,spd2
    mov maxerror,#10
    ret
spd2:
    cjne a,#2,spd3
    mov maxerror,#18
    ret
spd3:
    mov maxerror,#26
    ret



readerror:
    mov  a,r6           ; lsb error
    movc a,@a+dptr      ; read unsigned speed from error table

    cjne a,#window,re0
    ret

re0:
    cjne a,maxerror,re1
    ret                 ; a = maxerror, ok
re1:
    jc re2              ; jump if a < maxerror
    mov a,maxerror
re2:
    ret



update_posn:
    mov dptr,#Slave0
    
    movx @dptr,a        ; Request data from encoder slave
    jb p3.3,$           ; wait for slave to respond
    movx a,@dptr        ; Read data from slave
    
;    mov change,a
    jb acc.7,neg_change
    
    add a,@r0
    mov @r0,a
    jnc nomodmsb

    inc r0              ; Increment pointer, to point to msb
    inc @r0             ; increment msb
    ajmp nomodmsb

neg_change:
    cpl a
    inc a
;    mov change,a
    xch a,@r0
    clr c
    subb a,@r0
    mov @r0,a
    
    inc r0
    mov a,@r0
    subb a,#0
    mov @r0,a

nomodmsb:
    

    ret





home:
    setb zeroing            ; show IBM we're zeroing
    clr ibm_mode

home_0:

    lcall testjams

home_00:
    
    mov a,mcntrl
    jz home_01
    mov mcntrl,#0
    setb ibm_mode
    
    mov dptr,#home_decode
    jmp @a+dptr             ; will return to home_02 or home_0

home_02:
    clr ibm_mode
     
home_01:
    jb ibm_mode,home_0


    mov dptr,#0ce00h
    movx a,@dptr

    jb acc.7,home_01a           ; power on?
    jmp home_null

home_01a:    
    mov maxerror,#26        ; assume fast
    jb  acc.5,home_1        ; slow pressed?
    mov maxerror,#2         ; set slow
home_1:    
    anl a,#63
    mov pen_copy,a
    
    anl a,#15
    rl a    
    mov dptr,#hometab
    jmp @a+dptr
hometab:
    ajmp home_0m    ;0
    ajmp home_0p    ;1
    ajmp home_1m    ;2
    ajmp home_1p    ;3
    ajmp home_2m    ;4
    ajmp home_2p    ;5
    ajmp home_em    ;6
    ajmp home_ep    ;7
    ajmp home_rm    ;8
    ajmp home_rp    ;9
    ajmp home_end   ;10
    ajmp home_null  ;11
    ajmp home_null  ;12
    ajmp home_null  ;13
    ajmp home_null  ;14
    ajmp home_null  ;15
    
home_0m:    
    mov  a,maxerror
    lcall send_control0
    jmp home_0

home_0p:    
    mov  a,maxerror
    setb acc.0
    lcall send_control0
    jmp home_0


home_1m:    
    mov  a,maxerror
    setb acc.0
    lcall send_control1
    jmp home_0

home_1p:    
    mov  a,maxerror
    lcall send_control1
    jmp home_0

home_2m:    
    mov  a,maxerror
    lcall send_control2
    jmp home_0

home_2p:    
    mov  a,maxerror
    setb acc.0
    lcall send_control2
    jmp home_0
    

home_em:    
    mov  a,maxerror
    setb acc.0
    lcall send_control3
    mov  a,maxerror
    setb acc.0
    lcall send_control4
    jmp home_0

home_ep:    
    mov  a,maxerror
    lcall send_control3
    mov  a,maxerror
    lcall send_control4
    jmp home_0

home_rm:    
    mov  a,maxerror
    setb acc.0
    lcall send_control3
    mov  a,maxerror
    lcall send_control4
    jmp home_0

home_rp:    
    mov  a,maxerror
    lcall send_control3
    mov  a,maxerror
    setb acc.0
    lcall send_control4
    jmp home_0


home_null:    
    mov stallflags,#0
    
    clr a
    lcall send_control0
    clr a
    lcall send_control1
    clr a
    lcall send_control2
    clr a
    lcall send_control3
    clr a
    lcall send_control4
    
    jmp home_0


home_end:
    mov a,pen_copy
    jb acc.4,home_null
    jb acc.5,home_null

home_end_ibm:


; send control byte to send each axis to its endstop - wait til stalled

    setb enable_jam             ; arm jams need to be recognised
    mov stallflags,#0
    
he_0:
    acall waitpower
    mov  a,#27                  ; send command for minimum rotation
    lcall send_control3
    mov  a,#26
    lcall send_control4
    lcall testjams
    jnb stalled3,he_0           ; wait until both wrist
    jnb stalled4,he_0           ; axes are stalled
    
    mov stallflags,#0
    
he_1:
    acall waitpower
    mov  a,#26                  ; send command elbow minimum
    lcall send_control2
    lcall testjams
    jnb stalled2,he_1           ; wait until axis 2 stalled
    
    mov stallflags,#0
    
he_2:
    acall waitpower
    mov  a,#26                  ; send command shoulder maximum
    lcall send_control1
    lcall testjams
    jnb stalled1,he_2           ; wait until axis 1 stalled
    
    mov stallflags,#0
    
he_3:
    acall waitpower
    mov  a,#26                  ; send command waist minimum
    lcall send_control0
    lcall testjams
    jnb stalled0,he_3           ; wait until axis 0 stalled
    
    mov stallflags,#0
    
    clr a 
    mov r0,#encpos0     ;point to data to change
    lcall update_posn
    
    mov a,#2
    mov r0,#encpos1     ;point to data to change
    lcall update_posn
    
    mov a,#4
    mov r0,#encpos2     ;point to data to change
    lcall update_posn

    mov a,#6
    mov r0,#encpos3     ;point to data to change
    lcall update_posn

    mov a,#8
    mov r0,#encpos4     ;point to data to change
    lcall update_posn

    mov stallflags,#0
    
    
;   Note: To avoid negative feedback.   0 == 1024
;   The IBM will adjust data to suit
    
    mov encpos0,  #low   974    ; set axis 0 to move away from endstop
    mov encpos0+1,#high  974
    mov despos0,  #low  1024    ; == 0
    mov despos0+1,#high 1024
    
    
    mov encpos1,  #low  6574    ; set axis 1 to move away from endstop
    mov encpos1+1,#high 6574
    mov despos1,  #low  6524    ; == 5500
    mov despos1+1,#high 6524

    mov encpos2,  #low   974    ; set axis 2 to move away from endstop
    mov encpos2+1,#high  974
    mov despos2,  #low  1024    ; == 0
    mov despos2+1,#high 1024

    mov encpos3,  #low   999    ; set axis 3 to move away from endstop
    mov encpos3+1,#high  999
    mov despos3,  #low  1024    ; == 0
    mov despos3+1,#high 1024

    mov encpos4,  #low  2649    ; set axis 4 to move away from endstop
    mov encpos4+1,#high 2649
    mov despos4,  #low  2624    ; == 1600
    mov despos4+1,#high 2624

    
he_4:    
    acall servoarm

    jnb axis0_inpos,he_4
    jnb axis1_inpos,he_4
    jnb axis2_inpos,he_4
    jnb axis3_inpos,he_4
    jnb axis4_inpos,he_4

    clr zeroing             ; show IBM we're ready

    ret

home_nojams:
    clr enable_jam
    ajmp home_02

home_jams:
    setb enable_jam
    ajmp home_02

home_decode:
    ajmp home_02        ; 0 - unused
    ajmp home_nojams    ; 2 - turn arm jam off
    ajmp home_jams      ; 4 - turn arm jams back on
    ajmp home_02        ; 6 - unused
    ajmp home_02        ; 8 - unused
                        
    ajmp home_0m        ; 10 - move axis 0 towards 0   
    ajmp home_0p        ; 12
    ajmp home_1m        ; 14 - move axis 1 towards 0   
    ajmp home_1p        ; 16
    ajmp home_2m        ; 18 - move axis 2 towards 0   
    ajmp home_2p        ; 20
    
    ajmp home_02        ; 22 - move axis 3 towards 0   
    ajmp home_02        ; 24
    ajmp home_02        ; 26 - move axis 4 towards 0   
    ajmp home_02        ; 28
    ajmp home_02        ; 30 - open gripper  
    ajmp home_02        ; 32
    ajmp home_em        ; 34 - move axes 3 and 4 towards 0   
    ajmp home_ep        ; 36
    ajmp home_rm        ; 38 - move axes 3 towards 0  4 +ve 
    ajmp home_rp        ; 40
    ajmp home_02        ; 42 - Speed -ve
    ajmp home_02        ; 44 - Speed +ve  
    
    ajmp home_02        ; 46 - cancel ibm_mode   
    ajmp home_end_ibm   ; 48 - finish it off
    ajmp home_02        ; 50
    ajmp home_02        ; 52
    ajmp home_02        ; 54


waitpower:
    mov dptr,#0ce00h
    movx a,@dptr
    jnb acc.7,waitpower
    ret


send_control0:    
    jz   send0_0            ; always let stop through
    jnb  stalled0,send0_1
    ret
send0_0:
    jb   axis0_inpos,send0_3    ; already stopped?  

    mov  a,#28              ; Sending stop - check if inposition
    orl  a,#AXIS0_SPD    
    mov  dptr,#Slave1
    movx @dptr,a            ; send control byte to slave
    jb   p3.3,$             ; wait for slave to respond
    movx a,@dptr            ; read back slaves state
    jnz  send0_4            ; is it stopped?
    setb axis0_inpos        ; Its stopped - set inposition
    ret

send0_4:
    clr  a
send0_1:
    orl  a,#AXIS0_SPD    
    cjne a,control0,send0_2 ; only bother to send new control words
    ret
send0_2:
    mov  dptr,#Slave1
    movx @dptr,a            ; send control byte to slave
    jb   p3.3,$             ; wait for slave to respond
    movx a,@dptr            ; read back slaves state
    mov  control0,a         ; save as control byte
    anl  a,#11110b
    jz   send0_3            ; is slave stopping ?
    
    clr  axis0_inpos        ; no, so axis not inposition
    mov  stall0,#8       
    
send0_3:    
    ret

send_control1:    
    jz   send1_0            ; always let stop through
    jnb  stalled1,send1_1
    ret
send1_0:
    jb   axis1_inpos,send1_3    ; already stopped?  

    mov  a,#28              ; Sending stop - check if inposition
    orl  a,#AXIS1_SPD    
    mov  dptr,#Slave2
    movx @dptr,a            ; send control byte to slave
    jb   p3.3,$             ; wait for slave to respond
    movx a,@dptr            ; read back slaves state
    jnz  send1_4            ; is it stopped?
    setb axis1_inpos        ; Its stopped - set inposition
    ret

send1_4:
    clr  a
send1_1:
    orl  a,#AXIS1_SPD    
    cjne a,control1,send1_2 ; only bother to send new control words
    ret
send1_2:
    
;    jnb ti,$
;    clr ti
;    mov sbuf,a
    
    mov  dptr,#Slave2
    movx @dptr,a            ; send control byte to slave
    jb   p3.3,$             ; wait for slave to respond
    movx a,@dptr            ; read back slaves state
    mov  control1,a         ; save as control byte

;    jnb ti,$
;    clr ti
;    mov sbuf,a
    
    anl  a,#11110b
    jz   send1_3            ; is slave stopping ?
    clr  axis1_inpos        ; no, so axis not inposition
    mov  stall1,#12       
    
    mov r0,#encpos1
    mov r1,#last_encpos1
    lcall change_inpos  ; r3/r2 will be set to absolute change    


send1_3:    
    ret

send_control2:    
    jz   send2_0            ; always let stop through
    jnb  stalled2,send2_1
    ret
send2_0:
    jb   axis2_inpos,send2_3    ; already stopped?  

    mov  a,#28              ; Sending stop - check if inposition
    orl  a,#AXIS2_SPD    
    mov  dptr,#Slave2
    movx @dptr,a            ; send control byte to slave
    jb   p3.3,$             ; wait for slave to respond
    movx a,@dptr            ; read back slaves state
    jnz  send2_4            ; is it stopped?
    setb axis2_inpos        ; Its stopped - set inposition
    ret

send2_4:
    clr  a
send2_1:
    orl  a,#AXIS2_SPD    
    cjne a,control2,send2_2 ; only bother to send new control words
    ret
send2_2:
    mov  dptr,#Slave2
    movx @dptr,a            ; send control byte to slave
    jb   p3.3,$             ; wait for slave to respond
    movx a,@dptr            ; read back slaves state
    mov  control2,a         ; save as control byte
    anl  a,#11110b
    jz   send2_3            ; is slave stopping ?
    
    clr  axis2_inpos        ; no, so axis not inposition
    mov  stall2,#10         ; 8 TOO SMALL      
    
    mov r0,#encpos2
    mov r1,#last_encpos2
    lcall change_inpos  ; r3/r2 will be set to absolute change    


send2_3:    
    ret

send_control3:    
    jz   send3_0            ; always let stop through
    jnb  stalled3,send3_1
    ret
send3_0:
    jb   axis3_inpos,send3_3    ; already stopped?  

    mov  a,#28              ; Sending stop - check if inposition
    orl  a,#AXIS3_SPD    
    mov  dptr,#Slave1
    movx @dptr,a            ; send control byte to slave
    jb   p3.3,$             ; wait for slave to respond
    movx a,@dptr            ; read back slaves state
    jnz  send3_4            ; is it stopped?
    setb axis3_inpos        ; Its stopped - set inposition
    ret

send3_4:
    clr  a
send3_1:
    orl  a,#AXIS3_SPD    
    cjne a,control3,send3_2 ; only bother to send new control words
    ret
send3_2:
    mov  dptr,#Slave1
    movx @dptr,a            ; send control byte to slave
    jb   p3.3,$             ; wait for slave to respond
    movx a,@dptr            ; read back slaves state
    mov  control3,a         ; save as control byte
    anl  a,#11110b
    jz   send3_3            ; is slave stopping ?
    
    clr  axis3_inpos        ; no, so axis not inposition
    mov  stall3,#12
    
send3_3:    
    ret

send_control4:    
    jz   send4_0            ; always let stop through
    jnb  stalled4,send4_1
    ret
send4_0:
    jb   axis4_inpos,send4_3    ; already stopped?  

    mov  a,#28              ; Sending stop - check if inposition
    orl  a,#AXIS4_SPD    
    mov  dptr,#Slave1
    movx @dptr,a            ; send control byte to slave
    jb   p3.3,$             ; wait for slave to respond
    movx a,@dptr            ; read back slaves state
    jnz  send4_4            ; is it stopped?
    setb axis4_inpos        ; Its stopped - set inposition
    ret

send4_4:
    clr  a
send4_1:
    orl  a,#AXIS4_SPD    
    cjne a,control4,send4_2 ; only bother to send new control words
    ret
send4_2:
    
    
    
    mov  dptr,#Slave1
    movx @dptr,a            ; send control byte to slave
    jb   p3.3,$             ; wait for slave to respond
    movx a,@dptr            ; read back slaves state
    mov  control4,a         ; save as control byte
    anl  a,#11110b
    jz   send4_3            ; is slave stopping ?
    
    clr  axis4_inpos        ; no, so axis not inposition
    mov  stall4,#12
    
send4_3:    
    ret



change_inpos:     
;r0 points to encpos
;r1 points to last_encpos
    
    clr c
    mov a,@r0
    subb a,@r1
    mov r2,a
    inc r0  ; point to msb
    inc r1  ; point to msb
    mov a,@r0
    subb a,@r1
    mov r3,a
    jnc h0_1

    dec r0  ; point back to lsb
    dec r1  ; point back to lsb

    clr c
    mov a,@r1
    subb a,@r0
    mov r2,a

    inc r0  ; point to msb
    inc r1  ; point to msb
    
    mov a,@r1
    subb a,@r0
    mov r3,a

h0_1:                   ; r3/r2 = abs change of position


    mov a,@r0       ; save msb encpos in msb last_encpos
    mov @r1,a

    dec r0  ; point to lsb
    dec r1

    mov a,@r0       ; save msb encpos in msb last_encpos
    mov @r1,a

    ret




testjams:
    mov a,#0
    mov r0,#encpos0     ;point to data to change
    lcall update_posn
    
    mov a,#2
    mov r0,#encpos1     ;point to data to change
    lcall update_posn
    
    mov a,#4
    mov r0,#encpos2     ;point to data to change
    lcall update_posn
    
    mov a,#6
    mov r0,#encpos3     ;point to data to change
    lcall update_posn
    
    mov a,#8
    mov r0,#encpos4     ;point to data to change
    lcall update_posn

testjams_noread:
    mov dptr,#0ce00h        
    
    movx a,@dptr
    jb acc.7,testjams_1           ; power on?

    mov stallflags,#0
    ret
    

testjams_1:

    mov a,control0
    cjne a,#4 + AXIS0_SPD,$+3 ; set carry if a < 4
    jc h1                ; stopped or pigging slow

    cjne a,#28 + AXIS0_SPD,$+3 ; clear carry if a >= 28
    jnc h1

    jb stalled0,h1

    mov a,stall0        ; counter decremented by timer0
    jnz h1b
    mov stall0,#3

    mov r0,#encpos0
    mov r1,#last_encpos0
    lcall change_inpos  ; r3/r2 will be set to absolute change    

    mov a,r3            ; changed by more than 256 ?
    jnz h1
    
    mov a,r2
    cjne a,#10,$+3     ; set carry if a < 10
    jnc h1              ; moving 

    jnb enable_jam,h1
    jnb last_stalled0,h1a

    mov a,#30
    lcall send_control0
    setb stalled0       ; axis 0 is stalled
    mov r0,#stallcnt0
    inc @r0 
h1a:
    setb last_stalled0
    ajmp h1b
h1:
    clr  last_stalled0
h1b:

    mov a,control1
    cjne a,#4 + AXIS1_SPD,$+3 ; set carry if a < 4
    jc h2                ; stopped or pigging slow
    
    cjne a,#28 + AXIS1_SPD,$+3 ; clear carry if a >= 28
    jnc h2
    
    jb stalled1,h2
    
    mov a,stall1        ; counter decremented by timer0
    jnz h2b
    mov stall1,#4

    mov r0,#encpos1
    mov r1,#last_encpos1
    lcall change_inpos  ; r3/r2 will be set to absolute change    
    
    mov a,r3            ; changed by more than 256 ?
    jnz h2

;    jnb ti,$
;    clr ti
;    mov sbuf,a
    
    mov a,r2
    cjne a,#5,$+3     ; set carry if a < 5     
    jnc h2            ; moving 

;    MOV A,#1

    jnb enable_jam,h2
    jnb last_stalled1,h2a
    
    mov a,#30
    lcall send_control1
    setb stalled1       ; axis 1 is stalled
    mov r0,#stallcnt1
    inc @r0

h2a:
    setb last_stalled1
    ajmp h2b
h2:
    clr  last_stalled1
h2b:

    mov a,control2
    cjne a,#4 + AXIS2_SPD,$+3 ; set carry if a < 4
    jc h3                ; stopped or pigging slow

    cjne a,#28 + AXIS2_SPD,$+3 ; clear carry if a >= 28
    jnc h3


    jb stalled2,h3

    mov a,stall2        ; counter decremented by timer0
    jnz h3b
    mov stall2,#3

    mov r0,#encpos2
    mov r1,#last_encpos2
    lcall change_inpos  ; r3/r2 will be set to absolute change    
    
    mov a,r3            ; changed by more than 256 ?
    jnz h3
    
    mov a,r2
    cjne a,#5,$+3     ; set carry if a < 5     
    jnc h3

;    MOV A,#2
;    clr ti
;    mov sbuf,a
    jnb enable_jam,h3
    jnb last_stalled2,h3a
    mov a,#30
    lcall send_control2
    setb stalled2       ; axis 2 is stalled
    mov r0,#stallcnt2
    inc @r0
h3a:
    setb last_stalled2
    ajmp h3b
h3:
    clr  last_stalled2
h3b:

    mov   a,control3
    cjne  a,#4 + AXIS3_SPD,$+3  ; set carry if a < 4
    jc    h4                    ; stopped or pigging slow

    cjne  a,#28 + AXIS3_SPD,$+3 ; clear carry if a >= 28
    jnc   h4

    jb    stalled3,h4

    mov   a,stall3              ; counter decremented by timer0
    jnz   h4b
    mov   stall3,#4

    mov   r0,#encpos3
    mov   r1,#last_encpos3
    lcall change_inpos          ; r3/r2 will be set to absolute change    
    mov   a,r3
    jnz   h4
    
    mov   a,r2
    cjne  a,#5,$+3              ; set carry if a < 5     
    jnc   h4                    ; moving reset counter

    jnb   enable_jam,h4
    jnb   last_stalled3,h4a

    mov   a,#30                 ; send emer stop to slave
    lcall send_control3
    setb  stalled3              ; axis 3 is stalled
    
    mov r0,#stallcnt3
    inc @r0

h4a:
    setb last_stalled3
    ajmp h4b
h4:
    clr  last_stalled3
h4b:


    mov   a,control4
    cjne  a,#4 + AXIS4_SPD,$+3  ; set carry if a < 4
    jc    h5                    ; stopped or pigging slow

    cjne  a,#28 + AXIS4_SPD,$+3 ; clear carry if a >= 28
    jnc   h5

    jb    stalled4,h5

    mov   a,stall4        ; counter decremented by timer0
    jnz   h5b
    mov   stall4,#4

    mov r0,#encpos4
    mov r1,#last_encpos4
    lcall change_inpos  ; r3/r2 will be set to absolute change    
    mov a,r3
    jnz h5              ; moving reset counter
    
    mov a,r2

    cjne a,#5,$+3     ; set carry if a < 5     
    jnc h5              ; moving reset counter

    jnb enable_jam,h5
    jnb last_stalled4,h5a


    mov a,#30
    lcall send_control4
    setb stalled4       ; axis 4 is stalled

    mov r0,#stallcnt4
    inc @r0

h5a:
    setb last_stalled4
    ret
h5:
    clr  last_stalled4
h5b:
    ret



setmin3:
; Min3 = 2688 - d(4)            ;640 + 2048 = 2688
    clr  c
    mov  a,#low 2688
    subb a,despos4
    mov  despos3,a
    
    mov  a,#high 2688
    subb a,despos4+1
    mov  despos3+1,a
    ajmp limit3

setmin4:
; Min4 = 2688 - d(3)   
    
    clr  c
    mov  a,#low 2688
    subb a,despos3
    mov  despos4,a
    
    mov  a,#high 2688
    subb a,despos3+1
    mov  despos4+1,a
    ajmp limit4

setmax3:
; Max3 = 4608 - d(4)            ;2560+ 2048 =4608
    clr  c
    mov  a,#low 4608
    subb a,despos4
    mov  despos3,a
    
    mov  a,#high 4608
    subb a,despos4+1
    mov  despos3+1,a
    ajmp limit3

setmax4:
; Min4 = 4608 - d(3)   
    
    clr  c
    mov  a,#low 4608
    subb a,despos3
    mov  despos4,a
    
    mov  a,#high 4608
    subb a,despos3+1
    mov  despos4+1,a
    ajmp limit4












setmine:
;  Emin = 1024+ABS(d(3)-d(4))/2   
   acall setRE                  ; calculate current rotation
   
   clr   c                     ; set minimum elevation, given rotation 
   mov   a,despos3
   subb  a,despos4
   mov   E,a 
   mov   a,despos3+1
   subb  a,despos4+1
   mov   E+1,a
   jnc   lab1
   clr   c
   mov   a,despos4
   subb  a,despos3
   mov   E,a 
   mov   a,despos4+1
   subb  a,despos3+1
   mov   E+1,a
lab1:
    clr c
    rrc a                   ; 0 --> bit 7, bit 0 --> C
    mov E+1,a
    mov a,E
    rrc a                   ; C --> bit 7
    mov E,a

    mov  a,E
    add  a,#low 1024
    mov  E,a
    mov  a,E+1
    addc a,#high 1024
    mov  E+1,a
    
    clr  c                      ; lower limit elevation 320+1024
    mov  a,E
    subb a,#low  1344
    mov  a,E+1
    subb a,#high 1344
    jnc  lab2
    mov E,  #low  1344
    mov E+1,#high 1344

lab2:

    acall set34
    ret

setmaxe:
;  Emax = 2624 - ABS(d(3)-d(4))/2   
   acall setRE                  ; calculate current rotation
   
   
   clr   c                     ; set minimum elevation, given rotation 
   mov   a,despos3
   subb  a,despos4
   mov   E,a 
   mov   a,despos3+1
   subb  a,despos4+1
   mov   E+1,a
   jnc   lab3
   clr   c
   mov   a,despos4
   subb  a,despos3
   mov   E,a 
   mov   a,despos4+1
   subb  a,despos3+1
   mov   E+1,a
lab3:
    clr c
    rrc a
    mov E+1,a
    mov a,E
    rrc a
    mov E,a

    clr  c       
    mov  a,#low  2624
    subb a,E
    mov  E,a
    mov  a,#high 2624
    subb a,E+1
    mov  E+1,a

    clr  c
    mov  a,E                    ; check limit 1280+1024
    subb a,#low  2304
    mov  a,E+1
    subb a,#high 2304
    jc   lab4
    mov E,  #low  2304
    mov E+1,#high 2304
    
lab4:
    acall set34
    ret


setminR:
;if E < 1824 then
;    minR = R + 1024 - d(3)
;else
;    minR = R + d(4) - 2624
;endif
    acall setRE
    
    clr   c
    mov   a,#low  1824
    subb  a,E
    mov   a,#high 1824
    subb  a,E+1
    jnc   lab5          ; jump if E < 1824

;    minR = R + d(4) - 2624
    mov  a,R
    add  a,despos4
    mov  R,a
    mov  a,R+1
    addc a,despos4+1
    mov  R+1,a

    mov  a,R
    subb a,#low  2624
    mov  R,a
    mov  a,R+1
    subb a,#high 2624
    mov  R+1,a
    jmp lab6

    
lab5:
;    minR = R + 1024 - d(3)
    mov  a,R
    add  a,#low  1024
    mov  R,a
    mov  a,R+1
    addc a,#high 1024
    mov  R+1,a

    mov  a,R
    subb a,despos3
    mov  R,a
    mov  a,R+1
    subb a,despos3+1
    mov  R+1,a

lab6:

    acall set34
    ret


setmaxR:
;if E < 1824 then
;    maxR = R + d(4) - 1024
;else
;    maxR = R + 2624 - d(3)
;endif
    acall setRE
    clr   c
    mov   a,#low  1824
    subb  a,E
    mov   a,#high 1824
    subb  a,E+1
    
    jnc   lab7          ; jump if E < 1824

;    maxR = R + 2624 - d(3)  
    
    mov  a,R
    add  a,#low  2624
    mov  R,a
    mov  a,R+1
    addc a,#high 2624
    mov  R+1,a

    mov  a,R
    subb a,despos3
    mov  R,a
    mov  a,R+1
    subb a,despos3+1
    mov  R+1,a

    jmp  lab8

lab7:
;    maxR = R + d(4) - 1024
    mov  a,R
    add  a,despos4
    mov  R,a
    mov  a,R+1
    addc a,despos4+1
    subb a,#high 1024
    mov  R+1,a


lab8:


    acall set34
    ret


   
set34:
;  d(4) = E + 800 - R
    
    mov  a,E
    add  a,#low 800
    mov  despos4,a
    mov  a,E+1
    addc a,#high 800
    mov  despos4+1,a
    
    mov  a,despos4
    subb a,R
    mov  despos4,a
    mov  a,despos4+1
    subb a,R+1
    mov  despos4+1,a

;    acall limit4

;  d(3) = 2 * E - d(4)
    mov  a,E
    add  a,E
    mov  despos3,a
    mov  a,E+1
    addc a,E+1
    mov  despos3+1,a
    
    mov  a,despos3
    subb a,despos4
    mov  despos3,a
    mov  a,despos3+1
    subb a,despos4+1
    mov  despos3+1,a

;    acall limit3

    orl flags,#00011000b        ; == setb pen3 setb pen4
    ;setb pen3
    ;setb pen4
    ret



limit3:
    mov  a,despos3+1
    cjne a,#4,$+3           ; set carry if despos3 < 1024
    jnc  lim1
    mov  despos3,   #low 1024
    mov  despos3+1, #high 1024
lim1:
    clr  c
    mov  a,#low 2624
    subb a,despos3
    mov  a,#high 2624
    subb a,despos3+1
    jnc  lim2
    mov  despos3,   #low  2624
    mov  despos3+1, #high 2624
lim2:
    ret

limit4:
    mov  a,despos4+1
    cjne a,#4,$+3           ; set carry if despos3 < 1024
    jnc  lim3
    mov  despos4,   #low 1024
    mov  despos4+1, #high 1024
lim3:
    clr  c
    mov  a,#low 2624
    subb a,despos4
    mov  a,#high 2624
    subb a,despos4+1
    jnc  lim4
    mov  despos4,   #low  2624
    mov  despos4+1, #high 2624
lim4:
    ret




setRE:
;   R = (1600 + d(3) - d(4) ) /2 

    mov despos3  ,encpos3
    mov despos3+1,encpos3+1
    acall limit3
    
    mov despos4  ,encpos4
    mov despos4+1,encpos4+1
    acall limit4
    
    mov  a,#low 1600
    add  a,despos3
    mov  R,a
    
    mov  a,#high 1600
    addc a,despos3+1
    mov  R+1,a

    mov  a,R
    subb a,despos4
    push acc
    mov  a,R+1
    subb a,despos4+1

    clr c
    rrc a               ; 0 --> bit7, bit 0 --> C
    mov R+1,a
    pop acc
    rrc a               ; C --> bit 7
    mov R,a

;   E = (d(3) + d(4)) /2
    
    mov  a,despos3
    add  a,despos4
    push acc
    mov  a,despos3+1
    addc a,despos4+1
    
    clr c
    rrc a               ; 0 --> bit7, bit 0 --> C
    mov E+1,a
    pop acc
    rrc a               ; C --> bit 7
    mov E,a
    
    ret



timer0:    
;            Ramp up    Rev/sec(at top speed)     Enc/rev  Enc/sec
; Axis 0         587       10                      12000     1200
; Axis 1         344        7                      12000     1714
; Axis 2         539        7                      12000     1714
; Axis 3         447        4                       2000      500
     
; Conclude sample 10 times per second for arm jams
; Hence set timer to run at 100 times


    PUSH PSW
    PUSH ACC
    
    mov a,stall0    
    jz t0_1
    dec stall0
t0_1:    
    mov a,stall1    
    jz t0_2
    dec stall1
t0_2:
    mov a,stall2    
    jz t0_3
    dec stall2
t0_3:  
    mov a,stall3    
    jz t0_4
    dec stall3
t0_4:
    mov a,stall4    
    jz t0_5
    dec stall4
t0_5:

;    mov a,stalledcnt
;    cjne a,#10,t0_6
;    inc stalledcnt
;t0_6:
    
    POP ACC
    POP PSW
    reti




initadc:
    MOV DPTR,#0dd80h        ; ADC Configuration reg
    mov a,#00000010b        ; Reset/stop
    movx @dptr,a
    
    inc dptr
    mov a,#00000000b        ; Ram ptr = "00"
    movx @dptr,a        

    
    mov dptr,#0dd40h
    mov a,#00000010b        ; Channel 0 - pause
    lcall SetInstruction

    mov dptr,#0dd42h
    mov a,#00000100b        ; Channel 1
    lcall SetInstruction
    
    mov dptr,#0dd44h
    mov a,#00001000b        ; Channel 2
    lcall SetInstruction

    mov dptr,#0dd46h
    mov a,#00001100b        ; Channel 3
    lcall SetInstruction

    mov dptr,#0dd48h
    mov a,#00010000b        ; Channel 4
    lcall SetInstruction

    mov dptr,#0dd4ah
    mov a,#00010100b        ; Channel 5
    lcall SetInstruction
    
    mov dptr,#0dd4ch
    mov a,#00011000b        ; Channel 6
    lcall SetInstruction

    mov dptr,#0dd4eh
    mov a,#00011101b        ; Channel 7 - loop
    lcall SetInstruction

    
    
    MOV DPTR,#0dd80h        ; ADC Configuration reg
    mov a,#00001010b        ; Reset - calibrate
    movx @dptr,a
    clr a
    inc dptr                
    movx @dptr,a 
    
    
    MOV DPTR,#0dd82h        ; Interrupt enable Register
    clr  a
    movx @dptr,a
    
    
    MOV DPTR,#0dd84h        ; Interrupt status Register
    movx a,@dptr            ; Read clears 
    ret


startadc:
    MOV DPTR,#0dd80h        ; ADC Configuration reg
    mov a,#00000010b        ; Reset
    movx @dptr,a
    
    MOV DPTR,#0dd80h        ; ADC Configuration reg
    mov a,#01000001b        ; Calibrate and Start
    movx @dptr,a

    ret


 
readadc:
    jb   adcvalid,readadc2   ; Data not yet read by IBM
    MOV  DPTR,#0dd80h        ; ADC Configuration reg
    movx a,@dptr
    jnb  acc.0,readadc1      ; If paused then read FIFO buffer
readadc2:
    ret


readadc1:
    mov r0,#rawadc
readfifo:    
    mov dptr,#0dd85h        ; Read FIFO status
    movx a,@dptr
    anl a,#11111000b
    jz  fifoempty           ; jump if FIFO empty
    
    mov dptr,#0dd88h        ; Read FIFO lsb first
    movx a,@dptr
    mov @r0,a
    inc r0
    
    inc dptr
    movx a,@dptr
    jb acc.4,negadc         ; ADC negative?
    
    anl a,#00001111b        ; Mask off address/sign section
    mov @r0,a
    inc r0
    jmp posadc

negadc:
    dec r0                  ; Re-point to lsb
    clr a
    mov @r0,a               ; Store 0
    inc r0                  ; Point to msb
    mov @r0,a               ; Store 0
    inc r0

posadc:

    cjne r0,#rawadc+16,readfifo
fifoempty:    
    setb  adcvalid          ; Tell IBM data is good
    lcall startadc
    ret



SetInstruction:
    movx @dptr,a
    inc dptr
    mov a,#11110000b        ; Acquisition time max
    movx @dptr,a
    
    MOV  DPTR,#0dd80h        ; ADC Configuration reg
    mov  a,#00000010b        ; Reset
    movx @dptr,a
    ret


include timer2.inc              ; Timer 2


include ibmint.inc              ; External interrupt 0 service




include runin.inc
;runseq:

include errtab.inc
end
