;        
 
TITLE  ** 8031 Kestrel Encoders Monitor - Version 1, 4/1/95 **

PLEN 100

;    load
	list

;    base equ 0a000h
	base equ 0

	org base
	pad $ff
	
	org base+00h            ;reset address
	jmp begin               ;start of program
	org base+03h            ;external interrupt 0 address, letterbox
	jmp send_get_posn


;r0     change in axis 0 position
;r1     change in axis 1 position



;lastp1     is last state of p1 - Encoder inputs 0-3
;lastp3     is last state of p3 - Encoder input 4


led bit  p3.5


bitadds equ     20h     ;bit addressable sector

lastp1 equ     bitadds       ;last encoder 0 - 3 states


last0A  bit lastp1.1
last0B  bit lastp1.0

last1A  bit lastp1.2       
last1B  bit lastp1.3       


Enc0A   bit acc.1
Enc0B   bit acc.0

Enc1A   bit acc.2
Enc1B   bit acc.3


stack   equ     30h


db "Kestrel encoder monitor,1.00"  
db "19/6/95 (C) Cybernetic Applications 1995",0



begin:
	mov sp,#stack
	mov psw,#0
	
	movx a,@dptr            ; clear any current external interrupt

	mov tcon,#0h            ; set external interrupt 0 low level trigggered 

	mov r0,#0
	mov r1,#0
	
	mov acc,p1              ; read states of encoders 0 to 3
	mov lastp1,a

	
	mov ie,#81h             ; enable external interrupt


waitmove:
	mov acc,p1              ; read states of encoders 0 to 3
	cjne a,lastp1,axis0     ; process if its changed

	ajmp waitmove



;look for high to low transition on p1.0

axis0:                      ;if get high-> low transition then mod counter   
	jb  Enc0A, axis0lh      ;jump if encoder still high   
	jnb last0A,axis0q       ;jump if encoder was low last time also
	jb  Enc0B, incaxis0     ;get direction, jump positive

decaxis0:        
	dec r0
	jmp axis1

incaxis0:
	inc r0
	jmp axis1


axis0lh:                    ;test for low-> high transition   
	jb  last0A,axis0q       ;high this time, was it low last time    
	jb  Enc0B, decaxis0
	jmp incaxis0


axis0q:                  ;quadrature testing, ie. on other signal channel, p1.1
	
	jb  Enc0B,axis0lhq   ;jump if encoder still high
	jnb last0B,axis1      ;jump if encoder was low last time also
	jnb Enc0A,incaxis0  ;get direction, jump positive (phase)
	dec r0
	jmp axis1


axis0lhq:                ;test for low-> high transition
	jb  last0B,axis1      ;high this time, was it low last time
	jnb Enc0A,decaxis0
	jmp incaxis0



axis1:                   ;if get high-> low transition then mod counter   
	jb Enc1A,axis1lh     ;jump if encoder still high   
	jnb last1A,axis1q     ;jump if encoder was low last time also
	jb Enc1B,incaxis1    ;get direction, jump positive

decaxis1:        
	dec r1
	jmp axis2

incaxis1:
	inc r1
	jmp axis2


axis1lh:                 ;test for low-> high transition   
	jb  last1A,axis1q     ;high this time, was it low last time    
	jb  Enc1B,decaxis1
	jmp incaxis1


axis1q:                  ;quadrature testing, ie. on other signal channel, p1.1
	
	jb  Enc1B,axis1lhq   ;jump if encoder still high
	jnb last1B,axis2      ;jump if encoder was low last time also
	jnb Enc1A,incaxis1   ;get direction, jump positive (phase)
	dec r1
	jmp axis2


axis1lhq:                ;test for low-> high transition
	jb  last1B,axis2      ;high this time, was it low last time
	jnb Enc1A,decaxis1
	jmp incaxis1 

	
	
axis2:    
	mov lastp1,a        ;last state now replaced by current
	jmp waitmove


; interrupt request from master for counter values

send_get_posn:
	push acc
	
	djnz r7,lab0
	cpl led
lab0:    
	
	movx a,@dptr            ; read masters' control byte
	jnz  sendaxis1change

sendaxis0change:
	xch a,r0                ; get change in posn, reset counter
	movx @dptr,a            ; put data onto master data latch
	pop acc
	reti


sendaxis1change:
	clr  a
	xch  a,r1               ; get change in posn, reset counter
	movx @dptr,a            ; put data onto master data latch
	
	pop acc
	reti
	
	
	db "END OF PROGRAM "
	db "Kestrel encoders "
	db 0,0,0,0

	org base+$1fcf
	
	db $ff
	
	end
