SUBTTL Constants     
TITLE **  Control Program for 8032 Serpent - Version 1.1 22/07/95 **

PLEN 100

;LOAD
    
LIST ; to allow 'L' switch at command line


NULL        equ 0     ;timer 0/1 function call - set r4/5


EPROM       equ 0ffh   ; IBM peek EPROM page
INTERNAL    equ 0feh   ; IBM peek internal RAM page



FASTEST     equ 12
SLOWEST     equ 9


maxdelay    EQU 0      ; Maximum seed value for timer2 


; HARDWARE ADDRESSES


lsblatch        equ     0a000h  ; latch for lsb address
intlatch        equ     0a001h  ; interrupt from IBM, Ext0
datalatch       equ     0a002h  ; 

workcell_i      equ     0c600h  ; inputs from workcell          - r
workcell_o      equ     0ca00h  ; outputs to workcell           - w

datastrobe      equ     0d200h  ; write strobe at RJ45 interface
dataoen         equ     0d600h  ; data out enable

slave0          equ     0dc00h  ; encoder slave letterbox address r/w
pwm_12          equ     0dc40h  ; PWM axes 1 and 2 speed    
pwm_0           equ     0dc41h  ; PWM axes 0
pwm_dir         equ     0dc42h  ; PWM direction



; INTERNAL RAM MAP



rbank0          equ     00h      ; register bank 0 - Baseloop
rbank1          equ     08h      ; register bank 1 - IBM interrupt
rbank2          equ     010h     ; register bank 2 - 
rbank3          equ     018h     ; register bank 3  

;lastjam    equ 20h
;last_stalled0 bit lastjam.0 
;last_stalled1 bit lastjam.1 
;last_stalled2 bit lastjam.2 

reallyinpos       equ 020h          ; two levels of inposition, this is
axis0_reallyinpos bit reallyinpos.0 ; tightest
axis1_reallyinpos bit reallyinpos.1
axis2_reallyinpos bit reallyinpos.2
Zup               bit reallyinpos.3


adccontrol equ 21h
adcvalid    bit adccontrol.0    ; set by 8032, cleared by IBM


wco_stat        equ     023h     ; states of workcell outputs - FIXED LOCATION
wco_stat0       bit     wco_stat.0
wco_stat1       bit     wco_stat.1
wco_stat2       bit     wco_stat.2
wco_stat3       bit     wco_stat.3
wco_stat4       bit     wco_stat.4
wco_stat5       bit     wco_stat.5
wco_stat6       bit     wco_stat.6
wco_stat7       bit     wco_stat.7

flags       equ 024h
pen_active  bit flags.5
enable_pen  bit flags.6



stallflags equ 025h
stalled0   bit stallflags.0
stalled1   bit stallflags.1
stalled2   bit stallflags.2


stallflags_ibm equ 026h ; copy for IBM to read
    

inpos       equ 027h          ;fixed location
axis0_inpos bit inpos.0
axis1_inpos bit inpos.1
axis2_inpos bit inpos.2

axis3_inpos bit inpos.3         ; Z axis          
axis4_inpos bit inpos.4         ; Gripper

power       bit inpos.5
jammed      bit inpos.6
zeroing     bit inpos.7


flags2 equ inpos+1

grip_press bit flags2.0
ibm_mode   bit flags2.1
enable_jam bit flags2.2


hammer0     bit flags2.5
hammer1     bit flags2.6 
hammer2     bit flags2.7 




Servo_Flags equ flags2+1

servo_enable0 bit Servo_Flags.0
servo_enable1 bit Servo_Flags.1
servo_enable2 bit Servo_Flags.2
stop0 bit Servo_Flags.3
stop1 bit Servo_Flags.4
stop2 bit Servo_Flags.5
servo_01 bit Servo_Flags.6  ; Servo axis 0 or 1
servo_23 bit Servo_Flags.7  ; Servo axis 2



AxesDir         equ     Servo_flags+1          ;direction word for axes 0,1 & 2
Dir0    bit AxesDir.2       ; axis 1 pwm channel 2
Dir1    bit AxesDir.0       ; axis 2 pwm channel 0
Dir2    bit AxesDir.1       ; axis 3 pwm channel 1
Dir3    bit AxesDir.3       ; axis 4 pwm channel 3


Teach_flags equ axesdir+1
pen0_slow   bit Teach_flags.0
pen1_slow   bit Teach_flags.1
pen2_slow   bit Teach_flags.2
pen0        bit Teach_flags.3
pen1        bit Teach_flags.4
pen2        bit Teach_flags.5


timer2_func     equ     Teach_flags+1
wco_low         equ     timer2_func+1
wco_high        equ     wco_low +1
wco_next        equ     wco_high  +1
pulse_width     equ     wco_next +1

stall0  equ pulse_width+1
stall1  equ stall0+1
stall2  equ stall1+1

nomove0 equ stall2+1
nomove1 equ nomove0+1
nomove2 equ nomove1+1

led_cnt         equ     nomove2+1    
led_cnt_seed    equ     led_cnt+1


control0        equ     led_cnt_seed+1
control1        equ     control0+1
control2        equ     control1+1

change          equ     control2+1

cntrl0          equ     change+1
cntrl1          equ     cntrl0+1
cntrl2          equ     cntrl1+1

hcnt0           equ     cntrl2+1
hcnt1           equ     hcnt0+1
hcnt2           equ     hcnt1+1

htim0           equ     hcnt2+1
htim1           equ     htim0+1
htim2           equ     htim1+1

rest0           equ     htim2+1
rest1           equ     rest0+1
rest2           equ     rest1+1
rest3           equ     rest2+1
tmp             equ     rest3+1

more0           equ     tmp+1 
more1           equ     more0+1
more2           equ     more1+1

ServoAxis       equ     more2+1







mcntrl          equ     050H            ; FIXED LOCATION
wcntrl          equ     mcntrl+1        ; workcell control
scntrl          equ     wcntrl+1
mcntrl_copy     equ     scntrl+1   
pen_copy        equ     mcntrl_copy+1

rs232_mess      equ     05bh            ; Byte to send as "RS232" via workcell
pulses_no       equ     rs232_mess+1    ; number of workcell pulses to be sent
pulses_rate     equ     pulses_no+2     ; rate to send workcell pulses


despos0         equ 060h
despos1         equ 062h
despos2         equ 064h


despos_grip     equ 06ah        ; Bit 4=gripper, Bits 5/6 = Z axis
despos_speed    equ 06bh

seqcnt          equ 06dh

encpos0         equ 070h
encpos1         equ 072h
encpos2         equ 074h


encpos_grip     equ 07ah
encpos_speed    equ 07bh

seqptr          equ 07ch

csum            equ 07eh      


rawadc          equ 080h            ;Result from ADC chip


stack           equ     090H


runcnt          equ 0f0h
stallcnt0       equ runcnt+2
stallcnt1       equ stallcnt0+1
stallcnt2       equ stallcnt1+1



scratch         equ 0ffh        ; used only by IBM    



; PROGRAM MEMORY MAP

PAGE 
SUBTTL Interrupt Vectors

;base           equ     08000h  ; alternatives for RAM and ROM versions
base           equ     0h

ORG     base
PAD     0ffh                    ; to fill unallocated locations


; SET-UP INTERRUPT VECTORS AT START OF PROGRAM SPACE


ORG     base+0h                 ; reset vector address
        jmp     begin           ; start of initialisation

ORG     base+03h                ; external interrupt 0 vector address
        jmp     ibmint          ; used for IBM communications

ORG     base+0bh                ; timer0 interrupt vector
        jmp timer0

ORG     base+13h                ; external interrupt 1 vector address
        reti

ORG     base+1bh                ; timer1 interrupt vector
        jmp timer1

ORG     base+23h                ; serial port vector address
        reti

org     base+2bh                ; timer2 interrupt vector
        jmp     timer2
        ;reti

ORG     base+30h                ; to be tidy


; PROM IDENTIFICATION


;   db      "SERP","1.00"     ; Serpent program, version 1
;   db      "25/06/95 ",169," Cybernetic Applications 1995",0    ; Null terminated
        
        
;   db      "SERP","1.01"     ; Serpent program, version 1.01
;   db      "04/08/95 ",169," Cybernetic Applications 1995",0    ; Null terminated
    
    db      "SERP","1.02"     ; Serpent program, version 1.02
    db      "02/09/95 ",169," Cybernetic Applications 1995",0    ; Null terminated


;Bug fixes
; v1.00, first issued 20/7/95, Vietnam via Feedback
; v1.01, servo changes - kick start, inpos earlier, regulated power supply
; v1.02, pneu times shortened, Servo re-written to Proportional control not speed servo





PAGE
     
SUBTTL INITIALISATION / RESET

;nb. uses register set 0, as does Baseloop

begin:
        mov  sp,#stack          ; initialise stack pointer 
        
        mov  dptr,#intlatch     ; clear possible IBM interrupt states
        movx a,@dptr

        mov dptr,#Slave0        ; Clear possible interrupt state on encoder slave
        movx a,@dptr



;debug:
;
;        mov  dptr,#workcell_i
;        movx a,@dptr
;        
;        mov  dptr,#pwm_12
;        movx @dptr,a
;
;        jmp  debug
        
        clr a                   ; Clear all internal RAM
        mov r0,#255
clearram:
        mov @r0,a
        djnz r0,clearram



    mov  dptr,#0ce00h           ; If SLOW pressed 
    movx a,@dptr                ; during boot up
    jb   acc.5,normalmode       ; enter test mode
    jmp TestMode


normalmode:


        
        
        mov  wco_stat,#0ffh     ; Set all workcell outputs high
        mov  a,wco_stat         ; send to workcell outputs
        mov  dptr,#workcell_o
        movx @dptr,a            

;        mov  dptr,#0ce00h       ; send gripper/Z data
;        mov  a,despos_grip
;        mov  encpos_grip,a
;        movx @dptr,a

        lcall initadc
        
        
        mov dptr,#0         ; Calculate EPROM checksum
        mov r0,#0
        mov r1,#0
gc1:
        clr a
        movc a,@a+dptr

        add a,r0
        mov r0,a

        clr a
        addc a,r1
        mov r1,a

        inc dptr
        mov a,dph
        cjne a,#20h,gc1     ; done all EPROM?

        mov csum,r0      ; save for IBM
        mov csum+1,r1

        mov led_cnt,#8          ; set led flash freq    
        mov led_cnt_seed,#8


        mov despos_speed,#3         ; Default to fastest
        acall setmaxerror



        mov  dptr,#Slave0   ; Request axis 1 feedback
        clr  a
        movx @dptr,a        


    
        


; Set-up Interrupts and their Priorities


        mov rcap2l,#low  maxdelay
        mov rcap2h,#high maxdelay
        mov t2con,#00000100b    ; timer2, 16bit autoreload timer

        ; To enable serial debugger:        
        ; replace following

;       mov t2con,#00110100b    ; serial generat
;       mov rcap2l,#low  65484  ; gives 9615 baud
;       mov rcap2h,#high 65484
;       mov scon,#01000000b
;       mov sbuf,a
       
    
    
    
    mov  tmod,#00010001b    ; timer0, timer1 both 16 bit timers
    mov  tcon,#01010000b    ; ext0 and ext1 level triggered, timer 0 running
        
    mov  ie  ,#10101011b    ; enable ext0 timer2,timer0,timer1  
    mov  ip  ,#00000001b    ; ext0 high priority


    clr  jammed
    setb enable_jam

    
    ;mov despos_speed,#15
    
    acall home



;    clr enable_jam


    page
     
     
    SUBTTL Baseloop

    lcall startadc
    
    setb enable_pen    

BASELOOP:
    
    lcall readadc
    
    lcall setmaxerror

    mov a,mcntrl
    jz bl1

    mov mcntrl,#0
    mov mcntrl_copy,a
    mov dptr,#master_decode
    jmp @a+dptr             ; will return to bl0
bl0:
    mov scntrl,mcntrl_copy


bl1:
    mov dptr,#0ce00h        ; read pendant
                            ; bits 0,1,2,3 = function
                            ; bit 4 = gripper
                            ; bit 5 = speed
    movx a,@dptr
    
    
    mov dptr,#pen_decode

    jnb enable_pen,bl2      ; cleared when IBM jogging
    anl a,#63
    mov pen_copy,a
    cjne a,#63,bl4          ; any key pressed
    clr pen_active          ; no - speed will be set by IBM
    jmp bl5
bl4:
    setb pen_active         ; yes - put in charge
    
    jb  acc.5,bl5           
    
    mov dptr,#pen_decode_slow

bl5:
    
    jnb acc.4,bl6           ; gripper switch down
    clr grip_press          ; no
    jmp bl7
bl6:    
    jb   grip_press,bl7     ; yes, but it was last time as well
    setb grip_press         ; mark pressed, for next time
    mov a,despos_grip       ; toggle the gripper
    cpl acc.4
    mov despos_grip,a
    
bl7:
    anl a,#15 
    rl  a
    jmp @a+dptr             ; will return to bl2
bl2:
    
    mov   a,stallflags      ; any axis jammed?
    jz    BASELOOP

    mov  stallflags_ibm,a   ; tell ibm which axes are jammed
    mov  stallflags,#0      ; re-enable servo
                            ; want to be able to use pendant to back off
    setb jammed             ; tell IBM

emer_stop:
    setb  enable_pen
    setb stop0
    setb stop1
    setb stop2
    JMP BASELOOP



pen_decode:
    ajmp pen_0m         ;0
    ajmp pen_0p         ;1
    ajmp pen_1m         ;2
    ajmp pen_1p         ;3
    ajmp pen_2m         ;4
    ajmp pen_2p         ;5
    ajmp pen_Zm         ;6
    ajmp pen_Zp         ;7
    ajmp bl2            ;8
    ajmp bl2            ;9
    ajmp bl2            ;10     
    ajmp pen_runin      ;11
    ajmp bl2            ;12
    ajmp bl2            ;13
    ajmp bl2            ;14
    ajmp pen_end        ;15


pen_decode_slow:
    ajmp pen_0m_slow    ;0
    ajmp pen_0p_slow    ;1
    ajmp pen_1m_slow    ;2
    ajmp pen_1p_slow    ;3
    ajmp pen_2m_slow    ;4
    ajmp pen_2p_slow    ;5
    ajmp pen_Zm         ;6
    ajmp pen_Zp         ;7
    ajmp bl2            ;8
    ajmp bl2            ;9
    ajmp bl2            ;10     
    ajmp pen_runin      ;11
    ajmp bl2            ;12
    ajmp bl2            ;13
    ajmp bl2            ;14
    ajmp pen_end        ;15



master_decode:                   ; jump table for IBM intructions
    ajmp bl0                     ; 0 - unused
    ajmp nojams                  ; 2 - turn arm jam off
    ajmp jams                    ; 4 - turn arm jams back on
    ajmp nopen                   ; 6 - turn pendant off
    ajmp emer_stop               ; 8 
    ajmp jog_0m                  ; 10 - move axis 0 towards 0   
    ajmp jog_0p                  ; 12
    ajmp jog_1m                  ; 14 - move axis 1 towards 0   
    ajmp jog_1p                  ; 16
    ajmp jog_2m                  ; 18 - move axis 2 towards 0   
    ajmp jog_2p                  ; 20
    ajmp jog_Zm                  ; 22 - move axis 3 towards 0   
    ajmp jog_Zp                  ; 24
    ajmp jog_5m                  ; 26 - open gripper
    ajmp jog_5p                  ; 28 - close gripper
    ajmp jog_sm                  ; 30 - Speed -ve 
    ajmp jog_sp                  ; 32 - Speed +ve  
    
    ajmp jog_end                 ; 34
    ajmp jog_end                 ; 36
    ajmp jog_end                 ; 38
    ajmp jog_end                 ; 40
    ajmp jog_end                 ; 42
    ajmp jog_end                 ; 44
    
    ajmp jog_end                 ; 46 - end of jog, re-enable pendant
    ajmp jog_end                 ; 48
    ajmp jog_clearjam            ; 50
    ajmp jog_home                ; 52
    ajmp jog_reset               ; 54

nopen:
    clr enable_pen
    ajmp bl0

nojams:
    clr  enable_jam
    ajmp bl0

jams:
    setb enable_jam
    ajmp bl0

jog_clearjam:
    clr jammed                  ; clear arm jammed flag
    mov stallflags,#0
    ajmp bl0



jog_end:
    setb enable_pen
    setb stop0
    setb stop1
    setb stop2

    jnb pen0,jog_end1
    setb stop0                      ; get timer to clear pen0
    clr  pen0
jog_end1:
    jnb pen1,jog_end2
    setb stop1                      ; get timer to clear pen1
    clr  pen1
jog_end2:
    jnb pen2,jog_end5
    setb stop2                      ; get timer to clear pen2
    clr  pen2
jog_end5:
    ajmp bl0
    

jog_home:
jog_reset:

    jmp bl0


jog_0m:
    clr enable_pen
    mov despos0  , #low 1024
    mov despos0+1, #high 1024
    setb pen0
    ajmp bl0
pen_0m_slow:
    setb pen0_slow
pen_0m:
    mov despos0  , #low 1024
    mov despos0+1, #high 1024
    setb pen0
    ajmp bl2


jog_0p:
    clr enable_pen
    mov despos0  , #low 7624       ; 6600 + 1024 
    mov despos0+1, #high 7624
    setb pen0
    ajmp bl0
pen_0p_slow:
    setb pen0_slow
pen_0p:
    mov despos0  , #low 7624       ; 6600 + 1024 
    mov despos0+1, #high 7624
    setb pen0
    ajmp bl2


jog_1m:
    clr enable_pen
    mov despos1  , #low 1024
    mov despos1+1, #high 1024
    setb pen1
    ajmp bl0
pen_1m_slow:
    setb pen1_slow
pen_1m:
    mov despos1  , #low 1024
    mov despos1+1, #high 1024
    setb pen1
    ajmp bl2

jog_1p:
    clr enable_pen
    mov despos1  , #low 8924        ; 7900 + 1024
    mov despos1+1, #high 8924
    setb pen1
    ajmp bl0
pen_1p_slow:
    setb pen1_slow
pen_1p:
    mov despos1  , #low 8924        ; 7900 + 1024
    mov despos1+1, #high 8924
    setb pen1
    ajmp bl2


jog_2m:
    clr enable_pen
    mov despos2  , #low 1024
    mov despos2+1, #high 1024
    setb pen2
    ajmp bl0
pen_2m_slow:
    setb pen2_slow
pen_2m:
    mov despos2  , #low 1024
    mov despos2+1, #high 1024
    setb pen2
    ajmp bl2


jog_2p:
    clr enable_pen
    mov despos2  , #low 2274       ; 1250 + 1024 
    mov despos2+1, #high 2274
    setb pen2
    ajmp bl0
    
pen_2p_slow:
    setb pen2_slow
pen_2p:
    mov despos2  , #low 2274       ; 1250 + 1024 
    mov despos2+1, #high 2274
    setb pen2
    ajmp bl2 


jog_Zm:
    clr enable_pen
pen_Zm:
    mov a,despos_grip   
    clr  acc.5 
    Setb acc.6
    mov despos_grip,a
    ajmp bl2 

jog_Zp:
    clr enable_pen
pen_Zp:
    mov a,despos_grip   
    clr  acc.6 
    Setb acc.5
    mov despos_grip,a
    ajmp bl2 


jog_5m:
    mov a,despos_grip   
    clr acc.4               ; Clear gripper bit
    mov despos_grip,a
    ajmp bl2 

jog_5p:
    mov a,despos_grip   
    Setb acc.4              ; Set gripper bit
    mov despos_grip,a
    ajmp bl2 


jog_sm:
    mov a,despos_speed
    jz  sm_1
    dec a
sm_1:    
    mov despos_speed,a
    ajmp bl0

jog_sp:
    mov a,despos_speed
    cjne a,#3,sp_1
    ajmp bl0
sp_1:    
    inc a
    mov despos_speed,a
    ajmp bl0






pen_end:
    jnb pen0,pen_end1
    setb stop0                      ; get timer to clear pen0

pen_end1:
    jnb pen1,pen_end2
    setb stop1                      ; get timer to clear pen1

pen_end2:
    jnb pen2,pen_end5
    setb stop2                      ; get timer to clear pen2

pen_end5:
    ajmp bl2




pen_runin:
    
    clr a 
    mov r0,#runcnt
    
pen_clear:    
    mov @r0,a
    inc r0
    cjne r0,#stallcnt2 + 1,pen_clear


    mov seqptr  ,#low runseq        ; set pointer to start of sequence
    mov seqptr+1,#high runseq
    mov seqcnt,#1
    mov seqcnt+1,#1

    ajmp pen_run2                   ; send first line
    

pen_run0:    
    mov  a,mcntrl
    jz   pen_run1
    ajmp baseloop       ; return to baseloop
    
pen_run1:
    mov stallflags,#0   ; reset jammed axes

    mov a,inpos
    anl a,#0111B
    cjne a,#0111B,pen_run4
                         ;arm inposition, set up new data

pen_run2:
    djnz seqcnt  ,pen_run4
    djnz seqcnt+1,pen_run4

    mov seqcnt+1,#16
    
    mov dpl,seqptr
    mov dph,seqptr+1
    mov r0,#despos_speed

    clr  a
    movc a,@a+dptr
    inc  dptr
    jnz  pen_run3

    mov r0,#runcnt
    inc @r0
    mov a,@r0
    jnz pen_run2a
    
    inc r0
    inc @r0
    mov a,@r0
    jnz pen_run2a
    
    jmp baseloop

pen_run2a:    
    mov seqptr  ,#low runseq    ;at end of sequence point back to start
    mov seqptr+1,#high runseq
    ajmp pen_run2


pen_run3:
    clr a
    movc a,@a+dptr
    mov @r0,a
    inc dptr            ; inc pointer to source
    dec r0              ; dec pointer to dest
    mov a,r0
    cjne a,#despos0-1,pen_run3

    mov seqptr,dpl
    mov seqptr+1,dph

pen_run4:
;    acall servoarm
;    lcall testjams_noread
    ajmp pen_run0



setmaxerror:
    mov a,despos_speed
    mov encpos_speed,a
    ret




;update_posn:
;    mov dptr,#Slave0
;    
;    movx @dptr,a        ; Request data from encoder slave


update_posn:    
    mov dptr,#Slave0
    
    jb p3.3,$           ; wait for slave to respond
    movx a,@dptr        ; Read data from slave
    
    mov change,a
    jb acc.7,neg_change
    
    add a,@r0
    mov @r0,a
    jnc nomodmsb

    inc r0              ; Increment pointer, to point to msb
    inc @r0             ; increment msb
    ajmp nomodmsb

neg_change:
    cpl a
    inc a
    mov change,a
    xch a,@r0
    clr c
    subb a,@r0
    mov @r0,a
    
    inc r0
    mov a,@r0
    subb a,#0
    mov @r0,a

nomodmsb:

    ret






home:
    clr servo_enable0
    clr servo_enable1
    clr servo_enable2
    
    setb zeroing            ; show IBM we're zeroing
    clr ibm_mode

    Clr  a                  ; Z axis Up, Gripper open
    Setb acc.5
    mov  despos_grip,a

home_0:
    mov a,mcntrl
    jz home_01
    mov mcntrl,#0
    setb ibm_mode
    
    mov dptr,#home_decode
    jmp @a+dptr             ; will return to home_02 or home_0

home_02:
    clr ibm_mode
     
home_01:
    jb ibm_mode,home_0


    mov dptr,#0ce00h
    movx a,@dptr


home_01a:    
    

home_1:    
    anl a,#63
    mov pen_copy,a
    
    anl a,#15
    rl a    
    mov dptr,#hometab
    jmp @a+dptr
hometab:
    ajmp home_0m    ;0
    ajmp home_0p    ;1
    ajmp home_1m    ;2
    ajmp home_1p    ;3
    ajmp home_2m    ;4
    ajmp home_2p    ;5
    ajmp home_null  ;6
    ajmp home_null  ;7
    ajmp home_null  ;8
    ajmp home_null  ;9
    ajmp home_end   ;10 
    ajmp home_null  ;11
    ajmp home_null  ;12
    ajmp home_null  ;13
    ajmp home_null  ;14
    ajmp home_null  ;15
    
home_0p:    
    setb dir0
    setb pen0
    jmp  home_0

home_1p:    
    setb dir1
    setb pen1
    jmp  home_0

home_2p:
    setb dir2
    setb pen2
    jmp home_0


home_0m:    
    clr  dir0
    Setb pen0
    jmp  home_0

home_1m:    
    clr  dir1
    setb pen1
    jmp  home_0

home_2m:
    clr  dir2
    setb pen2
    jmp  home_0


home_null:    
    clr a
    clr pen0
    clr pen1
    clr pen2
    clr  stalled0
    clr  stalled1
    clr  stalled2
    jmp home_0


home_end:
    mov a,pen_copy
    jb acc.4,home_null
    jb acc.5,home_null

home_end_ibm0:

; send control byte to send each axis to its endstop - wait til stalled
    
    
    setb enable_jam             ; arm jams need to be recognised
    mov  stallflags,#0

    acall home_0_m
    acall home_1_m
    jmp home_wrist
    
    


home_end_ibm1:
; send control byte to send each axis to its endstop - wait til stalled
    
    
    setb enable_jam             ; arm jams need to be recognised
    mov  stallflags,#0

    acall home_0_p
    acall home_1_m
    jmp home_wrist


home_end_ibm2:

; send control byte to send each axis to its endstop - wait til stalled
    
    
    setb enable_jam             ; arm jams need to be recognised
    mov  stallflags,#0

    acall home_0_m
    acall home_1_p
    jmp home_wrist


home_end_ibm3:
; send control byte to send each axis to its endstop - wait til stalled
    
    
    setb enable_jam             ; arm jams need to be recognised
    mov  stallflags,#0

    acall home_0_p
    acall home_1_p
    jmp home_wrist


    
home_wrist:    
    clr  stalled2
    setb pen2           ; move axis 2 to 0
    clr  dir2
    jnb  stalled2,$     ; wait til stalled
    clr  pen2
    
    mov  despos2  , #low 1024
    mov  despos2+1, #high 1024
    
    mov  encpos2  , #low 1000
    mov  encpos2+1, #high 1000
    
    clr  stalled2
    setb servo_enable2
    
    clr zeroing             ; show IBM we're ready

    ret


home_0_m:
    clr  stalled0
    setb pen0           ; move axis 0 to 0
    clr  dir0

    jnb  stalled0,$     ; wait til stalled

    clr  pen0
    
    mov  despos0  , #low 1024
    mov  despos0+1, #high 1024
    
    mov  encpos0  , #low 1000
    mov  encpos0+1, #high 1000
    
    clr  stalled0
    setb servo_enable0
    ret

home_0_p:    
    clr  stalled0
    setb pen0           ; move axis 0 to max
    setb dir0
    jnb  stalled0,$     ; wait til stalled
    clr  pen0
    
    mov  despos0  , #low 7624       ;6600+1024
    mov  despos0+1, #high 7624
    
    mov  encpos0  , #low 7648
    mov  encpos0+1, #high 7648
    
    clr  stalled0
    setb servo_enable0
    ret

home_1_m:    
    clr  stalled1
    setb pen1           ; move axis 1 to 0
    clr  dir1
    jnb  stalled1,$     ; wait til stalled
    clr  pen1
    
    mov  despos1  , #low 1024
    mov  despos1+1, #high 1024
    
    mov  encpos1  , #low 1000
    mov  encpos1+1, #high 1000
    
    clr  stalled1
    setb servo_enable1
    ret

home_1_p:    
    clr  stalled1
    setb pen1           ; move axis 1 to max
    setb dir1
    jnb  stalled1,$     ; wait til stalled
    clr  pen1
    
    mov  despos1  , #low 8924       ;7900+1024
    mov  despos1+1, #high 8924
    
    mov  encpos1  , #low 8948
    mov  encpos1+1, #high 8948
    
    clr  stalled1
    setb servo_enable1
    ret



home_nojams:
    clr enable_jam
    ajmp home_02

home_jams:
    setb enable_jam
    ajmp home_02

home_decode:
    ajmp home_02        ; 0 - unused
    ajmp home_nojams    ; 2 - turn arm jam off
    ajmp home_jams      ; 4 - turn arm jams back on
    ajmp home_02        ; 6 - unused
    ajmp home_02        ; 8 - unused
                        
    ajmp home_0m        ; 10 - move axis 0 towards 0   
    ajmp home_0p        ; 12
    ajmp home_1m        ; 14 - move axis 1 towards 0   
    ajmp home_1p        ; 16
    ajmp home_2m        ; 18 - move axis 2 towards 0   
    ajmp home_2p        ; 20
    
    ajmp home_02        ; 22 - move axis 3 towards 0   
    ajmp home_02        ; 24
    ajmp home_02        ; 26 - move axis 4 towards 0   
    ajmp home_02        ; 28
    ajmp home_02        ; 30 - open gripper  
    ajmp home_02        ; 32
    ajmp home_02        ; 34 - move axes 3 and 4 towards 0   
    ajmp home_02        ; 36
    ajmp home_02        ; 38 - move axes 3 towards 0  4 +ve 
    ajmp home_02        ; 40
    ajmp home_02        ; 42 - Speed -ve
    ajmp home_02        ; 44 - Speed +ve  
    
    ajmp home_02        ; 46 - cancel ibm_mode   
    
    
    ajmp home_end_ibm0  ; 48 - finish it off
    ajmp home_end_ibm1  ; 50
    ajmp home_end_ibm2  ; 52
    ajmp home_end_ibm3  ; 54



include ibmint.inc              ; External interrupt 0 service
include adc.inc

timer0:    
    mov th0,#252            ;250

    PUSH PSW
    PUSH ACC
    push dph
    push dpl

    mov psw,#00010000b      ; register set 2
    
    
    mov   a,Servoaxis    
    jnz   t0_0
    
    lcall servo0
    jnb  hammer0,ts0_0
    djnz htim0,ts0_3    
    mov  htim0,#5
    
    mov  control0,#0
    djnz hcnt0,ts0_3
    mov  hcnt0,#10
    mov  control0,#31
    jmp  ts0_3
ts0_0:   
    mov  hcnt0,#50      ; Reset hammer
    mov  htim0,#5       ; counters
    
    mov  a,cntrl0       
    cjne a,control0,ts0_1
    mov  more0,#10
    jmp  ts0_3
ts0_1:    
    jc  ts0_2           ; want less send now
    djnz more0,ts0_3
    mov  more0,#10
    inc  control0       ; want more ramp up
    jmp  ts0_3

ts0_2:
    mov  control0,a
ts0_3:
    mov   Servoaxis,#1
    mov   a,#2           ; Request data for axis 1
    jmp   t0_2


t0_0:
    cjne  a,#1,t0_1
    lcall servo1
    jnb  hammer1,ts1_0
    djnz htim1,ts1_3    
    mov  htim1,#5

    mov  control1,#0
    djnz hcnt1,ts1_3
    mov  hcnt1,#10
    mov  control1,#31
    jmp  ts1_3
ts1_0:   
    mov  hcnt1,#50      ; Reset hammer
    mov  htim1,#5       ; counters


    mov  a,cntrl1       
    cjne a,control1,ts1_1
    mov  more1,#10
    jmp  ts1_3
ts1_1:    
    jc  ts1_2           ; want less send now
    djnz more1,ts1_3
    mov  more1,#10
    inc  control1       ; want more ramp up
    jmp  ts1_3

ts1_2:
    mov  control1,a
ts1_3:


    mov   Servoaxis,#2
    mov   a,#4           ; Request data for axis 2
    jmp   t0_2
    

t0_1:
    lcall servo2
    jnb  hammer2,ts2_0
    djnz htim2,ts2_3    
    mov  htim2,#5

    mov  control2,#0
    djnz hcnt2,ts2_3
    mov  hcnt2,#10
    mov  control2,#7
    jmp  ts2_3
ts2_0:   
    mov  hcnt2,#50      ; Reset hammer
    mov  htim2,#5       ; counters


    mov  a,cntrl2       
    cjne a,control2,ts2_1
    mov  more2,#10
    jmp  ts2_3
ts2_1:    
    jc  ts2_2           ; want less send now
    djnz more2,ts2_3
    mov  more2,#10
    inc  control2       ; want more ramp up
    jmp  ts2_3
ts2_2:
    mov  control2,a
ts2_3:


;    mov  a,control2
;    jnb  Dir2,deb1
;    add  a,#100
;deb1:
    
;    mov   a,stall2
;    jnb   ti,$
;    clr   ti
;    mov   sbuf,a 



    mov   Servoaxis,#0
    clr   a              ; Request data for axis 0
    
t0_2:
    mov  dptr,#Slave0    ; Write request
    movx @dptr,a         ; to Encoder slave   

    
    
    
    
    mov dptr,#pwm_12
;Upper 3 bits = wrist (control2)
;Lower 5 bits = Elbow (control1)
    mov a,control2
    rl a
    rl a
    rl a
    rl a
    rl a
    anl a,#11100000b

    orl a,control1
    movx @dptr,a
    
    
    mov dptr,#pwm_0
    mov a,control0
    movx @dptr,a
    
    mov dptr,#pwm_dir
    mov a,axesdir
    movx @dptr,a
    
    pop dpl
    pop dph
    POP ACC
    POP PSW
    reti



TIMER1:
    ;mov th1,#88          ; 6 times slower than timer0    
                         ; to compensate for * 6 on encoders   
    
    
    PUSH PSW
    PUSH ACC
    push dph
    push dpl

    mov psw,#00010000b      ; register set 2

;    cpl servo_23
;    
;    jb  servo_23,t1_1
;
;    lcall servo2 
;    jmp t1_2
;t1_1:
;    lcall servo3
;t1_2:

    
    
    lcall TestPower
    lcall servo3
    
    pop dpl
    pop dph
    POP ACC
    POP PSW

    reti


TestPower:    
    mov dptr,#0ca00h        ; power byte
    movx a,@dptr
    jb  acc.0,tp_1         ; Motor power on? (1=Nose Lead)
    jnb acc.1,tp_1         ; Solenoid power on?
    setb Power
    Ret
tp_1:
    Clr Power
    Ret





servo0:        
    clr  hammer0    
    clr  axis0_inpos       ; assume not in position
    clr  axis0_Reallyinpos       ; assume not in position
    
    clr   a 
    mov   r0,#encpos0      ; point to data to change
    lcall update_posn

    mov a,change
    jnz SV0_0a
    inc nomove0
    jmp SV0_0b
SV0_0a:
    mov nomove0,#0
SV0_0b:

    
    jb    power,SV0_0
    
    mov  cntrl0,#0
    mov  stall0,#0
    
    clr  stop0                 ; axis is stopped  
    clr  pen0
    clr  pen0_slow
    Ret

SV0_0:
    jb stalled0,SV0_1       ; Axis is already stalled, ignore servoing
    
    mov  a,cntrl0           ; Sending zero?
    mov  cntrl0,#0
    cjne a,#2,$+3
    jc   SV0_2              ; Yes, don't test for movement
    
    
    mov  a,change           ; Any movement?
    jnz  SV0_2
    
    inc  stall0             ; No, count times power sent
    mov  a,stall0           ; without moving
    jnz  SV0_3              ; axis takes 100 to get moving

    setb stalled0           ; too many, arm is jammed

SV0_1:    
    Ret

    
SV0_2:    
    mov stall0,#0
SV0_3:
    
    jb    servo_enable0,SV0_5   
    
    jnb   pen0,SV0_4       
    
    jmp   S0_speed4

SV0_4:    
    Ret                         ; zero pendant mode, button not pressed

SV0_5:    
    jnb   stop0,SV0_7            ; teach mode wants axis stopped 
    
    mov   a,nomove0
    cjne  a,#20,SV0_6
    
    clr   stop0                 ; axis is stopped  
    clr   pen0
    clr   pen0_slow
    mov   despos0  ,encpos0   
    mov   despos0+1,encpos0+1

SV0_6:    
    Ret


SV0_7:
    
    
    clr  c
    mov  a,despos0
    subb a,encpos0
    mov  r6,a           ; LSB error
    
    mov  a,despos0+1
    subb a,encpos0+1
    mov  r7,a           ; MSB error
    
    jnc  SV0_9
    
    jnb  dir0,SV0_8
    clr  dir0           ; change of direction
    mov  rest0,#25      ; don't send new info for a while
    Ret

SV0_8:
    clr  c
    mov  a,encpos0
    subb a,despos0
    mov  r6,a           ; absolute LSB error
    
    mov  a,encpos0+1
    subb a,despos0+1
    mov  r7,a           ; absolute MSB error
    
    
    
    
    jmp  SV0_10

SV0_9:
    jb   dir0,SV0_10      ; c=0
    setb dir0           ; change of direction
    mov  rest0,#25     ; don't send new info for a while
    Ret

SV0_10:
    
    
;r7 r6 = absolute error    
    mov a,r7
    jnz  SV0_14
;Error less than 256 bits     
    
    
    mov a,r6
    cjne a,#4,$+3     ;c=1 if error<
    jc   s0_speed0
    
    jnb  pen0_slow,SV0_11
    setb hammer0                ; teach mode hammering
    ret

SV0_11:
    
    jnb  dir0,SV0_12    
    
    cjne a,#40,$+3    ;Travel towards 6000
    jc   s0_hammer
    
    
    cjne a,#60,$+3    
    jc   s0_speed1

    cjne a,#80,$+3    ;c=1 if error<
    jc   s0_speed2
    
    
    jmp  SV0_13

SV0_12:
    
    cjne a,#40,$+3    ;Travel towards 0
    jc   s0_hammer
    
    cjne a,#60,$+3    
    jc   s0_speed1

    cjne a,#90,$+3    ;c=1 if error<
    jc   s0_speed2


SV0_13:    
    
    
    cjne a,#160,$+3    ;c=1 if error<
    jc   s0_speed3

    jmp  s0_speed4


SV0_14:

    jnb  pen0_slow,SV0_15
    setb hammer0                ; teach mode hammering
    ret

SV0_15:


    cjne a,#2,$+3   
    jc   s0_speed4

    cjne a,#3,$+3   
    jc   s0_speed5
    
    cjne a,#4,$+3 
    jc   s0_speed6

    jmp  s0_speed7


s0_speed0:
    setb axis0_inpos     
    setb axis0_Reallyinpos
    Ret

s0_hammer:
    setb hammer0
    setb axis0_inpos     
    setb axis0_Reallyinpos
    Ret

s0_speed1:
    mov  cntrl0,#1      ;Slowest speed
    setb axis0_inpos
    ret             
                    

s0_speed2:
    mov  cntrl0,#2
    setb axis0_inpos
    ret

s0_speed3:
    mov  cntrl0,#3
    ret

s0_speed4:
    mov  cntrl0,#6
    ret

s0_speed5:
    mov a,despos_speed
    jz  s0_speed4
    mov cntrl0,#12
    ret

s0_speed6:
    mov  a,despos_speed
    cjne a,#2,$+3
    jc   s0_speed5
    mov  cntrl0,#20
    ret

s0_speed7:
    mov a,despos_speed
    cjne a,#3,s0_speed6

    mov  cntrl0,#31      ;Full speed
    ret



servo1:
    clr  hammer1    
    clr  axis1_inpos       ; assume not in position
    clr  axis1_Reallyinpos       ; assume not in position
    
    mov   a,#2
    mov   r0,#encpos1      ; point to data to change
    lcall update_posn
    
    mov a,change
    jnz SV1_0a
    inc nomove1
    jmp SV1_0b
SV1_0a:
    mov nomove1,#0
SV1_0b:

    
    jb    power,SV1_0
    
    mov  cntrl1,#0
    mov  stall1,#0
    
    clr  stop1                 ; axis is stopped  
    clr  pen1
    clr  pen1_slow
    Ret

SV1_0:
    jb stalled1,SV1_1
    
;    mov  a,cntrl1
;    mov  cntrl1,#0
;    jz   SV1_2

    mov  a,cntrl1           ; Sending zero?
    mov  cntrl1,#0
    cjne a,#2,$+3
    jc   SV1_2              ; Yes, don't test for movement

    
    
    mov a,change
    jnz  SV1_2
    
    inc stall1              ; count times power sent
    mov a,stall1            ; without axis moving
    jnz SV1_3

    setb stalled1           ; too many, arm is jammed

SV1_1:    
    Ret

    
SV1_2:    
    mov stall1,#0
SV1_3:
    
    jb    servo_enable1,SV1_5   
    
    jnb   pen1,SV1_4       
    
    jmp   S1_speed4

SV1_4:    
    Ret                         ; zero pendant mode, button not pressed

SV1_5:    
    jnb   stop1,SV1_7            ; teach mode wants axis stopped 
    
    mov   a,nomove1
    cjne  a,#20,SV1_6
    
    
    clr   stop1                 ; axis is stopped  
    clr   pen1
    clr   pen1_slow
    mov   despos1  ,encpos1   
    mov   despos1+1,encpos1+1

SV1_6:    
    Ret


SV1_7:
    clr  c
    mov  a,despos1
    subb a,encpos1
    mov  r6,a           ; LSB error
    
    mov  a,despos1+1
    subb a,encpos1+1
    mov  r7,a           ; MSB error
    
    jnc  SV1_9
    
    jnb  dir1,SV1_8
    clr  dir1           ; change of direction
    mov  rest1,#25      ; don't send new info for a while
    Ret

SV1_8:
    clr  c
    mov  a,encpos1
    subb a,despos1
    mov  r6,a           ; absolute LSB error
    
    mov  a,encpos1+1
    subb a,despos1+1
    mov  r7,a           ; absolute MSB error
    
    
    
    
    jmp  SV1_10

SV1_9:
    jb   dir1,SV1_10      ; c=0
    setb dir1           ; change of direction
    mov  rest1,#25     ; don't send new info for a while
    Ret

SV1_10:
    
    
;r7 r6 = absolute error    
    mov a,r7
    jnz  SV1_14
;Error less than 256 bits     
    
    
    mov a,r6
    cjne a,#4,$+3     ;c=1 if error<
    jc   s1_speed0
    
    jnb  pen1_slow,SV1_11
    setb hammer1                ; teach mode hammering
    ret

SV1_11:
    
    jnb  dir1,SV1_12    
    
    cjne a,#45,$+3    ;c=1 if error<
    jc   s1_hammer
    
    
    cjne a,#55,$+3    ;c=1 if error<
    jc   s1_speed1
    jmp  SV1_13

SV1_12:
    
    cjne a,#55,$+3    ;Travel towards 0
    jc   s1_hammer
    
    cjne a,#80,$+3    
    jc   s1_speed1

SV1_13:    
    
    cjne a,#90,$+3    ;c=1 if error<
    jc   s1_speed2
    
    cjne a,#160,$+3    ;c=1 if error<
    jc   s1_speed3

    jmp  s1_speed4


SV1_14:

    jnb  pen1_slow,SV1_15
    setb hammer1                ; teach mode hammering
    ret

SV1_15:


    cjne a,#2,$+3   
    jc   s1_speed4

    cjne a,#3,$+3   
    jc   s1_speed5
    
    cjne a,#4,$+3 
    jc   s1_speed6

    jmp  s1_speed7


s1_speed0:
    setb axis1_inpos     
    setb axis1_Reallyinpos
    Ret

s1_hammer:
    setb hammer1
    setb axis1_inpos     
    setb axis1_Reallyinpos
    Ret

s1_speed1:
    mov  cntrl1,#1      ;Slowest speed
    setb axis1_inpos
    ret                 

s1_speed2:
    mov  cntrl1,#2
    setb axis1_inpos
    ret

s1_speed3:
    mov  cntrl1,#3
    ret

s1_speed4:
    mov  cntrl1,#6
    ret

s1_speed5:
    mov a,despos_speed
    jz  s1_speed4
    mov cntrl1,#12
    ret

s1_speed6:
    mov  a,despos_speed
    cjne a,#2,$+3
    jc   s1_speed5
    mov  cntrl1,#20
    ret

s1_speed7:
    mov a,despos_speed
    cjne a,#3,s1_speed6
    mov  cntrl1,#31      ;Full speed
    ret







servo2:        
    clr  hammer2    
    clr  axis2_inpos       ; assume not in position
    clr  axis2_Reallyinpos       ; assume not in position
    
    mov   a,#4
    mov   r0,#encpos2      ; point to data to change
    lcall update_posn

    mov a,change
    jnz SV2_0a
    inc nomove2
    jmp SV2_0b
SV2_0a:
    mov nomove2,#0
SV2_0b:

    
    jb    power,SV2_0
    
    mov  cntrl2,#0
    mov  stall2,#0
    
    clr  stop2                 ; axis is stopped  
    clr  pen2
    clr  pen2_slow
    Ret

SV2_0:
    jb stalled2,SV2_1
    
;    mov  a,cntrl2
;    mov  cntrl2,#0
;    jz   SV2_2

    mov  a,cntrl2           ; Sending zero?
    mov  cntrl2,#0
    cjne a,#2,$+3
    jc   SV2_2              ; Yes, don't test for movement

    
    
    mov a,change
    jnz SV2_2
    
    inc stall2              ; count times power sent
    mov a,stall2            ; without axis moving
    jnz SV2_3

    setb stalled2           ; too many, arm is jammed

SV2_1:    
    Ret

    
SV2_2:    
    mov stall2,#0
SV2_3:
    
    jb    servo_enable2,SV2_5   
    
    jnb   pen2,SV2_4       
    
    jmp   S2_speed4

SV2_4:    
    Ret                         ; zero pendant mode, button not pressed

SV2_5:    
    jnb   stop2,SV2_7            ; teach mode wants axis stopped 
    
    mov   a,nomove2
    cjne  a,#20,SV2_6
    
    clr   stop2                 ; axis is stopped  
    clr   pen2
    clr   pen2_slow
    mov   despos2  ,encpos2   
    mov   despos2+1,encpos2+1

SV2_6:    
    Ret


SV2_7:
    clr  c
    mov  a,despos2
    subb a,encpos2
    mov  r6,a           ; LSB error
    
    mov  a,despos2+1
    subb a,encpos2+1
    mov  r7,a           ; MSB error
    
    jnc  SV2_9
    
    jnb  dir2,SV2_8
    clr  dir2           ; change of direction
    mov  rest2,#25      ; don't send new info for a while
    Ret

SV2_8:
    clr  c
    mov  a,encpos2
    subb a,despos2
    mov  r6,a           ; absolute LSB error
    
    mov  a,encpos2+1
    subb a,despos2+1
    mov  r7,a           ; absolute MSB error
    
    
    
    
    jmp  SV2_10

SV2_9:
    jb   dir2,SV2_10      ; c=0
    setb dir2           ; change of direction
    mov  rest2,#25     ; don't send new info for a while
    Ret

SV2_10:
    
    
;r7 r6 = absolute error    
    mov a,r7
    jnz  SV2_14
;Error less than 256 bits     
    
    
    mov a,r6
    cjne a,#4,$+3     ;c=1 if error<
    jc   s2_speed0
    
    jnb  pen2_slow,SV2_11
    setb hammer2                ; teach mode hammering
    ret

SV2_11:
    
    jnb  dir2,SV2_12    
    
    cjne a,#15,$+3    ;c=1 if error<
    jc   s2_hammer
    
    
    cjne a,#35,$+3    ;c=1 if error<
    jc   s2_speed1
    jmp  SV2_13

SV2_12:
    
    cjne a,#15,$+3    ;c=1 if error<
    jc   s2_hammer
    
    cjne a,#35,$+3    ;c=1 if error<
    jc   s2_speed1

SV2_13:    
    
    cjne a,#80,$+3    ;c=1 if error<
    jc   s2_speed2
    
    cjne a,#160,$+3    ;c=1 if error<
    jc   s2_speed3

    jmp  s2_speed4


SV2_14:

    jnb  pen2_slow,SV2_15
    setb hammer2                ; teach mode hammering
    ret

SV2_15:


    cjne a,#2,$+3   
    jc   s2_speed4

    cjne a,#3,$+3   
    jc   s2_speed5
    
    cjne a,#4,$+3 
    jc   s2_speed6

    jmp  s2_speed7


s2_speed0:
    setb axis2_inpos     
    setb axis2_Reallyinpos
    Ret

s2_hammer:
    setb hammer2
    setb axis2_inpos     
    setb axis2_Reallyinpos
    Ret

s2_speed1:
    mov  cntrl2,#1      ;Slowest speed
    setb axis2_inpos
    ret                 

s2_speed2:
    mov  cntrl2,#2
    setb axis2_inpos
    ret

s2_speed3:
    mov  cntrl2,#3
    ret

s2_speed4:
    mov  cntrl2,#4
    ret


s2_speed5:
    mov a,despos_speed
    jz  s2_speed4
    mov cntrl2,#5
    ret

s2_speed6:
    mov  a,despos_speed
    cjne a,#2,$+3
    jc   s2_speed5
    mov  cntrl2,#6
    ret

s2_speed7:
    mov a,despos_speed
    cjne a,#3,s2_speed6
    mov  cntrl2,#7      ;Full speed
    ret





Servo3:

; Zdown instruction only sent when really inposition
; Zup instruction sent straight away
; Gripper set at same time as Z
    
    Clr  axis3_inpos    ; assume not inpos
    jnb  power,s3_2
    
    jnb Zup,s3_2       ; already down?     

    mov a,despos_grip  
    jb  acc.5,s3_2     ; jump if want to go up
    

    jnb axis0_reallyinpos,s3_1
    jnb axis1_reallyinpos,s3_1
    jnb axis2_reallyinpos,s3_1
    jmp s3_2            ; arm is inposition, allow to come down

s3_1:
    ret



s3_2:
    mov  a,despos_grip
    mov  C,acc.5            ; acc.5 = 1 if Z will be up
    mov  Zup,C
    
    cjne a,encpos_grip,s3_3
    jmp  s3_4                   ; are same

s3_3:
    
    mov  a,rest3             ; Set time out period
    jz   s3_5
    
    djnz rest3,s3_6          ; Count down to pneumatic inpos
    mov  a,despos_grip
    mov  encpos_grip,a

s3_4:    
    Setb axis3_inpos        ; Z is inposition
    jmp  s3_6


s3_5:    
    
    mov  rest3,#60          ; About 1.5 secs if Z has changed - was 120 29/8/95

    mov  a,despos_grip      ; Bits 5 and 6 are Z
    anl  a,#1100000b
    mov  tmp,a
    
    mov  a,EncPos_grip      ; Bits 5 and 6 are Z
    anl  a,#1100000b
    
    cjne a,tmp,s3_6
    mov  rest3,#20         ; About 1/2 sec only Grip has changed - was 40 29/8/95
    

s3_6:
    mov  dptr,#0ce00h       ; send gripper/Z data
    mov  a,despos_grip
    movx @dptr,a
    ret





TestMode:
    djnz r0,tm1
    mov  dptr,#workcell_o
    inc  wco_stat
    mov  a,wco_stat
    movx @dptr,a            

tm1:
    mov control0,#0
    mov control1,#0
    
    
    mov  dptr,#0ce00h        ; read pendant
    movx a,@dptr
    anl a,#15
    rl a    

    mov  dptr,#TestMode_decode
    jmp @a+dptr  


TestMode_decode:
    ajmp Testpen_0m         ;0
    ajmp Testpen_0p         ;1
    ajmp Testpen_1m         ;2
    ajmp Testpen_1p         ;3
    ajmp Testpen_2m         ;4
    ajmp Testpen_2p         ;5
    ajmp Testpen_end        ;6
    ajmp Testpen_end        ;7
    ajmp Testpen_end        ;8
    ajmp Testpen_end        ;9
    ajmp Testpen_end        ;10     
    ajmp Testpen_end        ;11
    ajmp Testpen_end        ;12
    ajmp Testpen_end        ;13
    ajmp Testpen_end        ;14
    ajmp Testpen_end        ;15


Testpen_0m:
    Clr dir0
    mov control0,#1
    Jmp Testpen_end
Testpen_0p:
    Setb dir0
    mov control0,#1
    Jmp Testpen_end

Testpen_1m:
    Clr dir1
    mov control1,#1
    Jmp Testpen_end
Testpen_1p:
    Setb dir1
    mov control1,#1
    Jmp Testpen_end

Testpen_2m:
    Clr dir2
    mov control1,#00100000b
    Jmp Testpen_end
Testpen_2p:
    Setb dir2
    mov control1,#00100000b
    Jmp Testpen_end


Testpen_end:

    mov dptr,#pwm_12
    mov a,control1
    movx @dptr,a
    
    mov dptr,#pwm_0
    mov a,control0
    movx @dptr,a
    
    mov dptr,#pwm_dir
    mov a,axesdir
    movx @dptr,a

    jmp  TestMode








include timer2.inc              ; Timer 2
include runin.inc

end
